      PROGRAM PHOENIX2
*
*  Version 2.0 extended to dipole alignment (not only dipole pairing)  
*  Newly derived formulas used 
*
*  /////////////////////  UNIX version - fall 1990  /////////////////
*
*  1/8/91 Proline residue treatment included
*
*  2/20/91 Continuation method implemented in evaluating the angles theta
*          Conservation of original virtual geometry included
*
*  May 1993 The segment GENPATH has been modified to perform automatic
*           construction of the dipole-path network, if requested.
*
*  6/28/93 Added the construction of files for the plotting of dipole-path
*          network.
*
      PARAMETER (NUNIT=5)
      include 'parcom.dat'
      LOGICAL OPTSH,OPTRE,FAIL,FAIL1,RDPATH,PRINTMAP,NOCALC,
     & CONTACTS_ONLY
      REAL KSI
      double precision alph0(MAXRES)
C     INTEGER*2 ITYPE,IREF,IPATH,NLEFT,ILEFT
      CHARACTER*4 INAMP
      character*2 name(30)
      integer czasy(8),czasy0(8)
      character*10 czas1, czas2,czas3
      double precision czas_c
      DIMENSION GAMAOLD(MAXRES),ROLD(MAXRES),THETA1(MAXRES),IA(5),
     1 THETA2(MAXRES),STEPKSI(MAXRES),STEPETA(MAXRES),STEPALPHA(MAXRES)
      INTEGER IUNIT(NUNIT)/1,2,7,8,3/,IRW(NUNIT)/1,4*0/,
     1 IOVRD(NUNIT)/0,0,3*1/,IT
      CHARACTER*8 STAT(NUNIT) /'OLD',4*'UNKNOWN'/
      CHARACTER*64 
     1        DUMFNM(NUNIT) /'phoenix.dat','phoenix.out','phoenix.ang',
     2        'phoenix.pdb','error.msg'/
      CHARACTER*16 FORMA(NUNIT) /5*'FORMATTED'/
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,OPTRE
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES),
     2 ROLD1(MAXRES)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PARAM/ NSTEP,MAXIT,TOL,STABFAC
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      COMMON /POCHODNE/ NX,NY
      common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      common /mapa/ pref
      common /it/ it
      character*16 pref
CRK
      call date_and_time(czas1,czas2,czas3,czasy0)
CRK
*
      CALL OPENUNITS(NUNIT,IUNIT,IRW,STAT,FORMA,IOVRD,DUMFNM)
*
* The following options can be entered either in the option string (after
* the "-" sign in the command line) or in input data:
*
* r or READ_PATHS - GENPATH will not construct the dipole-path network;
*                   they'll be read from the input file instead;
*
* nc or NO_CALC - the program will stop after GENPATH; it will not calculate
*                 the peptide-group rotation angles lambda;
*
* p or PRINT_CONTACT_MAP - GENPATH will construct files for plotting the
*                 electrostatic-contact map.
*
      INP=IUNIT(1)
      IOUT=IUNIT(2)
      IPUN=IUNIT(3)
      IERRO=IUNIT(5)
CRK      print *,'Program PHOENIX2 started'
************
*  Read data and set up internal coordinates table
cd    print *,'calling START'
      CALL START(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
cd    print *,'exit START'
      if (printmap) then
        ii=index(dumfnm(1),'.')
        pref=dumfnm(1)(1:ii-1)
      endif
cd    print *,'calling CART'
      CALL CART(FAIL)
cd    print *,'exit CART'
************
*  Construct or read hydrogen-bond topology (the dipole-path network)
cd    print *,'calling GENPATH'
CRK      CALL GENPATH(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
cd    print *,'exit GENPATH'
************
      CALL TRANSFER(NRES2,THETA,THETA1)
*       do i=1,nres1
*         i1=4*(i-1)+nres2+1
*         write (iout,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*         write (*   ,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*       enddo
*
      write(iout,'(a6,200f12.7)') 'ALPH= ',(alph(i),i=1,nres2)
*
c      print *,'CRK *********  NSTEP=',NSTEP
c      NSTEP=5
c      print *,'CRK *********  NSTEP=',NSTEP
*
      DO I=1,NRES1
        alph0(i)=alph(i)
        STEPKSI(I)=KSI(I)
        STEPETA(I)=ETA(I)
      ENDDO
      alph0(nres2)=alph(nres2)
      write(iout,'(a6,200f12.7)') 'ALPH0=',(alph(i),i=1,nres2)

CRK - dalej zmiany w ksi i eta
c      print *,' katy KSI i ETA',(ksi(i),eta(i),i=1,nres1)
c      DO I=1,NRES1
c        if(ipro(i).eq.0) then
c          KSI(I)=5.0d0*conv
c          ETA(I)=5.0d0*conv
c        endif
c      ENDDO
CRK      print *,' katy KSI i ETA',(ksi(i),eta(i),i=1,nres1)
CRK
crk      DO I=3,NRES2
crk        STEPALPHA(I)=(ALPH(I)-0.9d0*pi/2.0d0)/NSTEP
crk        ALPH(I)=0.9d0*pi/(2.0d0*conv)
crk        STEPALPHA(I)=(ALPH(I)-THETA(I))/NSTEP
crk        ALPH(I)=THETA(I)
crk      ENDDO 
      do i=1,nres1
        i1=4*(i-1)+nres2+1
        i2=i1+1
        d(i1,2)=0.0
        d(i2,2)=0.0
      enddo
*     DO ISTEP=1,NSTEP
* Change 5/14/92. Adaptive step length
      delta=1.0/nstep
      odcinek=0.0
      istep=0
      do while (odcinek.le.0.999999)
        ISTEP=ISTEP+1
        write (iout,*) 'ISTEP',ISTEP
CRK        write (*   ,*) 'ISTEP',ISTEP
        do i=1,nres1
          i1=4*(i-1)+nres2+1
          i2=i1+1
          d(i1,2)=stepksi(i)
          d(i2,2)=stepeta(i)
        enddo
crk        DO I=3,NRES2
crk          ALPH(I)=ALPH(I)+STEPALPHA(I)
crk        ENDDO
CRK	print *,(ALPH(I),i=1,100)
CRK       do i=1,nres1
CRK         i1=4*(i-1)+nres2+1
CRK         write (iout,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
CRK         write (*   ,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
CRK       enddo
        do ii=1,nres2
          theta2(ii)=theta1(ii)
        enddo
        IF (ISTEP.EQ.1) GOTO 448
        DO II=1,NRES1
          ROLD(II)=RRL(II)
          ROLD1(II)=RRL(II)
        ENDDO
  448   difold=1000.0
CRK ???????????????????????????????????????????????

*
*  Build up the table of internal coordinates.
*
      DO K=1,NRES
        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
      ENDDO
      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
      DO K=1,NRES2
        D(K,2)=THETA(K)
        D(K,3)=GAMA(K)
      ENDDO

CRK ???????????????????????????????????????????????

        DO IT=1,MAXIT

CRK          CALL ORIENT(IOUT,ISTEP)
CRK	CALL ENERGY(iout,istep)
CRK	CALL METROPOLIS(iout,istep)
CRK - proc. METROPOLIS chwilowo tutaj
CRK          CALL ENERGY(iout,istep)
CRK ???????????????????????????????????????????????
*
*
*  Build up the table of internal coordinates.
*
*      DO K=1,NRES
*        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
*      ENDDO
*      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
*      DO K=1,NRES2
*        D(K,2)=THETA(K)
*        D(K,3)=GAMA(K)
*      ENDDO
*
CRK ???????????????????????????????????????????????

        write(iout,*) (i,' ALPH(i)=',alph(i),i=1,nres2)
c      print *,'wywoluje proc. METROPOLIS'
          CALL METROPOLIS(iout,istep)
c      print *,'wychodze z proc. METROPOLIS'
ccc     print *,'rrl(i) przed proc minimize',(rrl(i),i=1,nres)
CRK       CALL MINIMIZE(iretcode,nfun)
       CALL ENERGY(iout,istep)
ccc     print *,'energia po minimize=',eng,' iretcode=',iretcode
c#
      call date_and_time(czas1,czas2,czas3,czasy)
      czas_c=3.6d3*(czasy(5)-czasy0(5))+6.0d1*(czasy(6)-czasy0(6))
      czas_c=czas_c+1.0d0*(czasy(7)-czasy0(7))+
     & 1d-3*(czasy(8)-czasy0(8))
CRK        print *,'CRK  czas=',czas_c
C ***********************************************************************
C                            SIDECHAINS
C ***********************************************************************
       call miedzy_nami_programami






C ***********************************************************************
C                              KONIEC ?
C ***********************************************************************
*
        STOP
*



CRK
CRK          write (iout,*) 'Iteration #',it
CRK          write (iout,*) 'Angles lambda after ORIENT:'
CRK          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
CRK          IF (NLEFT.GT.0 .OR. NDEP.GT.0) CALL ALIGN(IOUT)
CRK          write (iout,*) 'Angles lambda after ALIGN:'
CRK          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          CALL DEPEN(IOUT)
CRK          write (iout,*) 'Angles lambda after DEPEN:'
CRK          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
CRK          RRL(NRES1)=ANG(RRL(NRES1)+PI)
CRK
CRK	print *,'RRL(nres1)=',RRL(NRES1)
CRK czy to jest mi potrzebne ?
*
*          IF (ISTEP.GT.1 .OR. IT.GT.1) THEN
*          DO I=1,NRES1
*            DELTANG=RRL(I)-ROLD(I)
*            IF (DELTANG.GT.PI) THEN
*              DELTANG=DELTANG-DWAPI
*            ELSE IF (DELTANG.LT.-PI) THEN
*              DELTANG=DELTANG+DWAPI
*            ENDIF
*            if (abs(deltang).gt.1.8) then
*              write (2,*) 'Angle',i,' freezed (delta=',deltang/conv,')' 
*              deltang=0.0
*            endif
*            RRL(I)=ANG(ROLD(I)+STABFAC*DELTANG)
*          ENDDO
*          ENDIF
*
CRK tu jest procedura thetev:
CRK
CRK          CALL THETEV(IOUT)
*
          write (iout,*) 'Iteration:',it
          write (iout,*) 'Angles lambda:'
          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          write (iout,*) 'Angles theta'
          write (iout,'(10f8.3)') (theta(i),i=1,nres2)

          DIF=0.0
          DO I=3,NRES2
*           DIF=DIF+(THETA1(I)-THETA(I))**2
            difi=abs(theta1(i)-theta(i))
            if (difi.gt.dif) dif=difi
          ENDDO
*         DIF=SQRT(DIF)/NRES1
          IF (IPRINT.GT.0) WRITE (IOUT,10) IT,DIF 
          write (*,10) it,dif  
          if (dif.gt.difold) then
            do ii=1,nres2
              theta(ii)=theta1(ii)
            enddo
            do i=1,nres1
              rrl(i)=rold(i)
            enddo
            goto 447
          endif
          difold=dif
          IF (DIF .LT. TOL) GOTO 447   
          DO II=1,NRES1
            ROLD(II)=RRL(II)       
          ENDDO
CRK          DO II=1,NRES2
CRK            THETA(II)=STABFAC*THETA(II)+(1.0-STABFAC)*THETA1(II)
CRK            THETA1(II)=THETA(II)
CRK          ENDDO
CRK          DO II=1,NRES2
CRK            D(II,2)=THETA(II)
CRK          ENDDO
          CALL LOCATE(1,NRES2,FAIL,IERRO)
CRK          print *,'LOCATE called from main program fail',fail
        ENDDO
*
*---- Half down the increments, if the procedure fails to converge
*
        do ii=1,nres2
          theta1(ii)=theta2(ii)
        enddo
        do ii=1,nres1
          rold(ii)=rold1(ii)
        enddo
        if (delta.le.0.05) goto 447
        delta=0.5*delta
crk        do i=1,nres1
crk          i1=4*(i-1)+nres2+1
crk          i2=i1+1
crk          stepksi(i)=0.5*stepksi(i)
crk          stepeta(i)=0.5*stepeta(i)
crk          d(i1,2)=d(i1,2)-stepksi(i)
crk          d(i2,2)=d(i2,2)-stepeta(i)
crk        enddo
crk        do i=3,nres2
crk          stepalpha(i)=0.5*stepalpha(i)
crk          alph(i)=alph(i)-stepalpha(i)
crk        enddo
        goto 448
CRK Czy to jest mi potrzebne ?
c  447   CALL DISTFIT(IOUT,F0)
c        CALL THETEV(IOUT)
  447   continue
CRK
CRK        write(*,*) 'energia przed wywolaniem proc. ENERGY',eng
CRK        CALL ENERGY(ENG)
CRK        write(*,*) 'energia po wywolaniu proc. ENERGY '/
CRK     & /'linia 239 w phoenix2.f',eng
CRK
        odcinek=odcinek+delta
        print *,'odcinek=',odcinek
        write(iout, *) 'odcinek=',odcinek
cd      write (iout,*) 'Angles ksi and eta:'
cd      write (*   ,*) 'Angles ksi and eta:'
cd      do i=1,nres1
cd        i1=4*(i-1)+nres2+1
cd        i2=i1+1
cd        write (iout,'(i5,2f10.3)') i,d(i1,2),d(i2,2)
cd        write (*   ,'(i5,2f10.3)') i,d(i1,2),d(i2,2)
cd      enddo
        IF (IPRINT.GT.0)
     &  WRITE (IOUT,20) (INAMP(I),I,THETA(I+1),GAMA(I+1),
     &                   RRL(I)/CONV, I=1,NRES1)
        WRITE (IOUT,30) ENG
      ENDDO
crk      call thetev(iout)
      call depen(iout)
crk      do it=1,10  
crk        call distfit(iout,ff0)
crk        call thetev(iout)
crk        call depen(iout)
crk        if (abs((ff0-f0)/f0).lt.0.001) goto 449
crk        f0=ff0
crk      enddo
  449 sumwei=0.0
      do i=1,ny
        sumwei=sumwei+w(i)
      enddo
      f0=sqrt(f0/sumwei)
      write (iout,*) 'Final average distance discrepancy:',f0
      IF (IPRINT.EQ.0)
     &  WRITE (IOUT,20) (INAMP(I),I,THETA(I+1),GAMA(I+1),
     &                   RRL(I)/CONV, I=1,NRES1)
*
*  Build up the table of internal coordinates.
*
      DO K=1,NRES
        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
      ENDDO
      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
      DO K=1,NRES2
        D(K,2)=THETA(K)
        D(K,3)=GAMA(K)
      ENDDO   
************
*  Print final internal coordinates
*
C     CALL READGM(NATOMS+1,INP,IOUT,FAIL,FAIL1)
*
*  Calculate Cartesian coordinates.
*
CRK
      CALL CART(FAIL)
*  diagnostics
      do i=1,nres
        i1=4*(i-1)+nres2+1
        i2=i+1
        i3=i1+5
        write (iout,1111) i1,i2,i3,alpha(i1,i2,i3)/conv
        write (*,1111) i1,i2,i3,alpha(i1,i2,i3)/conv
      enddo    
 1111 format (' alpha(',i3,',',i3,',',i3,')=',f10.3) 
*
*  Calculate and print fi and psi angles.
*
      CALL FIPSI(IOUT,IPUN)
*
* Write final Cartesian coordinates in .pdb format
	igeom=iunit(4)
CRK	CALL PDBOUT(igeom)


 360  FORMAT('ATOM    ',T7,I5,T14,A2,T18,A3,T23,I4,T31,3F8.3)
   10 FORMAT ('ITERATION:',I4,' MEAN DIFFERENCE',F10.5)
   20 FORMAT (//'RESIDUE        THETA     GAMMA    LAMBDA'/
     1       200(A3,'[',I2,']',3X,3F10.2/)/)
   30 FORMAT ('FINAL ENERGY IS ',1PE15.5,' KCAL/MOL')        

      END
******************************************************************************
      SUBROUTINE DISTFIT(IOUT,F0)
      include 'parcom.dat'
      CHARACTER*4 INAMP
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES)
      COMMON /LOC/ NLIN,IREF(MAXRES,5),D(MAXRES,3)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PARAM/ NSTEP,MAXIT,TOL,STABFAC,MAXMAR
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),XX(MAXRES)
      common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      DIMENSION X(MAXRES),DIAGH(MAXRES),GAMAOLD(MAXRES)
      LOGICAL FAIL     
      RL=100.0
      CALL TRANSFER(NRES2,GAMA,GAMAOLD)
      F0=RDIF(GAMA,IOUT) 
      IF (IPRINT.GT.0) WRITE (IOUT,*) 'DISTFIT: F0=',F0 
      DO 1 IT=1,MAXIT 
        CALL RDERIV
        CALL HEVAL
*       do i=1,nx
*         write (iout,'(i3,8(1pe10.2))') i,(h(i,j),j=1,nx),xx(i)
*       enddo
        DO I=1,NX
          DIAGH(I)=H(I,I)
        ENDDO
        RL=RL/10.0
        DO IMAR=1,MAXMAR
          DO I=1,NX
            H(I,I)=DIAGH(I)+RL
          ENDDO
          CALL TRANSFER(NX,XX,X)
          CALL BANACH(NX,H,X) 
*         do i=1,nx
*           write (iout,*) 'x',i,' =',x(i)
*         enddo
          AIN=0.0
          DO I=1,NX
            AIN=AIN+ABS(X(I))
          ENDDO
          IF (AIN.LT.0.1*TOL .AND. RL.LT.1.0E-4) THEN
            WRITE (IOUT,*) 'DISTFIT: CONVERGENCE HAS BEEN ACHIEVED'
            WRITE (IOUT,*) 'F=',F0
            RETURN
          ENDIF
          DO I=4,NRES2
            GAMA(I)=GAMAOLD(I)+X(I-3)
          ENDDO
          F1=RDIF(GAMA,IOUT)
          IF (IPRINT.GT.1) WRITE (IOUT,*) 'IMAR=',IMAR,' RL=',RL,
     &               ' F1=',F1 
          IF (F1.LT.F0) THEN
            CALL TRANSFER(NRES2,GAMA,GAMAOLD)
            F0=F1
            GOTO 1
          ELSE IF (ABS(F1-F0).LT.1.0E-5) THEN  
            WRITE (IOUT,*) 'DISTFIT: CANNOT IMPROVE DISTANCE FIT'
            WRITE (IOUT,*) 'F=',F1
            RETURN
          ENDIF
          RL=RL*10.0
        ENDDO
        WRITE (IOUT,*) 'DISTFIT: MARQUARDT PROCEDURE HAS FAILED' 
        WRITE (IOUT,*) 'F=',F0
        CALL TRANSFER(NRES2,GAMAOLD,GAMA)
        DO I=4,NRES2
          D(I,3)=GAMA(I)
        ENDDO
        CALL LOCATE(1,NRES2,FAIL,3)
        print *,'LOCATE called in DISTFIT: fail=',fail
        RETURN
        IF (IPRINT.GT.0) WRITE (IOUT,*) 'IT=',IT,' AIN=',AIN,
     &    ' F=',F0
    1 CONTINUE 
      WRITE (IOUT,*) 'DISTFIT: FINAL F=',F0
      END  
******************************************************************************
      FUNCTION RDIF(GORBI,IOUT)
      include 'parcom.dat'
      DIMENSION GORBI(MAXRES)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DIMENSION E12(3),R13(3),R24(3)
      LOGICAL FAIL     
      DO I=4,NRES2
        D(I,3)=GORBI(I)
      ENDDO
      CALL LOCATE(1,NRES2,FAIL,3)
      print *,'LOCATE called in RDIF fail=',fail
      SUMA=0.0
      IND=0
      DO I=1,NRES    
        DO J=I+3,NRES2
          IND=IND+1
          DIJ=DIST(I,J)
          SUMA=SUMA+W(IND)*(DIJ-D0(IND))**2
          DD(IND)=DIJ
        ENDDO
      ENDDO
      RDIF=SUMA
      RETURN
      END 
******************************************************************************
      SUBROUTINE RDERIV        
      include 'parcom.dat'
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DIMENSION E12(3),R13(3),R24(3),PROD(3)
      LOGICAL FAIL     
      DO I=1,NY
        DO J=1,NX
          DRDG(I,J)=0.0
        ENDDO
      ENDDO
      DO I=1,NX
        I1=I+1
        I2=I+2
        CALL VEC(I1,I2,E12)
        DO J=1,I
          DO K=1,3
            R13(K)=XYZ(J,K)-XYZ(I1,K)
          ENDDO
          DO K=I2+1,NRES2
            DO L=1,3
              R24(L)=XYZ(K,L)-XYZ(I2,L)
            ENDDO
            IND=((J-1)*(2*NRES2-J-6))/2+K-3
            PROD(1)=R13(2)*R24(3)-R13(3)*R24(2)
            PROD(2)=R13(3)*R24(1)-R13(1)*R24(3)
            PROD(3)=R13(1)*R24(2)-R13(2)*R24(1)
            DRDG(IND,I)=CONV*SCALAR(E12,PROD)/DIST(J,K)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END
******************************************************************************
      SUBROUTINE HEVAL
      include 'parcom.dat'
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,B(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DO I=1,NX
        XI=0.0
        HII=0.0
        DO K=1,NY
          BKI=B(K,I)
          BKIWK=W(K)*BKI
          XI=XI+BKIWK*(D0(K)-DD(K))
          HII=HII+BKI*BKIWK
        ENDDO
        H(I,I)=HII
        X(I)=XI
        DO J=I+1,NX
          HIJ=0.0
          DO K=1,NY
            HIJ=HIJ+B(K,I)*B(K,J)*W(K)
          ENDDO
          H(I,J)=HIJ
          H(J,I)=HIJ
        ENDDO
      ENDDO
      RETURN
      END
******************************************************************************
      SUBROUTINE OPT(IOUT,ENG)
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,REST
      LOGICAL OPTSH,REST
      write(*,*) 'CRK co to jest?',mxit,tolx,tolg,tolrec,optsh,rest
*     CALL DFP(IOUT,10,50,MXIT,TOLX,TOLG,TOLREC,.FALSE.,1,LINT,*1)
CRK    1 CALL ENERGY(ENG)
      RETURN 
      END
******************************************************************************
      SUBROUTINE THETEV(IOUT)
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      CHARACTER*4 INAMP
      REAL KSI,KSID
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      DO I=3,NRES2
        RL1=RRL(I-2)
        RL2=ALAM2(I-1)
        THETA(I)=THET(I,RL1,RL2)
      ENDDO
      RETURN
      END
******************************************************************************  
      FUNCTION THET(I,RL1,RL2)  
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      REAL KSI,KSID
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
C
      IF (INAMP(I-1).EQ.'TER '.AND.(INAMP(I-2).EQ.'TER '.OR.
     &    INAMP(I).EQ.'TER ')) THEN  
        THET=THETA(I)
        RETURN
      ENDIF
      I1=4*(I-3)+NRES2+1
      I2=I1+5 
      KSI=D(I1,2)*CONV
      ETA=D(I2,2)*CONV
*     print *,i,rl1/conv,rl2/conv,ksi/conv,eta/conv,alpha(i)
      COSKSI=COS(KSI)
      SINKSI=SIN(KSI)
      COSETA=COS(ETA)
      SINETA=SIN(ETA)
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSALF=COS(ALPHA(I)*CONV)
      BB=-SINKSI*COSETA*COSL1-COSKSI*SINETA*COSL2
      AA=COSKSI*COSETA-SINKSI*SINETA*COSL1*COSL2
      CC=-SINKSI*SINETA*SINL1*SINL2-COSALF
      DELTA=SQRT(AA*AA+BB*BB-CC*CC)
      IF (DELTA.LT.0.0) DELTA=0.0
      T1=-ATAN2((BB+DELTA),(CC-AA))
      T2=-ATAN2((BB-DELTA),(CC-AA))
      IF (T1.LT.0.0) T1=T1+PI
      IF (T2.LT.0.0) T2=T2+PI
      T1=2.0*T1
      T2=2.0*T2
      T=T1
*     print *,i,t1/conv,t2/conv
*     pause
      IF (T1.GT.PI) T=T2
      THET=T/CONV
*     print *,acos(aa*cos(t)+bb*sin(t)-sinksi*sineta*sinl1*sinl2)/conv
      RETURN
      END
******************************************************************************
      SUBROUTINE ALPHEV(IOUT)
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      CHARACTER*4 INAMP
      double precision xalph,KSI,KSID
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
CRK

      DO I=3,NRES2
        RL1=RRL(I-2)
        RL2=alam2(I-1)
        xalph=ALFA(I,RL1,RL2)
        ALPH(I-1)=xalph
CRK      print *,i,' wartosci "I+1", xalph', I+1,xalph
      ENDDO
CRK
      RETURN
      END
******************************************************************************
      FUNCTION ALFA(I,RL1,RL2)  
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      double precision KSI,KSID,eta,aa,bb,cc,alfa
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
C
      THET=THETA(I)*CONV
c      print *,i,' theta(i)=',theta(i)
C
      I1=4*(I-3)+NRES2+1
      I2=I1+5 
      KSI=D(I1,2)*CONV
      ETA=D(I2,2)*CONV
crk      ksi1=ksi(i)*conv
crk      eta1=eta(i)*conv
CRK!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c      print *,i,rl1/conv,rl2/conv,ksi/conv,eta/conv,alpha(i)
      COSKSI=COS(KSI)
      SINKSI=SIN(KSI)
      COSETA=COS(ETA)
      SINETA=SIN(ETA)
      SINTHET=sin(thet)
      COSTHET=cos(thet)
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
   
      BB=-SINKSI*COSETA*COSL1-COSKSI*SINETA*COSL2
      AA=COSKSI*COSETA-SINKSI*SINETA*COSL1*COSL2
      CC=-SINKSI*SINETA*SINL1*SINL2
CRK
      COSALF=aa*costhet+bb*sinthet+cc

*     print *,i,t1/conv,t2/conv
*     pause
      alfa=arcos(cosalf)
      alfa=alfa/CONV
crk      print *,'funkcja cosalf',cosalf,' alfa=',alfa
*     print *,acos(aa*cos(t)+bb*sin(t)-sinksi*sineta*sinl1*sinl2)/conv
      RETURN
      END
******************************************************************************
      SUBROUTINE L2EV(IOUT,II)
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      CHARACTER*4 INAMP
      double precision  KSI,KSID,xrrl
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      i=ii+2
        RL1=RRL(I-2)
crk        rold=RRL(I-1)
           rold=alam2(i-1)
        xrrl=RRL2(I-1,RL1,rold)
crk        print *,'xrrl=',xrrl,' lambda2=',rrl(i-1)
        RL2=xrrl
crk        RRL(I-1)=conv*GAMA(i+1)-RL2-pi
           RRL(I-1)=pinorm(conv*GAMA(i+1)-RL2-pi)
crk        RRL(i-1)=xrrl
      RETURN
      END
******************************************************************************
      FUNCTION RRL2(IJ,RL1,rold)  
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      double precision KSI,KSID,eta,aa,bb,cc,alfa,rrl2
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
C
      THET=THETA(IJ+1)*CONV
      alfa=ALPH(iJ)*conv
c      print *,iJ+1,' theta(iJ+1)=',theta(iJ+1)
C
      I1=4*(IJ-3)+NRES2+1
crk      I2=I1+5 
      I2=I1+5
      KSI=D(I1,2)*CONV
      ETA=D(I2,2)*CONV
crk      ksi1=ksi(i)*conv
crk      eta1=eta(i)*conv
CRK!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c      print *,ij,rl1/conv,thet/conv,ksi/conv,eta/conv,alfa/conv
      COSKSI=COS(KSI)
      SINKSI=SIN(KSI)
      COSETA=COS(ETA)
      SINETA=SIN(ETA)
      SINTHET=sin(thet)
      COSTHET=cos(thet)
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
c      COSL2=COS(RL2)
c      SINL2=SIN(RL2)
      COSALF=COS(alfa)
   
      AA=-SINKSI*SINETA*COSTHET*COSL1-COSKSI*SINETA*SINTHET
      BB=SINKSI*SINETA*SINL1
      CC=-SINKSI*COSETA*COSL1*SINTHET+COSKSI*COSETA*COSTHET-COSALF
CRK
crk      if(AA*AA+BB*BB-CC*CC.lt.0.0) print *,'DELTA=',AA*AA+BB*BB-CC*CC
      DELTA=SQRT(AA*AA+BB*BB-CC*CC)
      IF (DELTA.LT.0.0) DELTA=0.0
crk      T1=-ATAN2((BB+DELTA),(CC-AA))
crk      T2=-ATAN2((BB-DELTA),(CC-AA))

      T1=-ATAN2((BB+DELTA),(CC-AA))
      T2=-ATAN2((BB-DELTA),(CC-AA))

c      IF (T1.LT.0.0) T1=T1+PI
c      IF (T2.LT.0.0) T2=T2+PI
      T1=2.0*T1
      T2=2.0*T2

      RRL2=T1
crk      print *,i,' T1,T2 ',pinorm(t1),pinorm(t2),rrl(i-1)
crk      print *,i,t1/conv,t2/conv,rrl(i-1)/conv
*     pause
      IF (abs(pinorm(T2)-rold).LT.abs(pinorm(T1)-rold)) then
c        print *,ij,' T1,T2 ',pinorm(t1),pinorm(t2),rrl(ij)
        RRL2=T2
      endif

c      RRL2=RRL2/CONV
CRK
*
crk      print *,ij,' sprawdzam: t1',aa*cos(t1)+bb*sin(t1)+cc
crk      print *,ij,' sprawdzam: t2',aa*cos(t2)+bb*sin(t2)+cc
*     pause
*      alfa=arcos(cosalf)
*      alfa=alfa/CONV
c      print *,'funkcja cosalf',cosalf,' alfa=',alfa
*     print *,acos(aa*cos(t)+bb*sin(t)-sinksi*sineta*sinl1*sinl2)/conv
      RETURN
      END
**************************************************************************
      SUBROUTINE FIPSI(IOUT,IPUN)
      include 'parcom.dat'
      REAL KSI,KSID
      CHARACTER*4 INAMP
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /SADDAM/ FIPSICHI(MAXRES,10)
      common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      WRITE (IOUT,90)
   90 FORMAT ('RESIDUE               PHI                PSI'/50(1H-))
      DO 1 I=1,NRES
        I1=4*I+NRES2+1
        I2=4*I+NRES2+2
        I3=I+1
        I4=4*(I-1)+NRES2+1
        I5=4*(I-1)+NRES2+2
        FIPSICHI(I+1,1)=BETA(I2,I3,I4,I5)/CONV
        FIPSICHI(I+1,2)=BETA(I1,I2,I3,I4)/CONV
        WRITE(IOUT,100) INAMP(I+1),I+1,FIPSICHI(I+1,1),FIPSICHI(I+1,2)
    1 CONTINUE
  100 FORMAT (A3,'[',I3,']',10X,F10.3,10X,F10.3)
      WRITE (IPUN,'(10F8.3)') ( (FIPSICHI(I,J),J=1,10),I=1,NRES2)
      RETURN
      END
******************************************************************************
      SUBROUTINE START(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
C
C  This subroutine reads in the peptide geometry parameters (i.e. the
C  angles theta and gama), optionally other peptide backbone parameters,
C  and the remaining geometry (for example that of the sidechains).
C
      include 'parcom.dat'
      LOGICAL FAIL,FAIL1,DIHED,CLOSES,OPTSH,OPTRE,RDPATH,PRINTMAP,
     &        NOCALC,CONTACTS_ONLY,DUMMY_N_TERM,DUMMY_C_TERM,schain
CRK dodalem zmienna logiczna schain w celu odtwarzania tylko s. chain.
C     INTEGER*2 ICODE,ITYPE,IR,IBOND,ITORS,NAME,IREF
      integer iczyt,iczytca
      REAL KSI,KSID
      double precision xwsp(MAXAT,3),xsc(MAXAT,3),scw(MAXAT,3)
      double precision xscext
      CHARACTER*4 INAMP,atcc(MAXAT)
      CHARACTER*80 CONTROLCARD,TITLE,ucase
      DIMENSION IPAIR(100,2),WPAIR(100)
      COMMON /PARAM/ MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,OPTRE
      COMMON /DRUK/ IPRINT
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /ATOMS2/ xscext(2*maxat,3)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG,deg2rad
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /BND/ NBOND,NVDW,IBOND(MAXAT,2)
      COMMON /DSULF/ DIHED,CLOSES,DSS,ALCSS,BECSSC,AINCFI,ILOC(6,10),
     1 NSS,AKSS,AKSSC
      COMMON /NAMAT/ NAME(30)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1     H(MAXRES,MAXRES),XX(MAXRES)
      common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      COMMON /SADDAM/ FIPSICHI(MAXRES,10)
      COMMON /ELEC/ IEL12
      COMMON /HEADER/ TITLE
      common /log/ schain
      character*4 one_to_three
      common /cmdlopt/ optstring
      character*16 optstring
      dimension bls(4,4),aksis(4,4),aetas(4,4)
      character*8 form
      data alphgly /111.0/,alphpro /111.0/
      data bls/8*3.785,4*3.810,3*3.875,0.0/,
     &   aksis/14.93,2*14.94,14.93,14.92,14.95,2*14.93,
     &         15.30,15.32,15.31,15.30,3*14.93,0.0/,
     &   aetas/4*20.95,20.95,20.95,20.96,20.95,4*20.31,3*20.95,0.0/

      ALCSS=CONV*ALCSS
      BECSSC=CONV*BECSSC
      READ (INP,'(a)') TITLE
      WRITE (IOUT,'(a)') TITLE
 2000 FORMAT (20A4)
      read (inp,'(a80)') controlcard
      controlcard=ucase(controlcard)
      nocalc=(index(controlcard,'NO_CALC').gt.0 
     &   .or. index(optstring,'nc').gt.0)
      schain=(index(controlcard,'SCHAIN').gt.0)
      rdpath=(index(controlcard,'READ_PATHS').gt.0
     &   .or. index(optstring,'r').gt.0)
      printmap=(index(controlcard,'PRINT_CONT_MAP').gt.0 
     &   .or. index(optstring,'p').gt.0)
      contacts_only=(index(controlcard,'CONTACTS_ONLY').gt.0
     &   .or. index(optstring,'co') .gt.0)
      READ (INP,*) NRES,IPRINT,IWEI,IEL12
      NRES1=NRES+1
      NRES2=NRES+2
      NBOND=5*NRES1
      NATOMS=5*NRES1+1
      if (index(controlcard,'ONE_LETTER').gt.0) then
        read (inp,'(80a1)') (inamp(i)(1:1),i=1,nres2)
        do i=1,nres2
         inamp(i)=one_to_three(inamp(i))
        enddo
      else
        READ (INP,'(20A4)') (INAMP(I),I=1,NRES2)
      endif
C
C Interface to ECEPP
C Assign extended conformations to backbone & side chains
C
      do i=1,nres1
        do j=1,10
          fipsichi(i,j)=180.0
        enddo
        fipsichi(i,4)=-120.0
      enddo
C
C  NRES - the number of residues (excluding the blocking groups)       
C  NRES1- the number of peptide bonds                            
C  NRES2- the number of peptide bond vertices (including the blocking groups)
C
C  Determine fixed geometry parameters
C
      alph(1)=0.0
      alph(2)=0.0
      do i=1,nres1
        if (inamp(i).eq.'GLY ') then
          alph(i+1)=alphgly
        else if (inamp(i).eq.'PRO ') then
          alph(i+1)=alphpro
        else
          alph(i+1)=alphad
        endif
      enddo
C
C Read in virtual-chain geometry 
C
      READ (INP,'(A8)') FORM

      IF (INDEX(FORM,'MOPAC').GT.0) THEN

      DO I=1,NRES2
        READ (INP,1030) D(I,1),THETA(I),GAMA(I)
        IF (D(I,1).LE.3.4) D(I,1)=BLCCD
        D(I,2)=THETA(I)
        D(I,3)=GAMA(I)
      ENDDO

      ELSE IF (INDEX(FORM,'ZIP').GT.0) THEN
      
c       print *,'Wykrylem ZIP'
      DO I=1,NRES2
        D(I,1)=3.8
C        D(I,2)=90.0
C        THETA(I)=90.0
      ENDDO
      D(1,1)=0.0
      D(1,2)=0.0
      THETA(1)=0.0
      D(2,2)=0.0
      THETA(2)=0.0
      D(1,3)=0.0
      D(2,3)=0.0
      D(3,3)=0.0
      GAMA(1)=0.0
      GAMA(2)=0.0
      GAMA(3)=0.0
C 6/29/98 - Read the THETA angles too
      READ (INP,'(8F10.5)') (THETA(I),I=3,NRES2)
      READ (INP,'(8F10.5)') (GAMA(I),I=4,NRES2)
C 6/29/98
      DO I=3,NRES2
        D(I,2)=THETA(I)
      ENDDO
      DO I=4,NRES2
        D(I,3)=GAMA(I)
      ENDDO
c        print *,'Wykrylem ZIP 2'
      ELSE IF (INDEX(FORM,'PDB').GT.0) THEN

CRK tylko dodawanie s. chain.
      if(schain) then
c        print *,'proc. START wywoluje proc. dane (tylko dla schain)'
        call dane(inp)
        stop
      endif
CRK koniec dodawania tylko s. chain.

      ISREAD=2
      IEREAD=NRES1
      dummy_n_term=(INAMP(1).EQ.'D')
      dummy_c_term=(INAMP(NRES2).EQ.'D')
      IF (.not.dummy_n_term) ISREAD=1       
      IF (.not.dummy_c_term) IEREAD=NRES2
CRK zmieniam czytanie wsp. kart.
CRK (bylo)     READ (INP,'(30X,3F8.3)') ((X(I,J),J=1,3),I=ISREAD,IEREAD)
CRK
C  tu jest dopisane czytanie polozen (wspolrzednych) centroidow:
CRK
CRK      print *,'ISREAD, IEREAD',ISREAD,IEREAD
      READ (INP,'(12X,a4,14X,3F8.3)') (atcc(I),(XWSP(I,J),J=1,3),
     &                                 I=ISREAD,2*IEREAD-1)
      iczytca=ISREAD
      iczyt=ISREAD
CRK      print *,'ISREAD=',ISREAD,'IEREAD=',IEREAD
      do ii=ISREAD,2*IEREAD
        if(atcc(ii)(2:3).eq.'CA') then
         do jj=1,3
          X(iczytca,jj)=XWSP(ii,jj)
          xscext(maxat+iczytca,jj)=XWSP(ii,jj)
         enddo
         iczytca=iczytca+1
        endif
        if(atcc(ii)(2:3).ne.'CA') then
         do jj=1,3
          XSC(iczyt,jj)=XWSP(ii,jj)
          xscext(iczyt,jj)=XWSP(ii,jj)
c          print *,'iczyt=',iczyt
         enddo
         iczyt=iczyt+1
        endif
      enddo
CRK wydruk kontrolny prawidlowosci czytania CA
CRK      do ii=ISREAD,2*IEREAD-1
CRK      write(*,'(a4,a2,i4,6f8.3)') atcc(ii),'CA',ii,(xwsp(ii,jj),jj=1,3),
CRK     & (X(ii,jj),jj=1,3)
CRK      enddo
CRK koniec wydruku
      do ii=ISREAD,IEREAD
        scw(II,1)=DIST2(maxat+II,II)
        if(scw(II,1).gt.0.0d0) then
        scw(II,2)=ALPHA2(maxat+II+1,maxat+II,II)/CONV
        scw(II,3)=BETA2(maxat+II+2,maxat+II+1,maxat+II,II)/CONV
CRK        print *,ii,inamp(ii+1),'scw=',(scw(II,j),j=1,3)
        endif
      enddo


CRK  liczenie kata torsyjnego jest def. w funkcji beta
c
CRK
      DO I=ISREAD+3,IEREAD
        D(I,1)=DIST(I,I-1)
        D(I,2)=ALPHA(I,I-1,I-2)/CONV
        D(I,3)=BETA(I,I-1,I-2,I-3)/CONV
      ENDDO
      D(1,1)=0.0
      if (dummy_n_term) then
        D(2,1)=3.8
        D(4,1)=DIST(3,4)
      else
        D(2,1)=DIST(1,2)
      endif
      D(3,1)=DIST(2,3)
      D(1,2)=0.0
      D(2,2)=0.0
      if (dummy_n_term) then
        D(3,2)=106.3
        D(4,2)=ALPHA(2,3,4)/CONV
      else
        D(3,2)=ALPHA(1,2,3)/CONV
      endif
      D(1,3)=0.0
      D(2,3)=0.0
      D(3,3)=0.0 
      if (dummy_n_term) D(4,3)=180.0
      if (dummy_c_term) then
        D(NRES2,1)=3.8
        D(NRES2,2)=106.3
        D(NRES2,3)=180.0
      endif
      DO I=1,NRES2
        THETA(I)=D(I,2)
        GAMA(I)=D(I,3)
      ENDDO

      ELSE
        WRITE(IOUT,'(1a)') FORM
      WRITE(IOUT,'(2a)')'Illegal format specification for virtual ',
     & 'geometry; program stopped.' 
      stop 

      ENDIF
               
*******************
* Changes on 1/8/91 (proline treatment)
*******************
      DO I=1,NRES2
        IPRO(I)=0
      ENDDO

      DO I=1,NRES2
        IF (INAMP(I).EQ.'Pro' .OR. INAMP(I).EQ.'PRO') IPRO(I)=1
        IF (INAMP(I).EQ.'pro') IPRO(I)=-1
      ENDDO
********************
 1030 FORMAT (3X,F12.5,3X,F12.5,3X,F12.5)
      WRITE (IOUT,2010) NRES,NATOMS
      DO 6 I=1,NRES2
    6   WRITE (IOUT,2020) INAMP(I),I,D(I,1),THETA(I),GAMA(I),ALPH(I)
      WRITE (IOUT,2030)
 2010 FORMAT(80(1H*)//'The peptide contains',I4,' residues',
     1 ' and',I4,' backbone atoms.'//80(1H*)//'residue',2X,'vb length',
     2 6X,'theta',6X,'gamma',7X,'alpha'/80(1H-)/)
 2020 FORMAT (A3,'(',I3,')',5X,F5.3,5X,F6.2,5X,F6.1,6X,F6.1)
 2030 FORMAT (80(1H-)//)
C
C  Generate the part of the location table (IREF) corresponding
C  to the peptide shape
C
  222 NREACT=NREACT+1
      IREF(1,1)=1
      IREF(2,1)=2
      IREF(2,2)=1
      IREF(3,1)=3
      IREF(3,2)=2
      IREF(3,3)=1
      IF (NRES2.LT.4) GOTO 4
      DO 3 I=4,NRES2
        DO 33 J=1,4
   33     IREF(I,J)=I-J+1
    3 CONTINUE
C
C  Assign types for atoms of the peptide backbone, reads the
C  geometry parameters necessary to locate the rest of the backbone
C  as well as constructs a part of the bond table.
C
C   4 READ (INP,1010) ITYPE(1)
    4 itype(1)=1
      DO 2 I=1,NRES1
        ITY1=1
        IF (INAMP(I).EQ.'GLY ') THEN
          ITY1=2
        ELSE IF (INAMP(I).EQ.'PRO ') THEN
          ITY1=3
        ELSE IF (INAMP(I).EQ.'TER ') THEN
          ITY1=4
        ENDIF
        ITY2=1
        IF (INAMP(I+1).EQ.'GLY ') THEN
          ITY2=2
        ELSE IF (INAMP(I+1).EQ.'PRO ') THEN
          ITY2=3
        ELSE IF (INAMP(I+1).EQ.'TER ') THEN
          ITY2=4
        ENDIF
C       READ (INP,1010) ITC1,ITN,ITC,ITH,ITO,
C    1  BLCN,BLNC,KSI(I),ETA(I),BLNH,ALCNH,BLCO,ALCCO
 1010 FORMAT (5I5/8F10.5)
        ITC=ITCD
        ITN=ITND
        ITC1=ITC1D
        ITH=ITHD
        ITO=ITOD
        BLCN=BLCND
        BLNC=BLNCD
        KSI(I)=AKSIS(ITY1,ITY2)
        ETA(I)=AETAS(ITY1,ITY2)
c        print *,i,' ksi,eta ',ksi(i),eta(i)
        BLNH=BLNHD
        ALCNH=ALCNHD
        BLCO=BLCOD
        ALCCO=ALCCOD
        I1=I+1
        ITYPE(I1)=ITC1
        I1=4*(I-1)+NRES2+1
        I2=I1+1
        I3=I1+2
        I4=I1+3
        II1=5*(I-1)+1
        II2=II1+1
        II3=II2+1
        II4=II3+1
        II5=II4+1
        IBOND(II1,1)=I+1
        IBOND(II1,2)=I1
        IBOND(II2,1)=I1
        IBOND(II2,2)=I2
        IBOND(II3,1)=I2
        IBOND(II3,2)=I
        IBOND(II4,1)=I1
        IBOND(II4,2)=I3
        IBOND(II5,1)=I2
        IBOND(II5,2)=I4
        ITYPE(I1)=ITN
        ITYPE(I2)=ITC
        ITYPE(I3)=ITH
        ITYPE(I4)=ITO
        IREF(I1,1)=I1
        IREF(I2,1)=I2
        IREF(I3,1)=I3
        IREF(I4,1)=I4
        IREF(I1,2)=I+1
        IREF(I2,2)=I
        IREF(I3,2)=I1
        IREF(I4,2)=I2
        IREF(I1,3)=I
        IREF(I2,3)=I+1
        IREF(I3,3)=I+1
        IREF(I4,3)=I
        IREF(I3,4)=I
        IREF(I4,4)=I+1
        IREF(I2,4)=I1
        IREF(I1,4)=I+2
        IF (I.EQ.NRES1) IREF(I1,4)=I-1
        D(I1,1)=BLCN
        D(I1,2)=KSI(I)
        D(I1,3)=180.
        D(I2,1)=BLNC
        D(I2,2)=ETA(I)
        D(I2,3)=180.
        D(I3,1)=BLNH
        D(I3,2)=ALCNH
        D(I3,3)=180.
        D(I4,1)=BLCO
        D(I4,2)=ALCCO
c        write(*,*) 'wydruk katow walencyjnych:',
c     &              (itype(iii),d(iii,2),iii=i1,i4)
    2   D(I4,3)=180.
      OPTRE=.FALSE.
      OPTSH=.FALSE.
C
C Read in parameters that control the iterative process
C
      READ (INP,*) MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR   
      IF (MAXSTEP.EQ.0) MAXSTEP=20
      IF (MAXIT.EQ.0) MAXIT=20
      IF (TOL.EQ.0) TOL=0.5  
      IF (STABFAC.EQ.0) STABFAC=1.0
      IF (MAXMAR.EQ.0) MAXMAR=10
      WRITE (IOUT,2050) MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR  
 2050 FORMAT (/'Max. number of continuation-method steps:',I3/      
     1         'Max. number of iterations in theta angle adjusting:',I3/
     2         'Tolerance in theta angle adjusting (deg):',F8.2/
     3         'Stability factor in theta angle adjusting:',F8.2/
     4         'Max. number of Marquardt iterations:',I3/)
      if (iel12.gt.0) write (iout,*) 'Electrostatic interactions ',
     &'between the neighboring centers included.'
      if (iel12.le.0) write (iout,*) 'Electrostatic interactions ',
     &'between the neighboring centers discarded.'
      READ (INP,*) NPAIR
      write (iout,*)
      if (npair.gt.0)
     & WRITE (IOUT,'(a,i5,a)') 
     & 'There are',NPAIR,' distances to be weighed specially'
      DO I=1,NPAIR
        READ (INP,*) IPAIR(I,1),IPAIR(I,2),WPAIR(I)
        WRITE (IOUT,*) IPAIR(I,1),IPAIR(I,2),WPAIR(I)
      ENDDO
*
*  Calculate Cartesian coordinates of the shape.
*
      fail=.false.
      CALL LOCATE(1,NRES2,FAIL,3)
CRK      print *,'LOCATE called from START: fail=',fail
      IF (FAIL) STOP
      NX=NRES-1
      NY=((NRES-2)*(NRES-3))/2
      write (2,*) 'nx=',nx,' ny=',ny
*     do i=1,nres1
*       do j=i+1,nres2
*         write (iout,'(2i5,f10.5)') i+1,j+1,dist(i,j)
*       enddo
*     enddo
*     stop
      IND=0
      DO I=1,NRES-1
        DO J=I+3,NRES2
          IND=IND+1
          D0(IND)=DIST(I,J)
          W(IND)=1.0
          IF (IWEI.GT.0) W(IND)=1.0/D0(IND)**2
          DO K=1,NPAIR
            IF (IPAIR(I,1).EQ.I .AND. IPAIR(I,2).EQ.J) THEN
              W(IND)=WPAIR(K)**2
              GOTO 224
            ENDIF
          ENDDO
  224     CONTINUE
        ENDDO
      ENDDO
      DO I=2,NRES2
        ITY1=1
        IF (INAMP(I-1).EQ.'GLY ') THEN
          ITY1=2
        ELSE IF (INAMP(I-1).EQ.'PRO ') THEN
          ITY1=3
        ELSE IF (INAMP(I-1).EQ.'TER ') THEN
          ITY1=4
        ENDIF
        ITY2=1
        IF (INAMP(I).EQ.'GLY ') THEN
          ITY2=2
        ELSE IF (INAMP(I).EQ.'PRO ') THEN
          ITY2=3
        ELSE IF (INAMP(I).EQ.'TER ') THEN
          ITY2=4
        ENDIF
        IF (ITY1+ITY2.LT.8) D(I,1)=BLS(ITY1,ITY2)
      ENDDO
      RETURN
      END
******************************************************************************
      character*(*) function one_to_three(one_letter_code)
      character*1 ucase
      character*1 one_letter_code,aux
      character*1 one(21)
      character*4 three(21)
      character*4 lcase
      data one 
     & /'A',  'R',  'N',  'D',  'C',  'E',  'Q',  'G',  'H',  'I',
     &  'L',  'K',  'M',  'F',  'P',  'S',  'T',  'W',  'Y',  'V',  'X'/
      data three
     & /'ALA','ARG','ASN','ASP','CYS','GLU','GLN','GLY','HIS','ILE',
     &  'LEU','LYS','MET','PHE','PRO','SER','THR','TRP','TYR','VAL',
     &  'D  '/
      aux=ucase(one_letter_code)
      i=1
      do while (aux.ne.one(i) .and. i.lt.21)
        i=i+1
      enddo    
      if (aux.ne.one_letter_code) then
        one_to_three=lcase(three(i))
      else
        one_to_three=three(i)
      endif
      return 
      end 
C******************************************************************************
crk      SUBROUTINE ORIENT(IOUT,ISTEP)
crk      include 'parcom.dat'
crk*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
crk      DIMENSION RL(maxres+1),ZP(maxres,maxres),ZM(maxres,maxres),
crk     & CP(maxres,maxres),CM(maxres,maxres),SP(maxres,maxres),
crk     & SM(maxres,maxres),F0(maxres,maxres),P0(maxres,maxres)
crk      LOGICAL FAIL,CONV
crk      REAL LAM0
crk      CHARACTER*4 INAMP
crk      DIMENSION A(maxres+1,maxres+1),RESD(maxres+1,maxres+1),
crk     & G(maxres+1),AA(maxres+1,maxres+1)
crk      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
crk      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
crk      COMMON /LOCAL/ E1(3),E2(3),E3(3),U(3),ZZ(3),S1,S2
crk      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
crk      common /alph0/ alph0
crk      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
crk     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
crk      COMMON /APPROX/ LAM0(maxres,maxres)
crk      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
crk     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
crk     & FI0(maxres,maxres),PSI0(maxres,maxres) 
crk        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
crk      COMMON /GEO/ PI,DWAPI,CONVER,RAD2DEG
crk      COMMON /DRUK/ IPRINT
crk      DATA MAXIT /100/
crk	print *,'wszedlem do procedury ORIENT'
crk*
crkCRK      CALL COEFFT(IOUT,ISTEP)
crk*
crk      DO 1 i=1,nres
crk        RLAMBD=0.01
crkCRK
crk        DO 1 j=i,nres
crk	  ZP(i,j)=ZPLUS(i,j)
crk	  ZM(i,j)=ZMINUS(i,j)
crk	  F0(i,j)=FI0(i,j)
crk  1 	  P0(i,j)=PSI0(i,j)
crkCRK
crkCRK zmienic ostatnia linie
crkCRK write(*,*) (ZP(2,j),j=1,nres)
crk
crk       DO 12 i=1,nres
crk	do 12 j=1,nres
crk        RLAMBD=0.01
crk   12   RL(i)=LAM0(i,j)
crk
crkCRK - poprawic energie...
crk
crkCRK        EOLD=PATHENG(1,nres,RL)
crk
crkCRK
crkCRK - poprawic energie ^
crk
crkCRK        IF (LENGTH.LE.2) GOTO 333
crk*
crk*  Begin iteration
crk*
crk        DO 3 I=1,nres
crk	DO 3 J=1,nres
crk    3     A(I,J)=0.0	
crk        DO 222 IT=1,MAXIT
crk*
crk          DO i=1,nres-2
crk	   do j=I+1,nres-1
crk	   
crk            CP(i,j) = ZP(i,j)*COS(RL(i)+RL(j)-F0(i,j))
crk	    CM(i,j) = ZM(i,j)*COS(RL(i)-RL(j)-P0(i,j))
crkCRK            SP(I,j) = ZP(I,j)*SIN(RL(I)+RL(j)-F0(I,j))
crkCRK            SM(I,j) = ZM(I,j)*SIN(RL(I)-RL(j)-P0(I,j))	  	
crk	   enddo
crk	  enddo
crk*
crkCRK          RESD(1,1)=-SP(1,1)-SM(1,1)
crkCRK	  A(1,1) = CP(1,1)+CM(1,1)
crkCRK	  AA(1,2) = CP(1,2)-CM(1,2)
crk	  DO 4 i=1,nres
crk	    do 4 j=i,nres
crkCRK   		 RESD(I,j) = -SP(I-1,j-1)+SM(I-1,j-1)-SP(I,j)-SM(I,j)
crk            A(i,j) = CP(i,j)+CM(i,j)
crkCRK            AA(I,j) = CP(I,j) - CM(i,j)
crkCRK	print *,'a(i,j)=',a(I,j),i,j
crk    4     CONTINUE
crk	  DO i=1,nres
crk            do  j=1,i-1
crk            A(i,j) = A(j,i)
crk	    enddo
crk	  enddo
crk
crkCRK        RESD(nres)      =-SP(nres-1)+SM(nres-1)
crk	CALL TRANSFER(nres,RESD,G)
crkCRK        AA(nres,nres)= CP(nres,nres)-CM(nres,nres)
crk        A(nres,nres)  = CP(nres,nres)+CM(nres,nres)
crk        IF (IPRINT.GT.1) THEN 
crk           do 444 i=1,nres
crk  444       write (iout,4444) (a(i,j),j=1,nres),resd(i)
crk 4444 format (4f10.5,f15.5)  
crk        ENDIF
crkCRK  co to jest za procedura ?
crk        CALL INCR(1,nres,A,G,RL,CONV,AMAX,EOLD,RLAMBD)
crkCRK
crk        IF (IPRINT.GT.1) THEN
crk          write (iout,*) 'conv=',conv
crk      write (iout,2222) it,(i,ipath(ip,i),g(i)/conver,rl(i)/conver,
crk     2                      i=1,length)
crk 2222 format ('Iteration ',I3
crk     1       /'Increments & new variable values:'/10(2i4,2f15.5/) )
crk        ENDIF
crk        IF (CONV) GOTO 333
crk  222   CONTINUE
crk        WRITE (*,1000) IP,AMAX,RLAMBD
crk	WRITE (IOUT,1000) IP,AMAX,RLAMBD
crk  333   DO 5 I=1,nres
crk*         LAM0(IP,I)=ANG(RL(I))
crkCRK zmieniona nastepna linia
crk    5     RRL(I)=ANG(RL(I)+PI)
crk        IF (IPRINT.GT.1) WRITE (IOUT,1010) IP,EOLD,RLAMBD
crk	IF (IPRINT.GT.1) WRITE ( *  ,1010) IP,EOLD,RLAMBD
crkCRK  111 CONTINUE
crk 1000 FORMAT (' Path:',I3,', convergence has not been achieved. AMAX:',
crk     &                F10.5,' Lambda:',1pe12.3)    	  	
crk 1010 FORMAT (' Path ',I3,' energy=',F10.5,' lambda=',f10.5)
crk      RETURN
crk      END           
C*******************************************************************************
      SUBROUTINE DEPEN(IOUT)
      include 'parcom.dat'
*     INTEGER*2 IPATH,NLEFT,ILEFT
      CHARACTER*4 INAMP
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      DO 1 I=1,NFIXED
        II=IFIX(I)
        IF (IPRO(II+1).NE.0) THEN
          DO III=II+1,2,-1
            IF (IPRO(III).EQ.0) GOTO 1
            CALL LAMEVAL(III,1,IPRO(III),IOUT)
          ENDDO 
        ELSE
          CALL LAMEVAL(II,2,IPRO(II),IOUT)
        ENDIF
    1 CONTINUE
      RETURN
      END      
C*******************************************************************************
      FUNCTION ALAM2(I)
      include 'parcom.dat'
      CHARACTER*4 INAMP
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      IF (I.LT.NRES1) THEN
        RL2=ANG(CONV*GAMA(I+2)-RRL(I)-PI)
      ELSE
        RL2=RRL(I)
      ENDIF
      ALAM2=RL2
      RETURN
      END
C*******************************************************************************
      subroutine lameval(ires,ilam,iang,iout)
      include 'parcom.dat'
      real*8 lam1,lam2,lamf
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      dimension xint(100,2),obfun(100,2)
      logical zbieznosc
      phi0=-68.78d0*iang*conv
      nint=0
cd      write (iout,*) (rrl(i),i=1,nres2)
      if (ilam.eq.2) then
        lam1=rrl(ires-1)
cd        write (iout,*) 'ires',ires,' lam1 ',lam1
        lamf=lam1
      else
        lam2=alam2(ires)
cd        write (iout,*) 'ires',ires,' lam2 ',lam2
        lamf=lam2
      endif
      f1=0.0
      if (ilam.eq.1 .and. iang.eq.1) then
        iang1=-90
        iang2=-30
      else if (ilam.eq.1 .and. iang.eq.-1) then
        iang1=30
        iang2=90
      else if (ilam.eq.2) then
        iang1=-180
        iang2=180
      else
        write (iout,*) "From LAMEVAL: Bad ILAM: ",ilam
        stop
      endif
cd      write (iout,*) "lam1",lam1," lam2",lam2
      do i=iang1,iang2,2
        if (ilam.eq.1) then
          lam1=(i+0.0d0)*conv
        else
          lam2=(i+0.0d0)*conv
        endif
cd        write (iout,*) "lam1",lam1," lam2",lam2
        f2=ang(phi(ires,lam1,lam2)-phi0)
cd        print *,i,' lameval,  CONV=',conv,' lam1=',lam1
cd     & ,' phi0=',phi0,' lam2=',lam2,' F2=',f2
cd        write (iout,*) 'x ',i*conv,' f ',f2
        if (f1*f2.lt.0.0d0 .and. abs(f2-f1).lt.20.0d0*conv) then
c	print *,'f1*f2.lt.0.0d0 .and. abs(f2-f1).lt.20.0d0*conv'
          nint=nint+1
          xint(nint,1)=(i-2)*conv
          xint(nint,2)=i*conv
          obfun(nint,1)=f1
          obfun(nint,2)=f2
cd          write (iout,*) 'nint ',nint,' f1 ',f1,' f2 ',f2
c         write (*,*) 'nint ',nint,' f1 ',f1,' f2 ',f2
        endif
        f1=f2
      enddo
      if (nint.eq.0) then
        write (iout,*) 'error - proline impossible to locate'
      endif
c      write (iout,*) 'ires',ires,' ilam',ilam,' nint',nint
      do ii=1,nint
c        write (iout,*) 'x1 ',xint(ii,1),' x2 ',xint(ii,2)
c        write (iout,*) 'f1 ',obfun(ii,1),' f2 ',obfun(ii,2)
        call falsi(ires,ilam,xint(ii,1),xint(ii,2),obfun(ii,1),
     1             obfun(ii,2),lamf,phi0,zbieznosc)
c        write (iout,*) 'x ',xint(ii,1),' f ',obfun(ii,1)
        if (zbieznosc) then
          if (ilam.eq.1) then
            rrl(ires-1)=xint(ii,1)
c        print *,'CRK kat. pro. lameval',ires,' rrl(ires)=',rrl(ires)
c     & ,'xint(ii,1)=',xint(ii,1)
          else
            if (ires.lt.nres1) then
              rrl(ires)=ang(conv*gama(ires+2)-pi-xint(ii,1))
            else
              rrl(ires)=xint(ii,1)
            endif
          endif
          return
        endif
      enddo
c      write (iout,*) "Problems with locating proline, ires: ",ires
      return
      end
****************************************************************************
      double precision function phi(i,rl1,rl2)
      include 'parcom.dat'
      real*8 aksi,aeta
      double precision x,d
      integer natoms,natoms_t,itype,nlint,iref
      common /atoms/ x(maxat,3),natoms,itype(maxat),natoms_t
      common /loc/ d(maxat,3),nlint,iref(maxat,5)
      double precision pi,dwapi,conv,rad2deg,deg2rad,znak
      common /geo/ pi,dwapi,conv,rad2deg,deg2rad
      character*4 inamp
      double precision ksi,eta,gama,theta,alph,rrl,rold1,gama0
      integer nres,nres1,nres2,itres
      common /alph0/ alph0
      common /pept/ nres,nres1,nres2,inamp(maxres),gama(maxres),
     & theta(maxres),alph(maxres),
     & rrl(maxres),ksi(maxres),eta(maxres),
     & rold1(maxres),gama0(maxres),
     & itres(maxres)
C
      tt=thet(i+1,rl1,rl2)*conv
c      write (2,*) 'i',i,' lambda1 ',rl1/conv,' lambda2 ',rl2/conv,
c     1            ' theta ',tt/conv
      i1=4*(i-2)+nres2+1
      i2=i1+5
      aksi=d(i1,2)*conv
      aeta=d(i2,2)*conv
      cosksi=cos(aksi)
      sinksi=sin(aksi)
      coseta=cos(aeta)
      sineta=sin(aeta)
      cosl1=cos(rl1)
      sinl1=sin(rl1)
      cosl2=cos(rl2)
      sinl2=sin(rl2)
      costheta=cos(tt)
      sintheta=sin(tt)
      cosa=cos(alph(i+1)*conv)
      sina=sin(alph(i+1)*conv)
      u1=sinksi
      u2=cosksi*cosl1
      u3=cosksi*sinl1
      a1=cosksi
      a2=-sinksi*cosl1
      a3=-sinksi*sinl1
      b1=costheta*coseta-sintheta*sineta*cosl2
      b2=sintheta*coseta+costheta*sineta*cosl2
      b3=sineta*sinl2
      prod=a1*b1+a2*b2+a3*b3
      v1=b1-prod*a1
      v2=b2-prod*a2
      v3=b3-prod*a3
      vnorm=sqrt(v1*v1+v2*v2+v3*v3)
      v1=v1/vnorm
      v2=v2/vnorm
      v3=v3/vnorm
      uv1=u2*v3-u3*v2
      uv2=v1*u3-u1*v3
      uv3=u1*v2-u2*v1
      cosphi=u1*v1+u2*v2+u3*v3
      znak=uv1*a1+uv2*a2+uv3*a3
      znak=-sign(1.0d0,znak)
c      write (2   ,*) arcos(cosphi)/conv,znak
      phi=znak*arcos(cosphi)
      return
      end
C****************************************************************************
      subroutine falsi(ires,ilam,x1,x2,f1,f2,yy,phi0,zbieznosc)
      include 'parcom.dat'
      real*8 aksi,aeta
      double precision x,d
      integer natoms,natoms_t,itype,nlint,iref
      common /atoms/ x(maxat,3),natoms,itype(maxat),natoms_t
      common /loc/ d(maxat,3),nlint,iref(maxat,5)
      double precision pi,dwapi,conv,rad2deg,deg2rad
      common /geo/ pi,dwapi,conv,rad2deg,deg2rad
      character*4 inamp
      double precision ksi,eta,gama,theta,alph,rrl,rold1,gama0
      integer nres,nres1,nres2,itres
      common /alph0/ alph0
      common /pept/ nres,nres1,nres2,inamp(maxres),
     & gama(maxres),theta(maxres),alph(maxres),
     & rrl(maxres),ksi(maxres),eta(maxres),
     & rold1(maxres),gama0(maxres),
     & itres(maxres)
      real*8 ksid
      common /parpe/ blccd,blcnd,blncd,blnhd,chc,chc1,chn1,chh,cho,
     & ksid,etad,alcnhd,blcod,alccod,alphad,itc1d,itnd,itcd,ithd,itod

      logical zbieznosc
      data maxit /100/, tolx /0.0001d0/ tolf /0.0001d0/
*
* regula falsi method
*      
      do it=1,maxit
        xmed=x1-f1*(x2-x1)/(f2-f1)
        if (ilam.eq.1) then
          fmed=ang(phi(ires,xmed,yy)-phi0)
        else
          fmed=ang(phi(ires,yy,xmed)-phi0)
        endif
c        write (2,*) 'it',it,' xmed ',xmed,' fmed ',fmed
        if ( (abs(xmed-x1).lt.tolx .or. abs(x2-xmed).lt.tolx)
     1       .and. abs(fmed).lt.tolf ) then
          x1=xmed
          f1=fmed
          zbieznosc=.true.
          return
        else if ( fmed*f1.lt.0.0d0 ) then
          x2=xmed
          f2=fmed
        else
          x1=xmed
          f1=fmed
        endif
      enddo
      zbieznosc=.false.
      return
      end
C*******************************************************************************
      FUNCTION ARCOS(X)
      COMMON /GEO/ PI,DWAPI,DEG2RAD,RAD2DEG 
      IF (ABS(X).LT.1.0) GOTO 1
      ARCOS=0.5*(PI+SIGN(1.0,X)*PI)
      RETURN
    1 ARCOS=ACOS(X)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE INCR(IP,N,A,G,X,CONV,AMAX,EOLD,RLAMBD)
      include 'parcom.dat'
      DIMENSION A(maxres+1,maxres+1),X(N),G(N),XX(maxres)
      DIMENSION DX(maxres+1),AOLD(maxres+1,maxres+1)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /GEO/ PI,DWAPI,RAD2DEG
      LOGICAL CONV,FAIL
      DATA TOL /0.00001/, ATOL /0.180/
      RLAMBD=RLAMBD/10.0
      FAC=1.0
      DO I=1,N
        DO J=1,N
          AOLD(I,J)=A(I,J)
        ENDDO
      ENDDO

CRK zmienic energie

      EOLD=PATHENG(IP,N,X)
CRK 
      CALL TRANSFER(N,X,XX)
      DO 10 IMAR=1,10
      AMAX=0.0
      DO I=1,N
        DO J=1,N
          A(I,J)=AOLD(I,J)
        ENDDO
        A(I,I)=A(I,I)*(1.0+RLAMBD)
        DX(I)=G(I)
cd      write (2,*) a(i,i),dx(i)
      ENDDO
CRK      CALL GAUSS(nres,N,nres,A,DX,FAIL)
	CALL GAUSS(nres,nres,nres,A,DX,FAIL)
cd    write (2,*) 'fail=',fail
      IF (FAIL) THEN
CRK	print *,'gauss nie wyszedl'
        RLAMBD=RLAMBD*10.0
        GOTO 10
      ENDIF
      DO 1 I=1,N
cd      write (2,*) i,dx(i)
        IF (ABS(DX(I)).GT.AMAX) AMAX=ABS(DX(I))
    1 CONTINUE
CRK skomentowac nastepna linie;

	print *,'CRK amax=',amax,' rlambd=',rlambd
CRK
      IF (AMAX.GT.ATOL) THEN
*       DO 2 I=1,N
*   2     DX(I)=DX(I)*ATOL/AMAX
        RLAMBD=RLAMBD*10.0
        GOTO 10
      ENDIF
      CONV=(AMAX.LE.TOL.AND.RLAMBD.LE.0.1)
      IF (CONV) RETURN
      DO I=1,N
        X(I)=XX(I)+DX(I)
      ENDDO
*     IF (AMAX.LE.TOL) THEN
*       CONV=.TRUE.
*     ELSE	
*       CALL TRANSFER(N,X,XX)
*       DO 4 IT=1,20
*       DO 3 I=1,N
*   3     XX(I)=ANG(X(I)+FAC*(FAC*DX(I)-(1.0-FAC)*G(I)))
CRK       ENERGY=PATHENG(IP,N,X)
       IF (ENERGY.LE.EOLD .OR. ABS(ENERGY-EOLD).LE.1.0E-4) THEN
          do i=1,n
            g(i)=dx(i)
          enddo
	  EOLD=ENERGY
	  RETURN
       ENDIF
       RLAMBD=RLAMBD*10.0
*      FAC=0.5*FAC
*   4  CONTINUE
*     ENDIF       	  
   10 CONTINUE
      RETURN
      END
C*******************************************************************************
      FUNCTION PATHENG(IP,N,X)
      include 'parcom.dat'
      DIMENSION X(N)
*     INTEGER*2 ITYPE,IREF,IPATH,NLEFT,ILEFT
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      ENERGY=0.0
      DO 4 I=1,N-2
	do 4 j=i,n-1
        ENERGY=ENERGY+ZPLUS(i,j)*COS( X(i)+X(j)-FI0(i,j) ) +
     1               ZMINUS(i,j)*COS( X(i)-X(j)-PSI0(i,j) )
    4 CONTINUE
      PATHENG=ENERGY
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TRANSFER(N,X1,X2)
      DIMENSION X1(N),X2(N)
      DO 1 I=1,N
    1   X2(I)=X1(I)
      RETURN
      END      
C*******************************************************************************
      SUBROUTINE GAUSS(MT,M,N,RO,AP,FAIL)
C
C  Calculates RO**(-1)*AP by the Gauss elimination. RO is a square
C  matrix. The calculated product is stored in AP. Alarm if ro is
C  singular.
C
      LOGICAL FAIL
      DIMENSION RO(MT,M),AP(MT,N)
      IF (M.NE.1) GOTO 10
C
C Case of dimension one.
C
      X=RO(1,1)
      IF (ABS(X).GT.1.E-7) GOTO 111
      FAIL=.TRUE.
      RETURN
  111 X=1.0/X
      DO 16 I=1,N
   16   AP(1,I)=AP(1,I)*X
      RETURN
C
C Case of dimension greater than one. Triangularising the matrix.
C
   10 M1=M-1
      DO 1 I=1,M1
C
C Finding the maximal element in i-th column of RO.
C
        IM=I
        RM=ABS(RO(I,I))
        I1=I+1
        DO 2 J=I1,M
          IF (ABS(RO(J,I)).LE.RM) GOTO 2
          RM=ABS(RO(J,I))
          IM=J
    2   CONTINUE
        IF (IM.EQ.I) GOTO 17
        DO 3 J=1,N
          PR=AP(I,J)
          AP(I,J)=AP(IM,J)
    3     AP(IM,J)=PR
        DO 4 J=I,M
          PR=RO(I,J)
          RO(I,J)=RO(IM,J)
    4     RO(IM,J)=PR
   17   X=RO(I,I)
        IF (ABS(X).GT.1.0E-7) GOTO 112
        FAIL=.TRUE.
        RETURN
  112   X=1.0/X
        DO 5 J=1,N
    5     AP(I,J)=X*AP(I,J)
        DO 6 J=I1,M
    6     RO(I,J)=X*RO(I,J)
        DO 7 J=I1,M
          Y=RO(J,I)
          DO 8 K=1,N
    8       AP(J,K)=AP(J,K)-Y*AP(I,K)
          DO 9 K=I1,M
    9       RO(J,K)=RO(J,K)-Y*RO(I,K)
    7   CONTINUE
    1 CONTINUE
      X=RO(M,M)
      IF (ABS(X).GT.1.0E-7) GOTO 113
      FAIL=.TRUE.
      RETURN
  113 X=1.0/X
      DO 11 J=1,N
   11   AP(M,J)=X*AP(M,J)
      DO 12 I=1,M1
        MI=M-I
        MI1=MI+1
        DO 14 J=1,N
          X=AP(MI,J)
          DO 15 K=MI1,M
   15     X=X-AP(K,J)*RO(MI,K)
   14   AP(MI,J)=X
   12 CONTINUE
      RETURN
      END
******************************************************************************
      SUBROUTINE ALIGN(IOUT)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NL,ILEFT
      REAL LAMBDA
      LOGICAL FAIL
      CHARACTER*4 INAMP
      DIMENSION XX(3),F(3),FF1(10,3),FF2(3),RLL(10)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /LOCAL/ E1(3),E2(3),E3(3),DUM(3),Z(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      COMMON /DRUK/ IPRINT
      COMMON /ELEC/ IEL12
      IDE=1
      IF (IEL12.GT.0) IDE=0
      DO 1 IL=1,NLEFT
        IIL=ILEFT(IL)
        DO 11 I=1,3
   11     XX(I)=0.5*(XYZ(IIL,I)+XYZ(IIL+1,I))
        DO 12 I=1,3
   12     F(I)=0.0
        DO 2 IP=1,NPATH
	  DO 22 II=1,NMEM(IP)
	    IP1=IPATH(IP,II)
            IF (IABS(IP1-IIL).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
   22     CONTINUE	    
    2   CONTINUE
        IF (IIL.LT.NRES1) THEN
          I2=IIL
          I3=IIL+1
          I4=IIL+2
          CALL REFSYS(FAIL,3)
          print *,'REFSYS called from ALIGN fail=',fail
          IF (FAIL) STOP
          F2=SCALAR(E2,F)
          F3=SCALAR(E3,F)
          IF (F2.NE.0.0 .OR. F3.NE.0.0) THEN
            RRL(IIL)=ATAN2(F2,F3)
          ELSE
            RRL(IIL)=PI/2.0
          ENDIF
        ELSE
          I2=IIL+1
          I3=IIL
          I4=IIL-1
          CALL REFSYS(FAIL,3)
          IF (FAIL) STOP
          F2=-SCALAR(E2,F)
          F3=-SCALAR(E3,F)
          IF (F2.NE.0.0 .AND. F3.NE.0.0) THEN
            RRL(IIL)=ATAN2(F2,F3)
          ELSE
            RRL(IIL)=PI/2.0
          ENDIF
        ENDIF
        ENG=332.0*(F2*COS(RRL(IIL))+F3*SIN(RRL(IIL)))
        IF (ENG.GT.0.0) THEN
          RRL(IIL)=ANG(RRL(IIL)+PI)
          ENG=-ENG
        ENDIF
        IF (IPRINT.GT.0) THEN
        WRITE (IOUT,100) iil,(I,F(I),I=1,3),RRL(IIL)/CONV,ENG
        write (*,100) iil,(i,f(i),i=1,3),rrl(iil)/conv,eng
        ENDIF
    1 CONTINUE
*
* Proline handling 1/10/91
*
      IF (NDEP.GT.0 .AND. IPRINT.GT.0) WRITE (IOUT,150)
      DO III=1,NDEP
        NPB=0
        IDI=IDEP(III)
        DO IDII=IDI,2,-1
          IF (IPRO(IDII).EQ.0) GOTO 112 
          NPB=NPB+1
          DO I=1,3
            XX(I)=0.5*(XYZ(IDII-1,I)+XYZ(IDII,I))
          ENDDO
          DO I=1,3
            F(I)=0.0
          ENDDO
          DO IP=1,NPATH
	    DO II=1,NMEM(IP)
	      IP1=IPATH(IP,II)
              IF (IABS(IP1-IDII).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
            ENDDO        
          ENDDO    
          I1=I-1
          I2=I
          I3=I+1
          CALL REFSYS(FAIL,3)
          FF1(NPB,1)=SCALAR(E1,F)
          FF1(NPB,2)=SCALAR(E2,F)
          FF1(NPB,3)=SCALAR(E3,F)
        ENDDO
  112   DO I=1,3
          XX(I)=0.5*(XYZ(IDI,I)+XYZ(IDI+1,I))
        ENDDO
        DO I=1,3
          F(I)=0.0
        ENDDO
        DO IP=1,NPATH
	  DO II=1,NMEM(IP)
	    IP1=IPATH(IP,II)
            IF (IABS(IP1-IP1).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
          ENDDO        
        ENDDO    
        IF (IDI.LT.NRES1) THEN
          I1=I  
          I2=I+1
          I3=I+2
        ELSE
          I1=I+1
          I2=I
          I3=I-1
        ENDIF
        CALL REFSYS(FAIL,3)
        FF2(1)=SCALAR(E1,F)
        FF2(2)=SCALAR(E2,F)
        FF2(3)=SCALAR(E3,F)
        ENOLD=100000.0
*
* Vary the positions of the two peptide bonds at proline, subject to
* the constraint phi(Pro)=+-75 deg (depending on proline chirality),
* in order to achieve an optimum alignment with the field generated
* by the dipole paths. Because in such a case lambda1 is a univocal
* function of lambda2, the latter is chosen as an independent variable.
*
        DO IIA=-180,180,10
          RRL(IDI)=IIA*CONV
          CALL LAMEVAL(IDI,1,IPRO(IDI),IOUT)
          energia=0.0
          do k=idi-1,2,-1
            if (ipro(k).eq.0) goto 111
            call lameval(k,1,ipro(k),iout)
          enddo
  111     do k=idi-1,idi-npb,-1
            cosl1=cos(rrl(k))
            sinl1=sin(rrl(k))
           energia=energia-332.0*(cosl1*ff1(idi-k,2)+sinl1*ff1(idi-k,3))
          enddo
          COSL2=COS(RRL(IDI))
          SINL2=SIN(RRL(IDI)) 
          IF (IDI.LT.NRES1) THEN
            ENERGIA=ENERGIA+332.0*(COSL2*FF2(2)+SINL2*FF2(3))
          ELSE
            ENERGIA=ENERGIA-332.0*(COSL2*FF2(2)+SINL2*FF2(3))
          ENDIF
          IF (ENERGIA.LT.ENOLD) THEN
            ENOLD=ENERGIA
            do kk=1,npb
              rll(kk)=rrl(idi-kk)
            enddo
            RL2=RRL(IDI)
          ENDIF
*         write (*,*) 'rl1 ',rrl(idi-1)/conv,' rl2 ',rrl(idi)/conv,
*     1                ' energy ',energia
        ENDDO
        RL1=RLL(1)
        IF (IPRINT.GT.0)WRITE (2,160) IDI,RL1/CONV,ALAM2(IDI)/CONV,ENOLD
        do kk=1,npb
          rrl(idi-kk)=rll(kk)
        enddo
        RRL(IDI)=RL2
      ENDDO
  100 FORMAT (' Dipole: ',i3/1X,3('F(',I3,')=',1PE11.4,3X)/
     1 ' alignment angle:',0PF10.3,' energy=',1PE11.4) 
  150 FORMAT (/'      PROLINE RESIDUE ALIGNMENT'/
     1         'RESIDUE   LAMBDA1   LAMBDA2      ENERGY'
     2        /'---------------------------------------')
  160 FORMAT (I5,2F10.1,F12.3)
      RETURN
      END                    
******************************************************************************
      SUBROUTINE FIELD(II,RLAMBD,XX,F)
      include 'parcom.dat'
      DIMENSION XX(3),F(3),RIJ(3),P(3)
*     INTEGER*2 ITYPE
      REAL LAMBDA
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /LOCAL/ E1(3),E2(3),E3(3),DUM(3),Z(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      DO 1 I=1,3
    1   RIJ(I)=-0.5*(XYZ(II,I)+XYZ(II+1,I))+XX(I)
      RRIJ=SQRT(SCALAR(RIJ,RIJ))
      DO 2 I=1,3
    2   RIJ(I)=RIJ(I)/RRIJ
      RRIJ=RRIJ**3  
      IF (II.LT.NRES1) THEN
        I2=II
        I3=II+1
        I4=II+2
        CALL REFSYS(FAIL,3)
        SINT=-SIN(RLAMBD)
        COST=-COS(RLAMBD)
        DO 3 I=1,3
    3     P(I)=(COST*E2(I)+SINT*E3(I))/RRIJ
      ELSE
        I2=II+1
        I3=II
        I4=II-1
        CALL REFSYS(FAIL,3)
        SINT=-SIN(RLAMBD)
        COST=-COS(RLAMBD)
        DO 4 I=1,3
    4     P(I)=-(COST*E2(I)+SINT*E3(I))/RRIJ
      ENDIF
      PER=SCALAR(P,RIJ)
      DO 5 I=1,3
    5   F(I)=F(I)-P(I)+3.0*PER*RIJ(I)
      RETURN
      END
******************************************************************************
      SUBROUTINE LOS(IOUT,ISTEP)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      PARAMETER (NUNIT=5)
      INTEGER IUNIT(NUNIT)/1,2,7,8,3/,IRW(NUNIT)/1,4*0/,
     1 IOVRD(NUNIT)/0,0,3*1/
      DIMENSION ROLD(MAXRES)
      CHARACTER*4 INAMP
      LOGICAL FAIL
      INTEGER ipp(maxres,maxres),ipp2(maxres,maxres)
      INTEGER ipa2(maxres,2)
      integer ircz(maxres)
CRK      integer ipa(maxres,3)
      integer ipa(maxres,maxres),np(maxres),nast(maxres),poprz(maxres)
      integer njest(maxres),njest2(maxres)
      character*400 linia,linia2
*
      REAL LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
CRK      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
      COMMON /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
c      double precision ene,eprzed,epo,e0,e00,wsp,epo1,e0old
      double precision e0,e00,epref,cmax
      double precision dyst(30),xdif(maxres,maxres),xeps,dmax
      double precision dmin
      double precision rsamp(maxres,maxres)
      double precision ci(maxres,maxres),cj(maxres,maxres)
      double precision ccij(maxres,maxres)
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /XMIX/ xmi(maxres,maxres),xdif,
     & xmj(maxres,maxres)
*
      print *,'wszedlem do procedury LOS'
*
      xeps=0.3d0
      dmax=4.85d0
      dmin=4.3d0
      cmax=0.23d0
*
      print *,'NRES1=',nres1
	do i=1,nres1
	do j=1,nres1
          ipp(i,j)=0
          ipp2(i,j)=0
          ipa(i,j)=0
	enddo
	enddo
      do i=1,400
       linia(i:i)=' '
       linia2(i:i)=' '
      enddo
*
      do i=1,nres1
        do j=1,nres1
        if(abs(i-j).gt.1) then
         x2=x(i+1,1)-x(i,1)
         y2=x(i+1,2)-x(i,2)
         z2=x(i+1,3)-x(i,3)
         x3=x(j+1,1)-x(j,1)
         y3=x(j+1,2)-x(j,2)
         z3=x(j+1,3)-x(j,3)
         xij=((x(j+1,1)+x(j,1))-(x(i+1,1)+x(i,1)))/2.0d0
         yij=((x(j+1,2)+x(j,2))-(x(i+1,2)+x(i,2)))/2.0d0
         zij=((x(j+1,3)+x(j,3))-(x(i+1,3)+x(i,3)))/2.0d0
         anormij=0.0d0
         anormij=xij*xij+yij*yij+zij*zij
         anormij=sqrt(anormij)
         anormi=0.0d0
         anormi=x2*x2+y2*y2+z2*z2
         anormi=sqrt(anormi)
         anormj=0.0d0
         anormj=x3*x3+y3*y3+z3*z3
         anormj=sqrt(anormj)
         ci(i,j)=(x2*xij+y2*yij+z2*zij)/(anormi*anormij)
         cj(i,j)=(x3*xij+y3*yij+z3*zij)/(anormj*anormij)
         ccij(i,j)=(x2*x3+y2*y3+z2*z3)/(anormi*anormj)
        endif
        enddo
      enddo
*
      nn2=1
      nn=1
      do i=1,nres1
        do j=1,nres1
        ji=abs(j-i)
        if(xmi(i,j).gt.3.0d0.and.ci(i,j).lt.cmax) then
          if(xmi(i,j).lt.dmax.and.xmi(i,j).gt.dmin) then
            ipa2(nn2,1)=i
            ipa2(nn2,2)=j
           nn2=nn2+1
            ipp2(i,j)=1
            ipp2(j,i)=1
          endif
          ii=(xmi(i,j)-3.5d0)*20
        endif
        if(ii.gt.0.and.ii.lt.30) dyst(ii)=dyst(ii)+1
          do k=1,nres1
            kj=abs(k-j)
            ki=abs(k-i)
            if(ki.gt.1.and.kj.gt.1.and.ji.gt.1.and.
     &         xmi(i,j).gt.0.0d0.and.xmi(j,k).gt.0.0d0) then
              xdif(i,k)=(xmj(i,k)-(xmi(i,j)+xmi(j,k)))
        if(xdif(i,k).gt.(-1.0d0*xeps).and.xdif(i,k).lt.(-1.0d-6)
     &   .and.ci(i,j).lt.cmax.and.ci(j,k).lt.cmax) then
                ipa(nn,1)=i
                ipa(nn,2)=j
                ipa(nn,3)=k
                np(nn)=2
                  nast(i)=j
                  nast(j)=k
                  poprz(j)=i
                  poprz(k)=j
               nn=nn+1
                ipp(i,j)=1
                ipp(j,k)=1
                ipp2(i,j)=0
                ipp2(j,k)=0
           endif
              if(abs(xdif(i,k)).gt.xeps) then
                xdif(i,k)=0.0d0
              endif
            endif
          enddo
        enddo
      enddo
*
      do i=1,30
        if(dyst(i).lt.1.0d0) dyst(i)=0.0d0
        print *,(70+i)/20.0d0,' dyst(i)=',dyst(i)
      enddo
*
c      print *,'macierz xdif:'
      write(*,*) 'macierz ipp:'
      do i=1,nres1
        write(*,'(100i3)') (ipp(i,j),j=1,nres1)
      enddo
c      write(*,*) 'macierz ipp2:'
*

CRK sprawdzam, czy 2 trojki sa takie same albo czy 
CRK jest "tylko" przestawiona kolejnosc ("liczenie od tylu") :
*
      npimax=0
      do i=1,nn-1
        do k=3,nres1
         if(ipa(i,k).gt.0) then
          if(nast(ipa(i,k)).gt.0.and.nast(ipa(i,k)).ne.ipa(i,k-1))
     &  then
          ipa(i,k+1)=nast(ipa(i,k))
        endif
        if(poprz(ipa(i,k)).gt.0.and.poprz(ipa(i,k))
     &           .ne.ipa(i,k-1)) then
          ipa(i,k+1)=poprz(ipa(i,k))
          endif
         endif
        if(ipa(i,k).gt.0) np(i)=np(i)+1
        enddo
        if(np(i).gt.npimax) npimax=np(i)
      enddo
*
CRK ta (nastepna) petle trzeba poprawic!!!!

      do i=1,nn-1

c      print *,i,' np(i)=',np(i),' npimax=',npimax

       do j=i+1,nn
        ll=0
        if(np(i).le.np(j)) then
        do l=0,np(i)
         ll=0
          do k=1,np(i)
           if(ipa(i,k).eq.ipa(j,k+l)) ll=ll+1
          enddo
         if(ll.eq.np(i)) then
          do k=1,np(i)
           ipa(i,k)=0
          enddo
          ll=0
         endif
        ll=0
          do k=1,np(i)
           if(ipa(i,k).eq.ipa(j,np(i)+1-k-l)) ll=ll+1
          enddo
         if(ll.eq.np(i)) then
          do k=1,np(i)
           ipa(i,k)=0
          enddo
          ll=0
         endif
        enddo
        endif
        enddo

      enddo
*
CRK koniec sprawdzania
c      do i=1,nn
c        ii=ipa(i,1)
c        ij=ipa(i,2)
c        ik=ipa(i,3)
c        if(ii*ij*ik.gt.0) then
c          print *,ii,ij
c          print *,ij,ik
c        endif
c        print *
c      enddo
CRK
      do i=1,nn
        do j=1,npimax
          if(ipa(i,j).gt.0) njest(ipa(i,j))=ipa(i,j)
        enddo
      enddo
CRK
      kk=1
      write(linia(1:8),'(a8)') 'select ('
      do i=1,nres1
        if(njest(i).gt.0) then 
          write(linia(5+kk*4:8+kk*4),'(i3,a1)') njest(i),','
          kk=kk+1
        endif
      enddo
      write(*,'(a400)') linia
CRK
      do i=1,nn2
      ll=0
       i1=ipa2(i,1)
       i2=ipa2(i,2)
       do k=1,2
        do j=1,nres1
         if(ipa2(i,k).eq.njest(j).and.njest(j).gt.0) ipa2(i,k)=0
        enddo
       enddo
       do j=i+1,nn2
         if(i1.eq.ipa2(j,1).and.i2.eq.ipa2(j,2)) then
           ipa2(j,1)=0
           ipa2(j,2)=0
         endif
         if(i1.eq.ipa2(j,2).and.i2.eq.ipa2(j,1)) then
           ipa2(j,1)=0
           ipa2(j,2)=0
         endif
       enddo
      enddo
*
      do i=1,nres1
        write(*,'(a6,2(i4,a1))') 'ipa2: ',(ipa2(i,j),',',j=1,2)
      enddo
      do i=1,nn2
        do j=1,2
          if(ipa2(i,j).gt.0) njest2(ipa2(i,j))=ipa2(i,j)
        enddo
      enddo
      kk=1
      write(linia2(1:8),'(a8)') 'select ('
      do i=1,nres1
        if(njest2(i).gt.0) then
          write(linia2(5+kk*4:8+kk*4),'(i3,a1)') njest2(i),','
          kk=kk+1
        endif
      enddo
      write(*,'(a400)') linia2
CRK
      do i=1,nres1
        write(*,'(100i3)') (ipp2(i,j),j=1,nres1)
      enddo
c        ipp2sum=0
c        do j=i+1,nres1
c         ipp2sum=ipp2sum+ipp2(i,j)
c        enddo
c        print *,'IPP2_SUM=',ipp2sum
c        if(ipp2sum.gt.2) print *,'IPP2_SUM>2 ! , IPP2_SUM=',ipp2sum
      print *,'wydruk ipa:'
      do i=1,nres1
        write(*,'(a5,20(i4,a1))') 'ipa: ',(ipa(i,j),',',j=1,npimax)
      enddo

C###
      do i=1,nres1
       if(abs(gama(i)).lt.40.0d0) 
     &   print *,i-3,i-2,i-1,i,'gama(i)=',gama(i)
      enddo
C###
CRK --------------------- eksperyment -------------------
CRK                  (powinno byc dane i j)
CRK ------------------ najpierw trojki ------------------
      do ii=1,nn
       do jj=1,np(ii)
       i=ipa(ii,jj)
       j=ipa(ii,jj+1)
       if(i.eq.0.or.j.eq.0) goto 12
       if(jj.eq.np(ii)) then
         i=ipa(ii,jj)
         j=ipa(ii,jj-1)
       endif
c       do i=1,nres1
        ircz(i)=0
        x2=x(i+1,1)-x(i,1)
        y2=x(i+1,2)-x(i,2)
        z2=x(i+1,3)-x(i,3)
        x1=x(i+2,1)-x(i+1,1)
        y1=x(i+2,2)-x(i+1,2)
        z1=x(i+2,3)-x(i+1,3)
c        x3=x(j+1,1)-x(j,1)
c        y3=x(j+1,2)-x(j,2)
c        z3=x(j+1,3)-x(j,3)
        xil=y1*z2-y2*z1
        yil=x2*z1-x1*z2
        zil=x1*y2-x2*y1
        anorm=0.0d0
        anorm=xil*xil+yil*yil+zil*zil
        anorm=sqrt(anorm)
c       do j=1,nres1
       if(abs(j-i).gt.1) then
        xij=((x(j+1,1)+x(j,1))-(x(i+1,1)+x(i,1)))/2.0d0
        yij=((x(j+1,2)+x(j,2))-(x(i+1,2)+x(i,2)))/2.0d0
        zij=((x(j+1,3)+x(j,3))-(x(i+1,3)+x(i,3)))/2.0d0
        anormij=0.0d0
        anormij=xij*xij+yij*yij+zij*zij
        anormij=sqrt(anormij)
        cl=(xij*xil+yij*yil+zij*zil)/(anorm*anormij)
CRK lambda(i) = pi/2+arcos(cl) jesli 0<arcos(cl)<pi/2
        rsamp(i,j)=pi/2.0d0-arcos(cl)
C        print *,i,' PROC. LOS rrl(i)pocz.=',rrl(i)
          rrl(i)=pinorm(pi/2.0-arcos(cl))
          ircz(i)=1
         if(jj.eq.np(ii)) then
           rrl(i)=pinorm(pi/2.0-arcos(cl))
           ircz(i)=1
         endif
C        if(jj.eq.2) rrl(j)=pinorm(rsamp(i,j))
c        print *,i,' PROC. LOS rrl(i)=',rrl(i)
c        print *,i,j,' CL=',cl,pinorm(rsamp(i,j))/conv
CRK       write (*,*) arcos(cl)/conv
        endif
 12    continue
       enddo
      enddo
C
      do ii=1,nn
      e0=0.0d0
      e00=0.0d0
       i=ipa(ii,1)
       j=ipa(ii,2)
       k=ipa(ii,3)
       if(i*j*k.eq.0) goto 21
       rrl1=rrl(i)
       rrl2=rrl(j)
       rrl3=rrl(k)
c       if(abs(rrl1-rrl(i-1)).gt.3.0*pi/4.0d0) then
c          epref=-3.0d1
c        else
c          epref=3.0d1
c       endif
       i1=i
       call POT_LOCALMC(IOUT,ISTEP)
c       print *,i,j,k,' ELOC=',eloc
       e0=e0+eloc
       i1=j
       call POT_LOCALMC(IOUT,ISTEP)
       e0=e0+eloc
       i1=k
       call POT_LOCALMC(IOUT,ISTEP)
       e0=e0+eloc
c       rrl(i)=pinorm(rrl(i)+pi)
c       rrl(j)=pinorm(rrl(j)+pi)
c       rrl(k)=pinorm(rrl(k)+pi)
       i1=i
       call POT_LOCALMC(IOUT,ISTEP)
       e00=e00+eloc
       i1=j
       call POT_LOCALMC(IOUT,ISTEP)
       e00=e00+eloc
       i1=k
       call POT_LOCALMC(IOUT,ISTEP)
       e00=e00+eloc
c         print *,i,j,k,' e00-e0= ',e00-e0,e00-(e0+epref)
       if(e00.ge.e0+epref) then
c         rrl(i)=rrl1
c         rrl(j)=rrl2
c         rrl(k)=rrl3
       endif
 21   continue
      enddo
C ------------------ teraz pary, ktore nie naleza do trojek -------------
*
      do ii=1,nn2
       irzmien=0
       do jj=1,2
       i=ipa2(ii,jj)
       j=ipa2(ii,jj+1)
       if(i.eq.0.or.j.eq.0.or.ircz(i).eq.1.or.ircz(j).eq.1) goto 13
       if(jj.eq.2) then
         i=ipa2(ii,jj)
         j=ipa2(ii,jj-1)
       endif
        ircz(i)=0
        x2=x(i+1,1)-x(i,1)
        y2=x(i+1,2)-x(i,2)
        z2=x(i+1,3)-x(i,3)
        x1=x(i+2,1)-x(i+1,1)
        y1=x(i+2,2)-x(i+1,2)
        z1=x(i+2,3)-x(i+1,3)
        xil=y1*z2-y2*z1
        yil=x2*z1-x1*z2
        zil=x1*y2-x2*y1
        anorm=0.0d0
        anorm=xil*xil+yil*yil+zil*zil
        anorm=sqrt(anorm)
c       do j=1,nres1
       if(abs(j-i).gt.1) then
        xij=((x(j+1,1)+x(j,1))-(x(i+1,1)+x(i,1)))/2.0d0
        yij=((x(j+1,2)+x(j,2))-(x(i+1,2)+x(i,2)))/2.0d0
        zij=((x(j+1,3)+x(j,3))-(x(i+1,3)+x(i,3)))/2.0d0
        anormij=0.0d0
        anormij=xij*xij+yij*yij+zij*zij
        anormij=sqrt(anormij)
        cl=(xij*xil+yij*yil+zij*zil)/(anorm*anormij)
*
c        print *,i,' PROC. pLOS rrl(i)pocz.=',rrl(i)

          rrl(i)=pinorm(pi/2.0-arcos(cl))
        if(jj.eq.2) then
           rrl(i)=pinorm(pi/2.0-arcos(cl))
        endif
c        rrl(i)=pinorm(pi/2.0-arcos(cl))
        i1=i
        call POT_LOCALMC(IOUT,ISTEP)
        eprzed=eloc
        rrlold=rrl(i)
        rrl(i)=pinorm(rrl(i)+pi)
        call POT_LOCALMC(IOUT,ISTEP)
        epo=eloc
        irzmien=1
        if(epo.gt.eprzed) then
          rrl(i)=rrlold
          irzmien=0
        endif
CRK        ircz(i)=1
         if(jj.eq.2) then
           rrl(i)=pinorm(3.0*pi/2.0+arcos(cl))
           if(irzmien.eq.1) rrl(i)=pinorm(pi/2.0+arcos(cl))
CRK           ircz(i)=1
         endif
        print *,i,j,' CL=',cl,pinorm(pi/2.0-arcos(cl))/conv
        endif
 13    continue
       enddo
      enddo
*
C ------------------------ koniec 'parowania' ---------------------------
      do i=1,nres1
        i1=i
        call POT_LOCALMC(IOUT,ISTEP)
	print *,i,' ELOC=',ELOC,' ircz(i)=',ircz(i)
      enddo
CRK --------------------- eksperyment -------------------
*
          CALL MINIMIZE(iretcode,nfun)
          CALL ENERGY(iout,istep)
        print *,'energia po minimize=',eng,' iretcode=',iretcode
*
CRK      stop
      RETURN
      END
******************************************************************************
      SUBROUTINE METROPOLIS(IOUT,ISTEP)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      PARAMETER (NUNIT=5)
      INTEGER IUNIT(NUNIT)/1,2,7,8,3/,IRW(NUNIT)/1,4*0/,
     1 IOVRD(NUNIT)/0,0,3*1/
      INTEGER ilos(maxres)
      DIMENSION ROLD(MAXRES)
      CHARACTER*4 INAMP
      LOGICAL FAIL
      double precision LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      double precision alph0(maxres)
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
      common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      double precision ene,eprzed,epo,e0,wsp,epo1,e0old
      double precision odch(maxres),odmax,walph,odmaxold
      double precision eph1,xeph,rrl0(maxres),errl,ods,xg
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      common /it/ it
CRK        print *,'bylem w METROPOLIS'
*
        elow=9.999999d6
        eprzed=9.999999d6
*
        dlam=0.21d0
        dlam0=dlam
crk        walph=0.20d0
CRK dla testow zmienilem jmax=10000
        jmax=10000
crk        jmax=20
        if(it.gt.1) then
          dlam=0.05d0
          goto 222
        endif
CRK
c      CALL LOS(IOUT,ISTEP) 
CRK
	if(nseed.eq.0) nseed=-39685457
	nseed=1000000*rand(nseed)
C	if(istep.eq.1) then
*
	nfixed=0
	do i=1,nres2
	nseed=1000000*rand(nseed)
        if(ipro(i+1).eq.0) rrl(i)=pinorm(pi*rand(nseed))
	if(ipro(i+1).eq.1) then
C       nseed=1000000*rand(nseed)
        nseed=nseed+1
	rrl(i+1)=pinorm(pi*rand(nseed))
	  nfixed=nfixed+1
C	  print *,'wywoluje lameval: ',i
	  call lameval(i+1,1,ipro(i+1),iout)
C	  print *,'wyszedlem z lameval:',i
	endif
	enddo

        do i=1,nres1
         if(ipro(i+1).eq.0) then
             rrl(i)=-0.90d0*pi/2.0
c           if(abs(gama(i-1)).lt.10.0d0)  rrl(i)=0.90d0*pi/2.0
c             print *,i,'CRK drukuje gama(i)',gama(i)
         endif
         ilos(i)=0
        enddo
        do i=1,nres1
           rrl0(i)=rrl(i)
c         i1=i
c         call energymc(iout,istep)
        enddo
ccc        write(*,'(a8,150f12.8)') 'lambda: ',(rrl(k),k=1,nres1)
ccc        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
*
        call ENERGY(iout,istep)
        e0=eng
        open(14,file='energia.dip')
        write(14,*) e0
	e0old=e0
CRK         print *,'NFIXED=',nfixed,' ENERGY=',e0
*
CRK
CRK ------------------ dalszy ciag eksperymentu: ---------------------
c      DO K=1,NRES
c        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
c      ENDDO
c      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
c      DO K=1,NRES2
c        D(K,2)=THETA(K)
c        D(K,3)=GAMA(K)
c      ENDDO
c      CALL CART(FAIL)
c        ipun=iunit(3)
c      CALL FIPSI(IOUT,IPUN)
c          igeom=iunit(4)
c          write(igeom,*) 'Wspolrzedne poczatkowe'
c          CALL PDBOUT(igeom)
c          print *,'CRK zapisuje zbior pdb: (krok)',j
CRK koniec "tymczasowego" generowania pdb
CRK ------------------------------------------------------------------
CRK   chwilowo wylaczam      CALL LOS(IOUT,ISTEP)
crk      STOP
CRK ------------------ dalszy ciag eksperymentu: ---------------------
c      DO K=1,NRES
c        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
c      ENDDO
c      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
c      DO K=1,NRES2
c        D(K,2)=THETA(K)
c        D(K,3)=GAMA(K)
c      ENDDO
c      CALL CART(FAIL)
c	ipun=iunit(3)
c      CALL FIPSI(IOUT,IPUN)
c          igeom=iunit(4)
c          CALL PDBOUT(igeom)
c	  print *,'CRK zapisuje zbior pdb: (krok)',j
CRK koniec "tymczasowego" generowania pdb
CRK ------------------------------------------------------------------
CRK      STOP
CRK ------------------------------------------------------------------
*
       if(IT.gt.1) goto 121
	nseed=1000000*rand(nseed+1)
	jj=jmax/4
        dlam0=0.10d0
          do j=1,jj
c          wsp=1.0d0*(jj-j)/(jj-1)
c          dlam=dlam0*(j-1)/(jj-1)+0.05d0
           wsp=0.5d0
crk           dlam=dlam0/4.0d0
            do i=1,nres1
              eprzed=0.0d0
              epo=0.0d0
             if(ipro(i+1).eq.1) then
C              nseed=1000000*rand(nseed)
               nseed=nseed+1
               rrlold1=rrl(i+1)
               rrlold=rrl(i)
               i1=i+1
               call ENERGYMC(iout,istep)
      errl=(rrl(i+1)-rrl0(i+1))*(rrl(i+1)-rrl0(i+1))
               eprzed=wsp*(ealph+4.0d1*edip+5.0d0*errl)+eng
               rrl(i+1)=rrl(i+1)+(rand(nseed)-0.5)*2.0*pi*dlam
      errl=(rrl(i+1)-rrl0(i+1))*(rrl(i+1)-rrl0(i+1))
               call lameval(i+1,1,ipro(i+1),iout)
               call ENERGYMC(iout,istep)
               epo=wsp*(ealph+4.0d1*edip+5.0d0*errl)+eng
               if(epo.gt.eprzed) then
                 rrl(i)=rrlold
                 rrl(i+1)=rrlold1
               endif
             endif
CRK
	     if(ipro(i+1).eq.0) then
crk            kk=rand(nseed)*nres2
            I1=i
           rrlold1=rrl(i)
      errl=(rrl(i)-rrl0(i))*(rrl(i)-rrl0(i))
          call ENERGYMC(iout,istep)
*
crk      print *,'ealph',wsp*(ealph)
crk      print *,'edip',wsp*(4.0d1*edip)
crk      print *,'errl',wsp*(5.0d0*errl)
crk      print *,'eng',eng
*
          eprzed=wsp*(ealph+4.0d1*edip+5.0d0*errl)+eng
crk      print *,'eprzed',eprzed
           rrl(i)=rrl(i)+(rand(nseed)-0.5)*2.0*pi*dlam
           rrl(i)=pinorm(rrl(i))
      errl=(rrl(i)-rrl0(i))*(rrl(i)-rrl0(i))
          call ENERGYMC(iout,istep)
*
crk      print *,'ealph',wsp*(ealph)
crk      print *,'edip',wsp*(4.0d1*edip)
crk      print *,'errl',wsp*(5.0d0*errl)
crk      print *,'eng',eng
*
          epo=wsp*(ealph+4.0d1*edip+5.0d0*errl)+eng
c            dalph=abs(alph(i)-alph0(i))
c            dalph2=abs(alph(i+1)-alph0(i+1))
c      if(epo.ge.eprzed.or.dalph.gt.5.0d0.or.dalph2.gt.3.0d0) then
       if(epo.ge.eprzed) then
              rrl(i)=rrlold1
            endif
C              nseed=1000000*rand(nseed)
              nseed=nseed+1
	      endif
            enddo
        if(epo-eprzed.lt.0.0) then
        write(14,*) epo
ccc      write(*,'(a6,i6,a9,f15.10)') 'CRK j=',j,' delta.E=',epo-eprzed
ccc        write(*,'(a8,150f12.8)') 'lambda: ',(rrl(k),k=1,nres1)
ccc        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
	endif
          enddo
CRK
	nseed=1000000*rand(nseed)
	jtys=1000
        jj=jmax/5
          do j=1,jj
	if(epo-eprzed.lt.0.0) then
c      write(*,'(a6,i6,a9,f15.10,a9,f15.4)') 'CRK j=',j,
c     & ' delta.E=',epo-eprzed,' E.tot. =',e0
	endif
            do i=1,nres2
	      eprzed=0.0d0
	      epo=0.0d0
	      epo=0.0d0
 111           kk=rand(nseed)*nres2
            I1=kk
        if(ipro(kk+1).eq.1) then
C          nseed=1000000*rand(nseed)
           nseed=nseed+1
               rrlold1=rrl(kk+1)
               rrlold=rrl(kk)
               i1=kk+1
               call ENERGYMC(iout,istep)
       errl=(rrl(kk+1)-rrl0(kk+1))*(rrl(kk+1)-rrl0(kk+1))
               eprzed=(ealph+4.0d1*edip+5.0d0*errl)+eng
               rrl(kk+1)=rrl(kk+1)+(rand(nseed)-0.5)*2.0*pi*dlam
               call lameval(kk+1,1,ipro(kk+1),iout)
               call ENERGYMC(iout,istep)
       errl=(rrl(kk+1)-rrl0(kk+1))*(rrl(kk+1)-rrl0(kk+1))
               epo=(ealph+4.0d1*edip+5.0d0*errl)+eng
               if(epo.ge.eprzed) then
                 rrl(kk)=rrlold
                 rrl(kk+1)=rrlold1
               endif
        endif
CRK
	   if(ipro(kk+1).eq.0) then
C	print *,'proc. ME. kk=',kk
	  if(kk.eq.0) goto 111
           rrlold1=rrl(kk)
          i1=kk
          call ENERGYMC(iout,istep)
        errl=(rrl(kk)-rrl0(kk))*(rrl(kk)-rrl0(kk))
          eprzed=(ealph+4.0d1*edip+5.0d0*errl)+eng
           rrl(kk)=rrl(kk)+(rand(nseed)-0.5)*2.0*pi*dlam
	   rrl(kk)=pinorm(rrl(kk))
          call ENERGYMC(iout,istep)
        errl=(rrl(kk)-rrl0(kk))*(rrl(kk)-rrl0(kk))
          epo=(ealph+4.0d1*edip+5.0d0*errl)+eng
	  e0old=e0
c          print *,'eprzed',eprzed,' epo',epo,' e0',e0
	  e0=e0+epo-eprzed
c            dalph=abs(alph(i)-alph0(i))
c            dalph2=abs(alph(i+1)-alph0(i+1))
c      if(epo.ge.eprzed.or.dalph.gt.3.0d0.or.dalph2.gt.3.0d0) then
       if(epo.ge.eprzed) then
              rrl(kk)=rrlold1
	      e0=e0old
c      print *,'eprzed',eprzed,' epo',epo,' e0',e0,'e0old',e0old
            endif
C              nseed=1000000*rand(nseed)
              nseed=nseed+1
	     endif
            enddo
CRK
	if(j.eq.jtys) then
          nseed=1000000*rand(nseed)
CRK-------------------------------------------------------------------------
*
*  Build up the table of internal coordinates.
*
      DO K=1,NRES
        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
      ENDDO
      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
      DO K=1,NRES2
        D(K,2)=THETA(K)
        D(K,3)=GAMA(K)
      ENDDO

      CALL CART(FAIL)
*  diagnostics
 1111 format (' alpha(',i3,',',i3,',',i3,')=',f10.3)
*
*  Calculate and print fi and psi angles.
*
	ipun=iunit(3)
      CALL FIPSI(IOUT,IPUN)
*
* Write final Cartesian coordinates in .pdb format
c          igeom=iunit(4)
          CALL PDBOUT(igeom)
CRK          print *,'CRK zapisuje zbior pdb: (krok)',j
CRK-------------------------------------------------------------------------
	jtys=jtys+1000
	endif
ccc        if(epo-eprzed.lt.0.0) then
ccc          write(*,'(a6,i6,a9,f15.10,a9,f15.4)') 'CRK j=',j,
ccc     &     ' delta.E=',epo-eprzed,' E.tot. =',e0
ccc        write(*,'(a8,150f12.8)') 'lambda: ',(rrl(k),k=1,nres1)
ccc        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
ccc        endif
	enddo

C	endif	
CRK ------------------------------------------------------------------
CRK ------------------------------------------------------------------
*
crk  222     stop

 222        call energy(iout,istep) 
         ealph=0.0d0
         dlam=dlam0
*
         call ALPHEV(IOUT)
         do i=1,nres1
           ealph=ealph+(alph(i)-alph0(i))*(alph(i)-alph0(i))
crk           rrl0(i)=rrl(i)
         enddo
         eng=eng+0.8d1*ealph
crk           eng=eng+0.20d0*ealph
         eprzed=eng
*  
CRK         print *,j,' Energia0=',eng
         jj=jmax/5
         do j=1,jj
C?
crk             dlam=odmax/0.80d3
crk             walph=4.0d0/odmax

C?
           do i=1,nres1
             rold(i)=rrl(i)
           enddo
           do i=1,nres1
             i1=i
crk            ilos=i
c           ilos=nres1*rand(nseed+i)
              if(ilos(i).eq.1) then
crk                 print *,i
crk         print *,'odch(i)=',abs(odch(i))
c1             if(abs(odch(i)/3.5d2).gt.dlam) then
c1          rrl(i)=rrl(i)+(rand(nseed)-0.5)*pi*abs(odch(i))/3.5d2
c1               else
            if(j.gt.jj/3) dlam=dlam*0.8d0
          rrl(i)=rrl(i)+(rand(nseed)-0.5)*pi*dlam*1.00d0
          rrl(i)=pinorm(rrl(i))
c1             endif
crk      print *,i,' dlama=',dlam,' odch(i)=',odch(i),odch(i)/dlam
              endif
crk             do ll=ilos,nres1
crk               i1=ll
crk               call ALPHEV(IOUT,I1)
c               call l2ev(iout,i1)
crk             enddo
           enddo
*
           ealph=0.0d0
           eph1=0.0d0
           errl=0.0d0
           ods=0.0d0
           call ALPHEV(IOUT) 
crk           odmaxold=odmax
           odmax=0.0d0
           jlos=0

           do i=1,nres1
            odch(i)=0.0d0
            odch(i)=(alph(i)-alph0(i))
            if(abs(odch(i)).gt.odmax) then
              odmax=abs(odch(i))
              iodmax=i
            endif
            xeph=0.0d0
            xeph=abs(odch(i))
            xeph=xeph*xeph
            ods=ods+xeph
            errl=errl+(rrl(i)-rrl0(i))*(rrl(i)-rrl0(i))
            ealph=ealph+xeph
            eph1=eph1+xeph*xeph
           enddo
           do i=1,nres1
             ilos(i)=0
crk             if(abs(odch(i)).gt.0.20d0*odmax) then
crk             if(abs(odch(i)).gt.1.0d0) then
c             if(j.gt.jj/10.and.j.lt.jj/5) then
c               xg=0.1d0*(cos(j*pi*1.0d1/jj)+1.0d0)
c             else
c               xg=0.0d0
c             endif
c             if(abs(odch(i)).gt.xg) then
               ilos(i)=1 
               jlos=jlos+1
c             endif
           enddo
*
           call energy(iout,istep)
crk           write(*,'(2(a6,f8.5))') 'walph=',walph,' dlam=',dlam
*
      ealph=sqrt(ealph)
      errl=sqrt(errl)
*
ccc      print *,'drukuje energie:'
ccc      print *,j,' eng=',eng
ccc      print *,'walph*1.0d2*ealph',walph*1.0d2*ealph
ccc      print *,'walph*0.5d2*errl',walph*0.5d2*errl
ccc      print *,'walph*2.0d2*odmax',walph*2.0d2*odmax
ccc      print *,'walph*3.5d0*ods',walph*3.5d0*ods
*
crk
c      eng=eng+walph*(1.0d2*ealph+2.0d2*errl
c     & +2.0d2*odmax+3.5d0*ods)
      eng=eng+walph*(1.0d2*ealph+1.0d2*errl
     & +2.0d2*odmax+3.0d0*ods)*0.10d0
crk      if(i.eq.1.and.j.eq.1) eprzed=eng
ccc      print *,'epo=',epo,' eprzed=',eprzed
*

c        write(*,'(a8,150f12.8)') 'lambda: ',(rrl(k),k=1,nres1)
c        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
          j100=j/100
          j100=j100*100
c        if(j100.eq.j) print *,j,' ENERGIA=',eng,ealph
           epo=eng
           if(epo.gt.eprzed) then
            do ii=1,nres1
               rrl(ii)=rold(ii)
            enddo
           endif
           if(odmax.lt.odmaxold) odmaxold=odmax
c           if(j.eq.ilos) then
c             eprzed=eng
c             print *,j,' Energia dla j=1 ',eprzed
c           endif
           if(epo.lt.eprzed) then
           e0=e0+epo-eprzed
ccc      write(*,'(i5,a10,3f10.3,i5)') j,' ENERGIA1=',epo,ealph,odmax,jlos
ccc        print *,'Lambda 2 wyliczana krok j=',j
ccc      write(*,'(a6,i6,a9,f15.10)') 'CRK j=',j,' delta.E=',epo-eprzed
ccc        write(*,'(a8,150f12.8)') 'lambda: ',(rrl(k),k=1,nres1)
ccc        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
             eprzed=epo
           endif
           write(14,*) e0
         enddo
CRK
CRK ------------------ dalszy ciag eksperymentu: ---------------------
      DO K=1,NRES
        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
      ENDDO
      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
      DO K=1,NRES2
        D(K,2)=THETA(K)
        D(K,3)=GAMA(K)
      ENDDO
      CALL CART(FAIL)
        ipun=iunit(3)
      CALL FIPSI(IOUT,IPUN)
          igeom=iunit(4)
c          write(igeom,*) 'REMARK Wspolrzedne po L2EV'
CRK        write(*,*) 'Wspolrzedne po L2EV'
*
ccc      do k=1,natoms
ccc        write(*,*) 'CRK x,y,z',x(k),y(k),z(k) 
ccc      enddo
*
c          CALL PDBOUT(igeom)
c        write(*,'(a8,150f12.6)') 'alpha:  ',(alph(k),k=1,nres1)
CRK          print *,'CRK zapisuje zbior pdb: (krok)',j

*
*       call setup
*       call gener
*


CRK koniec "tymczasowego" generowania pdb
CRK ------------------------------------------------------------------
*
 121    RETURN 
CRK        STOP
*
CRK 121    RETURN
	END  
******************************************************************************
      SUBROUTINE EALPHMC(iout,istep,ii)
*
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      CHARACTER*4 INAMP
      LOGICAL FAIL
c      double precision eng,eloc,evdw,elow,edip,eijold
      double precision walph,ealphi,deltaa
      integer nseed
      double precision LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      double precision alph0(maxres)
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      common /contact/ ncont(maxres),icont(maxres,20),econt(maxres,20)
      dimension itel(maxat)
      logical dumy
CRK
crk      write(iout,*) 'wszedlem do proc. ealphmc'
crk      write(iout,'(a6,200f12.7)') 'ALPH0=',(alph0(i),i=1,nres2)
*
      ealph=0.0d0
      walph=5.0d0
crk      print *,'proc. elaphmc, ii=',ii
c      call alphev(iout,ii)
*
crk      write(iout,'(a6,200f12.7)') 'ALPH0=',(alph0(i),i=1,nres2)
*

      imin=ii
      imax=ii+1
*
      if(imin.le.2) then
        imin=2
        imax=2
      endif
      if(imax.ge.nres1) then
        imax=nres1
        imin=nres1
      endif
      do i=imin,imax
       call alphev(iout,i)
c       print *,ii,' wartosci "i" ealphi=walph*deltaa*deltaa', i
       deltaa=(alph(i)-alph0(i))
       ealphi=walph*deltaa*deltaa
       ealph=ealph+ealphi
      enddo 
c      print *,ii,' ealph=',ealph
*
      RETURN
      END
******************************************************************************
      SUBROUTINE ENERGYMC(iout,istep)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      CHARACTER*4 INAMP
      LOGICAL FAIL
      double precision eng,eloc,evdw,elow,edip,eijold
      double precision cutoff
      integer nseed,lcut(maxres,maxres)
      double precision LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      common /contact/ ncont(maxres),icont(maxres,20),econt(maxres,20)
      dimension itel(maxat)
      logical dumy
      common /cut/ cutoff,lcut
*
	CALL POT_LOCALMC(IOUT,ISTEP)
        CALL EALPHMC(iout,istep,i1)
*
	eold=eng
	eng=0.0
	j=I1
C	print *,' j w procedurze energy_mc',j
*
C
      nnt=1
      if (inamp(1).eq.'TER') nnt=2
      nct=nres2
      if (inamp(nres2).eq.'TER') nct=nres1
      do i=nnt,nct-1
        if (inamp(i+1).eq.'PRO') then
          itel(i+1)=3
        else
          itel(i+1)=2
        endif
	if(inamp(i+1).eq.'GLY') itel(i+1)=1
      enddo
C
*
CRK---------------------------
crk        do i=1,nres1
CRK      print *,i,' ipro=',ipro(i),' inamp=',inamp(i),'nres1=',nres1
crk        ncount=0
crk        if(abs(i-j).gt.1) then
crk 22          eneij=zplus(i,j)*COS(RRL(i)+RRL(j)-FI0(i,j))
crk     &          +zminus(i,j)*COS(RRL(i)-RRL(j)-PSI0(i,j))
crk          eng=eng+eneij
C       print *,'ij',i,j,' eneij',eneij,' zp zm',zplus(i,j),zminus(i,j)
crk          endif
crk         enddo
CRK---------------------------
        eng=0.0d0
        do i=1,nres1-1
          eneij=0.0d0
          if(lcut(i1,i).eq.1) then
          if(i1.gt.i+2) eneij=zplus(i,i1)*COS(RRL(i)+RRL(i1)-FI0(i,i1))
     &          +zminus(i,i1)*COS(RRL(i)-RRL(i1)-PSI0(i,i1))
          eng=eng+eneij
          endif
        enddo
        do j=i1+2,nres1
          eneij=0.0d0
          if(lcut(i1,i).eq.1) then
          eneij=zplus(i1,j)*COS(RRL(i1)+RRL(j)-FI0(i1,j))
     &          +zminus(i1,j)*COS(RRL(i1)-RRL(j)-PSI0(i1,j))
          eng=eng+eneij
          endif
        enddo

c       print *,'energia e.s. =',eng,' ealph=',ealph,'eloc=',eloc
	edip=eng
	eng=eng+eloc
*
C	print *,'energia calkowita (lacznie z eloc)=',eng,' Emin=',elow
*
      RETURN
	END
******************************************************************************
	SUBROUTINE POT_LOCALMC(IOUT,ISTEP)
C
      include 'parcom.dat'
      CHARACTER*4 INAMP
      LOGICAL FAIL
	double precision b(84,2),xxpro,x0pro,rrpro,Eloci
      REAL LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
	dimension itel(maxat)
C
	Eloc=0.0
C
	do i=1,84
	  b(i,1)=bag1(i)
	  b(i,2)=bag2(i)
	enddo
C
      nnt=1
      if (inamp(1).eq.'TER') nnt=2
      nct=nres2
      if (inamp(nres2).eq.'TER') nct=nres1
      do i=nnt,nct-1
        if (inamp(i+1).eq.'PRO') then
          itel(i+1)=3
        else
          itel(i+1)=2
        endif
	if(inamp(i+1).eq.'GLY') itel(i+1)=1
      enddo
C
c      print *,'Pro. pot_locmc i1= ',i1
C
	jj=I1+1
	imin=jj-1
	imax=jj
	if(imin.lt.2) imin=2
	if(imax.gt.nres1) then
          imax=nres1
          imin=imax-1
        endif
C
	do i=imin,imax
	  ga2=RRL(i-1)
	  ga1=alam2(i)

	  j=itel(i)
	if(ipro(i).eq.1) then
CRK 	  CALL LAMEVAL(i,1,IPRO(i),IOUT)
	  ga1=rrl(i)
	  goto 10
	endif
	Eloci=0.0d0

       Eloci=Eloci+b(2,j)*cos(ga1)+b(3,j)*cos(ga2)
     & +b(4,j)*sin(ga1)+b(5,j)*sin(ga2)
     & +b(6,j)*cos(2.0*ga1)+b(7,j)*cos(2.0*ga2)+b(8,j)*sin(2.0*ga1)
     & +b(9,j)*sin(2.0*ga2)+b(10,j)*cos(ga1+ga2)+b(11,j)*cos(ga1-ga2)
     & +b(12,j)*sin(ga1+ga2)+b(13,j)*sin(ga1-ga2)
     & +b(14,j)*cos(3.0*ga1)+b(15,j)*cos(3.0*ga2)
     & +b(16,j)*sin(3.0*ga1)+b(17,j)*sin(3.0*ga2)
     & +b(18,j)*cos(2.0*ga1+ga2)+b(19,j)*sin(2.0*ga1+ga2)
     & +b(20,j)*cos(2.0*ga1-ga2)+b(21,j)*sin(2.0*ga1-ga2)
     & +b(22,j)*cos(ga1+2.0*ga2)+b(23,j)*sin(ga1+2.0*ga2)
     & +b(24,j)*cos(ga1-2.0*ga2)+b(25,j)*sin(ga1-2.0*ga2)
     & +b(26,j)*cos(4.0*ga1)+b(27,j)*cos(4.0*ga2)
     & +b(28,j)*sin(4.0*ga1)+b(29,j)*sin(4.0*ga2)
     & +b(30,j)*cos(3.0*ga1+ga2)+b(31,j)*sin(3.0*ga1+ga2)
     & +b(32,j)*cos(3.0*ga1-ga2)+b(33,j)*sin(3.0*ga1-ga2)
     & +b(34,j)*cos(2.0*ga1+2.0*ga2)+b(35,j)*sin(2.0*ga1+2.0*ga2)
     & +b(36,j)*cos(2.0*ga1-2.0*ga2)+b(37,j)*sin(2.0*ga1-2.0*ga2)
     & +b(38,j)*cos(3.0*ga2+ga1)+b(39,j)*sin(3.0*ga2+ga1)
     & +b(40,j)*cos(3.0*ga2-ga1)+b(41,j)*sin(3.0*ga2-ga1)
     & +b(42,j)*cos(5.0*ga1)
     & +b(43,j)*cos(5.0*ga2)
     & +b(44,j)*sin(5.0*ga1)
     & +b(45,j)*sin(5.0*ga2)
     & +b(46,j)*cos(4.0*ga1+ga2)
     & +b(47,j)*sin(4.0*ga1+ga2)
     & +b(48,j)*cos(4.0*ga1-ga2)
     & +b(49,j)*sin(4.0*ga1-ga2)
     & +b(50,j)*cos(3.0*ga1+2.0*ga2)
     & +b(51,j)*sin(3.0*ga1+2.0*ga2)
     & +b(52,j)*cos(3.0*ga1-2.0*ga2)
     & +b(53,j)*sin(3.0*ga1-2.0*ga2)
     & +b(54,j)*cos(4.0*ga2+ga1)
     & +b(55,j)*sin(4.0*ga2+ga1)
     & +b(56,j)*cos(4.0*ga2-ga1)
     & +b(57,j)*sin(4.0*ga2-ga1)
     & +b(58,j)*cos(3.0*ga2+2.0*ga1)
     & +b(59,j)*sin(3.0*ga2+2.0*ga1)
     & +b(60,j)*cos(3.0*ga2-2.0*ga1)
     & +b(60,j)*sin(3.0*ga2-2.0*ga1)
     & +b(61,j)*cos(6.0*ga1)
     & +b(62,j)*cos(6.0*ga2)
     & +b(63,j)*sin(6.0*ga1)
     & +b(64,j)*sin(6.0*ga2)
     & +b(65,j)*cos(5.0*ga1+ga2)
     & +b(66,j)*sin(5.0*ga1+ga2)
     & +b(67,j)*cos(5.0*ga1-ga2)
     & +b(68,j)*sin(5.0*ga1-ga2)
     & +b(69,j)*cos(3.0*ga1+3.0*ga2)
     & +b(70,j)*sin(3.0*ga1+3.0*ga2)
     & +b(71,j)*cos(3.0*ga1-3.0*ga2)
     & +b(72,j)*sin(3.0*ga1-3.0*ga2)
     & +b(73,j)*cos(5.0*ga2+ga1)
     & +b(74,j)*sin(5.0*ga2+ga1)
     & +b(75,j)*cos(5.0*ga2-ga1)
     & +b(76,j)*sin(5.0*ga2-ga1)
     & +b(77,j)*cos(4.0*ga2+2.0*ga1)
     & +b(78,j)*sin(4.0*ga2+2.0*ga1)
     & +b(79,j)*cos(4.0*ga2-2.0*ga1)
     & +b(80,j)*sin(4.0*ga2-2.0*ga1)
     & +b(81,j)*cos(4.0*ga1+2.0*ga2)
     & +b(82,j)*sin(4.0*ga1+2.0*ga2)
     & +b(83,j)*cos(4.0*ga1-2.0*ga2)
     & +b(84,j)*sin(4.0*ga1-2.0*ga2)
CRK	if(i.eq.3.or.i.eq.4.or.i.eq.8.or.i.eq.9) 
C      print *,'i=',i,' ga1=',ga1/conv,'ga2=',ga2/conv,' ELOCi=',Eloci
	Eloc=Eloc+Eloci
CRK - to dla proliny;
 10	if(ipro(i).eq.1) then

	  xxpro=0.0
          x0pro=apro(1)
          do j=2,37
            rrpro=(75-2*j)*(-36.0*ga1+37.0*3.14159265)/73.0
            xxpro=xxpro+apro(j)*cos(rrpro)+bpro(j)*sin(rrpro)
          enddo
          xxpro=x0pro+2.0*cos(-36.0*ga1+37.0*3.14159265)*xxpro
          xxpro=xxpro/73.0
	  Eloc=Eloc+xxpro

C	print *,'CRK energia Eloc proliny=',xxpro
CRK	print *,'CRK znalazlem proline Eloc=',Eloc

	endif

      enddo
C
CRK     print *,'CRK ELOC=',Eloc
CRK     print *,'bylem w proc. POT_LOCAL'
	RETURN
	END

******************************************************************************
      SUBROUTINE ENERGY(iout,istep)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      CHARACTER*4 INAMP
      LOGICAL FAIL
      double precision eng,eloc,evdw,elow,edip,xmi(maxres,maxres)
      double precision cutoff
      integer nseed,lcut(maxres,maxres)
CRK 17.09.01 dodalem cutoff i lcut
      double precision LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /XMIX/ xmi,xdif(maxres,maxres),
     & xmj(maxres,maxres)
      common /cut/ cutoff,lcut
CRK wielkosc CUTOFF:

      data CUTOFF /7.0d0/

CRK fragmenty procedury elecont
      double precision app(2,2),bpp(2,2),ael6(2,2),ael3(2,2)
      integer itel(maxat)
      logical dumy
      common /contact/ ncont(maxres),icont(maxres,20),econt(maxres,20)
*
* Load the constants of peptide bond - peptide bond interactions.
* Type 1 - ordinary peptide bond, type 2 - alkylated peptide bond (e.g.
* proline) - determined by averaging ECEPP energy.
*
*
      double precision rri,
     &     epp  (2,2) / 0.3045, 0.3649, 0.3649, 0.5743/,
     1     rpp  (2,2) / 4.5088, 4.5395, 4.5395, 4.4846/,
     2     elpp6(2,2) /-0.2379,-0.2056,-0.2056,-0.0610/,
     3     elpp3(2,2) / 0.0503, 0.0000, 0.0000, 0.0692/
CRK      data elcutoff /-0.3/
C
CRK
      do i=1,nres
        do j=1,nres
          lcut(i,j)=0
        enddo
      enddo
CRK
	evdw=0.0d0
CRK
      do i=1,2
        do j=1,2 
        rri=rpp(i,j)**6
	app (i,j)=epp(i,j)*rri*rri
        bpp (i,j)=-2.0*epp(i,j)*rri
        ael6(i,j)=elpp6(i,j)*4.2**6
        ael3(i,j)=elpp3(i,j)*4.2**3
CRK	write (iout,*) 'wspolczynniki Vdw' 
CRK	write (iout,'(2i2,4e15.4)') i,j,app(i,j),bpp(i,j),ael6(i,j),
CRK	1                               ael3(i,j)
        enddo
      enddo
C
        vbl=3.8
        vblinv=1.0d0/vbl
        vblinv2=vblinv*vblinv
C
      nnt=1
      if (inamp(1).eq.'TER') nnt=2
      nct=nres2
      if (inamp(nres2).eq.'TER') nct=nres1
      do i=nnt,nct-1
        if (inamp(i+1).eq.'PRO') then
          itel(i)=2
        else
          itel(i)=1
        endif
      enddo

*
*  Loop over dipoles
*

CRK
	do i=1,nres2-1

	xi=x(i)
        yi=y(i)
        zi=z(i)
	X1=X(i+1)-X(i)
	Y1=Y(i+1)-Y(i)
	Z1=Z(i+1)-Z(i)
	xx(i,1)=0.5*(x(i+1)+x(i))
	xx(i,2)=0.5*(y(i+1)+y(i))
	xx(i,3)=0.5*(z(i+1)+z(i))
	call vec(i,i+1,uaux)
	do k=1,3
	  u1(k)=uaux(k)
	enddo
CRK
	I4=i+2
        IF (I4.GT.NRES2) THEN
          I2=i+1
          I3=i
          I4=i-1
        ELSE
          I2=i
          I3=i+1
        ENDIF
*       write (iout,3333) ip,1,ii,x1,y1,z1,i2,i3,i4
        call vec(i3,i2,uaux)
        CALL REFSYS(FAIL,3)
        DO ii=1,3
          U1(ii)=E1(ii)
          V1(ii)=E2(ii)
          W1(ii)=E3(ii)
	ENDDO

	  do j=i+2,nres2-1
	
	  X2=X(j+1)-X(j)
          Y2=Y(j+1)-Y(j)
          Z2=Z(j+1)-Z(j)
	  xx(j,1)=0.5*(x(j+1)+x(j))
          xx(j,2)=0.5*(y(j+1)+y(j))
          xx(j,3)=0.5*(z(j+1)+z(j))
	  call vec(j,j+1,uaux)
          do k=1,3
            u2(k)=uaux(k)
          enddo
CRK
	I4=j+2
          IF (I4.GT.NRES2) THEN
            I2=j+1
            I3=j
            I4=j-1
          ELSE
            I2=j
            I3=j+1
          ENDIF
*         write(iout,3333) ip,j,jj,x2,y2,z2,i2,i3,i4
          CALL REFSYS(FAIL,3)
          AUX(1)=xx(j,1)-xx(i,1)
          AUX(2)=xx(j,2)-xx(i,2)
          AUX(3)=xx(j,3)-xx(i,3)
          RR=SQRT(SCALAR(AUX,AUX))
CRK
	  DO K=1,3
            AUX(K)=AUX(K)/RR
	  ENDDO

          U2(1)=SCALAR(U1,E1)
          U2(2)=SCALAR(V1,E1)
          U2(3)=SCALAR(W1,E1)
          V2(1)=SCALAR(U1,E2)
          V2(2)=SCALAR(V1,E2)
          V2(3)=SCALAR(W1,E2)
          W2(1)=SCALAR(U1,E3)
          W2(2)=SCALAR(V1,E3)
          W2(3)=SCALAR(W1,E3)
*         write (iout,3334) u2(1),u2(2),u2(3),v2(1),v2(2),v2(3),w2(1),
*    1    w2(2),w2(3)
 3334 format (' u=',3f10.5/' v=',3f10.5/' w=',3f10.5)
          ER(1) = SCALAR(U1,AUX)
          ER(2) = SCALAR(V1,AUX)
          ER(3) = SCALAR(W1,AUX)
          ERV2  = SCALAR(ER, V2)
          ERW2  = SCALAR(ER, W2)
*         write (iout,3335) er(1),er(2),er(3),erv2,erw2
 3335 format (' er=',3f10.5,' erv2=',f10.5,' erw2=',f10.5)
          Q11   = V2(2)-3.0*ERV2*ER(2)
          Q12   = W2(2)-3.0*ERW2*ER(2)
          Q21   = V2(3)-3.0*ERV2*ER(3)
          Q22   = W2(3)-3.0*ERW2*ER(3)
          FI0(i,j) =ATAN2(Q12+Q21,Q11-Q22)
          PSI0(i,j)=ATAN2(Q21-Q12,Q11+Q22)
*
*  Determine starting angles for alignment procedure
*
          LAMB1=ANG(0.5*( FI0(i,j)+PSI0(i,j) ) + PI)
          LAMB2=ANG(0.5*( FI0(i,j)-PSI0(i,j) ))
*         write ( *,4446) lamb1/conv,lamb2/conv,i,j
* 4446 format('theta1(LAMB1)=',f10.3,' theta2=',f10.3,' i=',i3,' j=',i3)
*
*  Determine dipole alignment with path direction
*
          PER=ER(2)*COS(LAMB1)+ER(3)*SIN(LAMB1)
*         print *,'er(2)=',er(2),' er(3)=',er(3),' coslam=',cos(lamb1),
*    1    ' sinlam=',sin(lamb1),' per=',per
          IF (PER .LT. 0.0) THEN

            LAMB1=ANG(LAMB1+PI)
            LAMB2=ANG(LAMB2+PI)
CRK - tutaj powinny byc lambdy

CRK print *,'LAMB1=',lamb1,' LAMB2=',lamb2
          ENDIF
*         if (istep.eq.1) then
          IF (j.GT.1) THEN
            DELTAL=LAMB1-L2OLD
            IF (DELTAL.GT.PI) DELTAL=DELTAL-DWAPI
            LAM0(i,j)=L2OLD+0.5*DELTA
*           LAM0(i,j)=0.5*(LAMB1+L2OLD)
            L2OLD=LAMB2
          ELSE
            LAM0(i,j)=LAMB1
            L2OLD=LAMB2
          ENDIF
*         endif
          AUX1=Q11*Q11+Q12*Q12+Q21*Q21+Q22*Q22
          AUX2=2.0*(Q11*Q22-Q12*Q21)
*         print *,'q11=',q11,' q12=',q12,' q21=',q21,' q22=',q22
*         print *,'aux1=',aux1,' aux2=',aux2
          X1=X2
          Y1=Y2
          Z1=Z2
          DO 12 ii=1,3
            U1(ii)=E1(ii)
            V1(ii)=E2(ii)
            W1(ii)=E3(ii)
   12     CONTINUE
          CALL TRANSFER(3,VAUX,UAUX)
c    2   CONTINUE
C        LAM0(nres,nres)=LAMB2
c    1 CONTINUE
C 
	ANORM=0.0
        DO K=1,3
          UK=xx(j,k)-xx(i,k)
          ANORM=ANORM+UK*UK
          U(K)=UK
	enddo
	
        ANORM=SQRT(ANORM)
CRK
        xmi(i,j)=0.0d0
        xmj(i,j)=0.0d0
        if(ANORM.lt.5.5d0.and.ANORM.gt.4.40d0) then
	  xmi(i,j)=ANORM
          xmi(j,i)=ANORM
        endif
        if(ANORM.lt.1.1d1) then
          xmj(i,j)=ANORM
          xmj(j,i)=ANORM
        endif
CRK ********************************************************
CRK budowanie listy oddzialujacych reszt dla ANORM < CUTOFF:
        if(ANORM.lt.CUTOFF) then
          lcut(i,j)=1
          lcut(j,i)=1
        endif
CRK ********************************************************
        DO K=1,3
          U(K)=U(K)/ANORM
	enddo
CRK
C
	cosa=scalar(u1,u2)
	cosb=scalar(u1,u)
	cosg=scalar(u2,u)
	wij=cosa-3.0*cosb*cosg
	z1ij=wij*wij+4.0*(1+cosa)-3.0*(cosb+cosg)*(cosb+cosg)
	z1ij=0.5*sqrt(z1ij)
	z2ij=wij*wij+4.0*(1-cosa)-3.0*(cosb-cosg)*(cosb-cosg)
        z2ij=0.5*sqrt(z2ij)

CRK liczenie oddzialywan VdW.
	
	ind=ind+1
          iteli=itel(i)
          itelj=itel(j)
          if (j.eq.i+2 .and. itelj.eq.2) iteli=2
c          if (iteli.eq.2 .and. itelj.eq.2) goto 4
          aaa=app(iteli,itelj)
  	  bbb=bpp(iteli,itelj)
          ael6i=ael6(iteli,itelj)
          ael3i=ael3(iteli,itelj)
          dxj=x(j+1)-x(j)
          dyj=y(j+1)-y(j)
          dzj=z(j+1)-z(j)
          xj=x(j)+0.5*dxj-xmedi
          yj=y(j)+0.5*dyj-ymedi
          zj=z(j)+0.5*dzj-zmedi
          rrmij=1.0/(xj*xj+yj*yj+zj*zj)
          rmij=sqrt(rrmij)
          r3ij=rrmij*rmij
          r6ij=r3ij*r3ij
          vrmij=vblinv*rmij
          ev1=aaa*r6ij*r6ij
	  ev2=bbb*r6ij
          evdwij=ev1+ev2
	  evdw=evdw+evdwij
CRK
CRK	print *,'anorm(i,j)=',anorm,' i=',i,' j=',j
	anorm3=anorm*anorm*anorm
	zplus(i,j)=z1ij*sqrt(abs(ael6i))/anorm3
        zminus(i,j)=z2ij*sqrt(abs(ael6i))/anorm3
	zplus(j,i)=zplus(i,j)
	zminus(j,i)=zminus(i,j)

CRK
c	print *,'zplus(i,j)=',zplus(i,j),' i=',i,' j=',j
c	print *,'zminus(i,j)=',zminus(i,j),' i=',i,' j=',j
c	print *,'ael6i=',ael6i,' z1ij=',z1ij,'z2ij=',z2ij,
c     & ' i=',i,' j=',j

 4	continue
	  enddo
	enddo
C
	CALL POT_LOCAL(IOUT,ISTEP)
C
c	print *,'E.vdw=',evdw
	eold=eng
	eng=0.0
	do i=1,nres1-1
CRK          if(ipro(i).eq.1) then
CRK            CALL LAMEVAL(i,1,IPRO(i),IOUT)
CRK          endif
	  do j=i+2,nres1
CRK            if(ipro(j).eq.1) then
CRK              CALL LAMEVAL(j,1,IPRO(j),IOUT)
CRK            endif
           eneij=zplus(i,j)*COS(RRL(i)+RRL(j)-FI0(i,j))
     &          +zminus(i,j)*COS(RRL(i)-RRL(j)-PSI0(i,j))
           eng=eng+eneij
c	eng=eng+zplus(i,j)*COS(RRL(i)+RRL(j)-FI0(i,j))
c	eng=eng+zminus(i,j)*COS(RRL(i)-RRL(j)-PSI0(i,j))
c           print *,'ij',i,j,' zplus=',zplus(i,j),'zminus=',zminus(i,j),
c     &   ' fi0',fi0(i,j),' psi0',psi0(i,j),' eneij',eneij
      if(eneij.gt.1.0.and.j.gt.i+2) print *,'ij',i,j,' eneij',eneij

	  enddo
	enddo
C	print *,'energia e.s. =',eng,' en.vdw',evdw,'eloc=',eloc
	edip=eng
	eng=eng+evdw+eloc
C	print *,'energia calkowita (lacznie z eloc)=',eng,' Emin=',elow
CRK
      RETURN
	END
******************************************************************************
	SUBROUTINE POT_LOCAL(IOUT,ISTEP)
C
      include 'parcom.dat'
      CHARACTER*4 INAMP
      LOGICAL FAIL
	double precision b(84,2),xxpro,x0pro,rrpro,Eloci
      REAL LAM0,LAMB1,LAMB2,L2OLD,uk,anorm3
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3),xx(maxres,3),u(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U,ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      common /alph0/ alph0
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxres,maxres),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxres,maxres),ZMINUS(maxres,maxres),
     & FI0(maxres,maxres),PSI0(maxres,maxres)
        common /energia/ eng,eloc,evdw,nseed,elow,edip,ealph
      COMMON /APPROX/ LAM0(maxres,maxres)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
     & ,apro(37),bpro(37),bag1(84),bag2(84)
	dimension itel(maxat)
      double precision eee(37,37)
C
	Eloc=0.0
C
	do i=1,84
	  b(i,1)=bag1(i)
	  b(i,2)=bag2(i)
c        print *,i,' b(i,1)=',b(i,1),' b(i,2)=',b(i,2)
	enddo
C
      nnt=1
      if (inamp(1).eq.'TER') nnt=2
      nct=nres2
      if (inamp(nres2).eq.'TER') nct=nres1
      do i=nnt,nct-1
        if (inamp(i+1).eq.'PRO') then
          itel(i+1)=3
        else
          itel(i+1)=2
        endif
	if(inamp(i+1).eq.'GLY') itel(i+1)=1
      enddo
C
      do i=2,nres1
         ga2=RRL(i-1)
         ga1=alam2(i)

	  j=itel(i)

	if(ipro(i).eq.1) then
 	  CALL LAMEVAL(i,1,IPRO(i),IOUT)
	  ga1=rrl(i)
C	print *,' czy to prolina:',ipro(i),inamp(i)
	  goto 10
	endif

ctmp
ctmp      write(iout,*) 'mapka lambda1 lambda2'
ctmp      j=2
ctmp     do i=0,36
ctmp       do k=0,36
ctmp        ga1=(-180.0d0+i*10.0d0)*pi/180.0d0
ctmp        ga2=(-180.0d0+k*10.0d0)*pi/180.0d0


       Eloci=0.0d0

       Eloci=Eloci+b(1,j)+b(2,j)*cos(ga1)+b(3,j)*cos(ga2)
     & +b(4,j)*sin(ga1)+b(5,j)*sin(ga2)
     & +b(6,j)*cos(2.0*ga1)+b(7,j)*cos(2.0*ga2)+b(8,j)*sin(2.0*ga1)
     & +b(9,j)*sin(2.0*ga2)+b(10,j)*cos(ga1+ga2)+b(11,j)*cos(ga1-ga2)
     & +b(12,j)*sin(ga1+ga2)+b(13,j)*sin(ga1-ga2)
     & +b(14,j)*cos(3.0*ga1)+b(15,j)*cos(3.0*ga2)
     & +b(16,j)*sin(3.0*ga1)+b(17,j)*sin(3.0*ga2)
     & +b(18,j)*cos(2.0*ga1+ga2)+b(19,j)*sin(2.0*ga1+ga2)
     & +b(20,j)*cos(2.0*ga1-ga2)+b(21,j)*sin(2.0*ga1-ga2)
     & +b(22,j)*cos(ga1+2.0*ga2)+b(23,j)*sin(ga1+2.0*ga2)
     & +b(24,j)*cos(ga1-2.0*ga2)+b(25,j)*sin(ga1-2.0*ga2)
     & +b(26,j)*cos(4.0*ga1)+b(27,j)*cos(4.0*ga2)
     & +b(28,j)*sin(4.0*ga1)+b(29,j)*sin(4.0*ga2)
     & +b(30,j)*cos(3.0*ga1+ga2)+b(31,j)*sin(3.0*ga1+ga2)
     & +b(32,j)*cos(3.0*ga1-ga2)+b(33,j)*sin(3.0*ga1-ga2)
     & +b(34,j)*cos(2.0*ga1+2.0*ga2)+b(35,j)*sin(2.0*ga1+2.0*ga2)
     & +b(36,j)*cos(2.0*ga1-2.0*ga2)+b(37,j)*sin(2.0*ga1-2.0*ga2)
     & +b(38,j)*cos(3.0*ga2+ga1)+b(39,j)*sin(3.0*ga2+ga1)
     & +b(40,j)*cos(3.0*ga2-ga1)+b(41,j)*sin(3.0*ga2-ga1)
     & +b(42,j)*cos(5.0*ga1)
     & +b(43,j)*cos(5.0*ga2)
     & +b(44,j)*sin(5.0*ga1)
     & +b(45,j)*sin(5.0*ga2)
     & +b(46,j)*cos(4.0*ga1+ga2)
     & +b(47,j)*sin(4.0*ga1+ga2)
     & +b(48,j)*cos(4.0*ga1-ga2)
     & +b(49,j)*sin(4.0*ga1-ga2)
     & +b(50,j)*cos(3.0*ga1+2.0*ga2)
     & +b(51,j)*sin(3.0*ga1+2.0*ga2)
     & +b(52,j)*cos(3.0*ga1-2.0*ga2)
     & +b(53,j)*sin(3.0*ga1-2.0*ga2)
     & +b(54,j)*cos(4.0*ga2+ga1)
     & +b(55,j)*sin(4.0*ga2+ga1)
     & +b(56,j)*cos(4.0*ga2-ga1)
     & +b(57,j)*sin(4.0*ga2-ga1)
     & +b(58,j)*cos(3.0*ga2+2.0*ga1)
     & +b(59,j)*sin(3.0*ga2+2.0*ga1)
     & +b(60,j)*cos(3.0*ga2-2.0*ga1)
     & +b(60,j)*sin(3.0*ga2-2.0*ga1)
     & +b(61,j)*cos(6.0*ga1)
     & +b(62,j)*cos(6.0*ga2)
     & +b(63,j)*sin(6.0*ga1)
     & +b(64,j)*sin(6.0*ga2)
     & +b(65,j)*cos(5.0*ga1+ga2)
     & +b(66,j)*sin(5.0*ga1+ga2)
     & +b(67,j)*cos(5.0*ga1-ga2)
     & +b(68,j)*sin(5.0*ga1-ga2)
     & +b(69,j)*cos(3.0*ga1+3.0*ga2)
     & +b(70,j)*sin(3.0*ga1+3.0*ga2)
     & +b(71,j)*cos(3.0*ga1-3.0*ga2)
     & +b(72,j)*sin(3.0*ga1-3.0*ga2)
     & +b(73,j)*cos(5.0*ga2+ga1)
     & +b(74,j)*sin(5.0*ga2+ga1)
     & +b(75,j)*cos(5.0*ga2-ga1)
     & +b(76,j)*sin(5.0*ga2-ga1)
     & +b(77,j)*cos(4.0*ga2+2.0*ga1)
     & +b(78,j)*sin(4.0*ga2+2.0*ga1)
     & +b(79,j)*cos(4.0*ga2-2.0*ga1)
     & +b(80,j)*sin(4.0*ga2-2.0*ga1)
     & +b(81,j)*cos(4.0*ga1+2.0*ga2)
     & +b(82,j)*sin(4.0*ga1+2.0*ga2)
     & +b(83,j)*cos(4.0*ga1-2.0*ga2)
     & +b(84,j)*sin(4.0*ga1-2.0*ga2)
CRK	if(i.eq.3.or.i.eq.4.or.i.eq.8.or.i.eq.9) 
CRK      print *,'i=',i,' ELOCi=',Eloci
      Eloc=Eloc+Eloci

ctmp        eee(i+1,k+1)=Eloci
ctmp       enddo
ctmp      enddo
ctmp      do i=1,37
ctmp        write(*,'(37f12.6)') (eee(i,k),k=1,37)
ctmp      enddo
ctmp



CRK - to dla proliny;
 10   if(ipro(i).eq.1) then

       xxpro=0.0
          x0pro=apro(1)
          do j=2,37
            rrpro=(75-2*j)*(-36.0*ga1+37.0*3.14159265)/73.0
            xxpro=xxpro+apro(j)*cos(rrpro)+bpro(j)*sin(rrpro)
          enddo
          xxpro=x0pro+2.0*cos(-36.0d0*ga1+37.0*3.14159265d0)*xxpro
          xxpro=xxpro/73.0
        Eloc=Eloc+xxpro

C	print *,'CRK energia Eloc proliny=',xxpro
CRK	print *,'CRK znalazlem proline Eloc=',Eloc

	endif

      enddo
C
CRK	print *,'CRK ELOC=',Eloc
CRK	print *,'bylem w proc. POT_LOCAL'
	RETURN
	END
******************************************************************************
      FUNCTION SCALAR(U,V)
      DIMENSION U(3),V(3)
      P=0.0
      DO 1 I=1,3
    1   P=P+U(I)*V(I)
      SCALAR=0.0
      SCALAR=P
      RETURN
      END
******************************************************************************
      FUNCTION ANG(THETA)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      THETA=AMOD(THETA,DWAPI)
      IF (THETA.LT.-PI) THEN
        ANG=THETA+DWAPI
      ELSE IF (THETA.GT.PI) THEN
        ANG=THETA-DWAPI
      ELSE
        ANG=THETA
      ENDIF
      RETURN
      END
******************************************************************************
      FUNCTION ANGS(PROD)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      IF (ABS(PROD).GT.1.0) THEN 
         ANGS=0.5*PI*(1.0-PROD/ABS(PROD))
      ELSE
       ANGS=ACOS(PROD)
      ENDIF
      RETURN
      END 
******************************************************************************
      SUBROUTINE VEC(I,J,U)
*
*  Find the unit vector from atom (I) to atom (J). Store in U.
*
*     INTEGER*2 ITYPE 
      include 'parcom.dat'
      DIMENSION U(3)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      ANORM=0.0
      DO 1 K=1,3
        UK=XYZ(J,K)-XYZ(I,K)
        ANORM=ANORM+UK*UK
    1   U(K)=UK
      ANORM=SQRT(ANORM)
      DO 2 K=1,3
    2   U(K)=U(K)/ANORM
      RETURN
      END
**************************************************************************
      SUBROUTINE CART(FAIL)
      common /atoms/ natoms
C
C  Calculating the coordinates without closing the disulphide bond.
C
      CALL LOCATE(1,NATOMS,FAIL,3)
      RETURN
      END
