      SUBROUTINE SETUP
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.OMTOR'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CALC'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.KASOS'
      INCLUDE 'COMMON.EDMC'
      INCLUDE 'COMMON.EXTPH'
C =======================================================================
#ifdef MP
C  This block defines some variables and includes some COMMONS that
C  are required by the parallel random number generator used on the sp2
C  OR sgi- ONYXs. The number generators are initialized in this subroutine.
      INCLUDE 'PARAMET.MP'
      INCLUDE 'COMMON.MP'
#endif
#ifndef WVRND
      LOGICAL OKRandom, PRNG_RESTART
      REAL*8  R1, PRNG_NEXT
#endif
C =======================================================================
      COMMON/NUMRND/NUMR
      DATA IONE /1/
      NUMR=0
C Set up force_field parameters 
      GOTO (101,100,102,102,102,102,101) ICOMP(1)
C
C
  100 CONTINUE
C Set keyword to indicate the use  of Max Vasquez' simplified potential.
C    J. of Biomol. Struct. & Dyn. vol 5 (4), pp 757-784 (1988)
      SIMPLE_POT=.TRUE.
C
C ECEPP/3 force field
  101 CALL BD11
C
C generate parameters for modified potential
      write(jout,'(a)')'generating parameters soft-sphere potential'
      CALL MOD_BD11

C Initialize the random-number generator
      write(jout,'(a)') ' initializing random generator'
C ======================================================================

C     Here is where we initialize the approprite random number
C   generators.

#ifndef WVRND
crk      OKRandom = PRNG_RESTART(TASKID,ISEED)
crk      IF (OKRandom) THEN
crk        R1 = PRNG_NEXT(TASKID)
crk      ELSE
crk        write (jout,*) 'PRNG DID NOT WORK!!!'
crk        write (*,*)    'PRNG DID NOT WORK!!!'
crk        STOP 66666
crk      ENDIF
#else
#ifdef MP
crk      ISEED = ISEED-TASKID
#endif
crk      CALL VRNDST(ISEED)
#endif
C =======================================================================
C Read residue data base
	write(jout,*) 'jestem na etapie czytania reszt'
CRK
      IF (ICOMP(2).GT.0 .or. icomp(4) .eq. 5) THEN
C Subroutine hinput reads in the standard residue data for the hydration
C and stores it in the appropriate arrays:
         CALL HINPUT
C Now we need to remove the "zero" solvation types and calculate the
C number of atoms considered in solvation for each residue or end
C group -- AL 11/28/93
         if(icomp(4) .eq. 4) CALL TRANSLATE_ATOM_TYPES
      END IF
      IF ( INTOR .EQ. 0 ) THEN
         WRITE (JOUT,'(A)') 'NO TORSIONALS WILL BE COMPUTED'
         DO 10 I=1,num_restypes
            DO 5 J=1,num_chi
               AR(J,I) = 0.0E0
5           CONTINUE
10       CONTINUE
      END IF

      INUMRS = NRES + 2
C Determine if the backbone is cyclic.
crk      CYCLIC=(LIST(1).EQ.10 .AND. LIST(INUMRS).EQ.20)
crk      IF (CYCLIC) WRITE(JOUT, '("THIS IS A CYCLIC PEPTIDE")')
C Convert dihedral angles from degrees to radians.
      DO 40 I=1,INUMRS
         DO 30 J=1,maxnum_dihe
              ANGULO(J,I) = ANGULO(J,I) * RAD
30       CONTINUE
40    CONTINUE
C Set KASO = 1 to calculate the interaction array without cutoffs.
      KASO=1
C  setup the conformation
      write(jout,*) 'crk CALL SETUP_X(IONE)'
      CALL SETUP_X(IONE)
      write(jout,*) 'crk wyszedlem z SETUP_X(IONE)' 
C Set reference sequence to neutral, if variable degree of ionization
C is assumed.
C     if (phs.gt.0.0) CALL DEGIONZ

C     write(jout,'(a)') ' initializing dihedral angle mapping '
crk
      write(jout,*) 'crk CALL PLACO (0.05)'
      CALL PLACO (0.05)

      GOTO 200
  102 WRITE (JOUT,'(2A)') 'Sorry, only the ECEPP/3 force field and ',
     & 'a soft sphere potential are supported with the current version.'
      STOP
  200  CONTINUE
      RETURN
      END 
      SUBROUTINE BRIDGE_CONSTR
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      IF (IS.NE.0 .AND. IE.NE.0) GOTO 110
* 4/22/93 Constraints implied by the presence of bridges included.
      IS=NPAIR(1,1)
      IE=NPAIR(2,1) 
  110 DO I=1,NLOOP
        IF (NPAIR(1,I).LT.IS) IS=NPAIR(1,I)
        IF (NPAIR(2,I).GT.IE) IE=NPAIR(2,I)
      ENDDO
      IF (IS.EQ.1) IS=2
      IF (IE.EQ.INUMRS) IE=INUMRS-1
cd    WRITE (JOUT,*) 'BRIDGE_CONSTR: IS=',IS,' IE=',IE
      RETURN
      END
      SUBROUTINE DETSEQ
C when using PRO-HIS with changes in ring conformations it is necessary 
C to reset the LIST array  with the sequence of the current minimum
C because LIST is now private.
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.LIST0'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LPROLIN, LHISTID

      MSK=ISHFT(1,NPH-1)
      DO 80 J=1,INUMRS
         LIST(J)=LIST0(J)
         LIT= IABS(LIST0(J))
C
C NOW LET'S SEE IF THIS IS AN "L" OR "D" RESIDUE
         ISIGNO=ISIGN( 1, LIST(J) )
         IF (LHISTID(J)) THEN
C A HIS, HIE or HIP RESIDUE.
           IF (INDPH(J).NE.0) THEN
C RESIDUE WITH AT LEAST ONE VARIABLE DIHEDRAL ANGLE
C*****************************************************************
C*          IF (JDSEQ(J).EQ.0) THEN
C HISTIDINE RESIDUE IS UNCHARGED.
C*****************************************************************
              IF (IAND(LPRHI,MSK).EQ.0) THEN
C  H-ATOM OF HISTIDINE IS ON DELTA N-ATOM
              ELSE
C  H-ATOM OF HISTIDINE IS ON EPSILON N-ATOM
                LIST(J)=ISIGNO*25
              ENDIF
C**************************************
C*          ELSE
C HISTIDINE RESIDUE IS CHARGED.
C*            LIST(J)=ISIGNO*28
C*          ENDIF
C**************************************
           ENDIF
           MSK=ISHFT(MSK,-1)
         ELSE IF (LPROLIN(J).AND.(LIT.NE.34)) THEN
           IF (INDPH(J).NE.0) THEN
C  CHECK PROLINE RING CONFIGURATION.
              IF (IAND(LPRHI,MSK).EQ.0) THEN
C  PROLINE RING IS IN DOWN CONFIGURATION
              ELSE
C  PROLINE RING IS IN UP CONFIGURATION
                IF (LIST(J).EQ.13) LIST(J)=ISIGNO*33
                IF (LIST(J).EQ.22) LIST(J)=ISIGNO*35
              ENDIF
           ENDIF
           MSK=ISHFT(MSK,-1)
         ENDIF
  80  CONTINUE
C     WRITE(JOUT,554)(LIST(J), J=1,INUMRS)
554   FORMAT('LIST IN DETSEQ', /, 20I4)
      RETURN
      END
      SUBROUTINE DMM(A,B,C)
C
C THIS SUBROUTINE MULTIPLIES MATRIX A BY MATRIX B, AND RETURNS THE
C PRODUCT AS MATRIX C (ALL ARE 3X3 MATRICES).
C
      DOUBLE PRECISION A,B,C
      DIMENSION A(3,3),B(3,3),C(3,3)
      DO 10 I = 1,3
      DO 10 J = 1,3
 10   C(I,J) = A(I,1)*B(1,J) + A(I,2)*B(2,J) + A(I,3)*B(3,J)
      RETURN
      END
      FUNCTION DST(A,B)
C
C THIS FUNCTION SUBPROGRAM COMPUTES THE DISTANCE BETWEEN TWO ATOMS,
C REPRESENTED BY COORDINATE ARRAYS A AND B.
C
      DIMENSION A(3),B(3)
      T = A(1) - B(1)
      X = A(2) - B(2)
      Y = A(3) - B(3)
      DST = SQRT(T*T+X*X+Y*Y)
      RETURN
      END
      SUBROUTINE GENBRIDGE
C
C THIS SUBROUTINE GENERATES THE INTERACTION TABLE FOR THE PAIRS OF ATOMS
C INVOLVED IN BRIDGE FORMATION.
C
C AS OF 8/3/93
C
      DOUBLE PRECISION DUK,ESAVE
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.CALC'
      COMMON/DIVH/CPSI,DS(3),DT(3),DU(3),DV(3)
C IF THE BRIDGE LINKS THE ENDS OF THE BACKBONE, THE INTERACTION TABLE HA
C ALREADY BEEN SET UP BY THE APPROPRIATE CALL TO ADJCNT.
      IF (LISTIJ.EQ.10) RETURN
      ITB1=ITB(NBRIDGE,1)
      ITB2=ITB(NBRIDGE,2)
      II=ITB(NBRIDGE,3)
      IA1=NPREIJ+IBRID(1,ITB1)
      IB1=NPREIJ+IBRID(2,ITB1)
      IS1=NPREIJ+IBRID(3,ITB1)
      IC1=IBRID(4,ITB1)
      IF (IC1.NE.0) IC1=IC1+NPREIJ
      ID1=IBRID(5,ITB1)
      IF (ID1.NE.0) ID1=ID1+NPREIJ
      IA2=NPREIK+IBRID(1,ITB2)
      IB2=NPREIK+IBRID(2,ITB2)
      IS2=NPREIK+IBRID(3,ITB2)
      IC2=IBRID(4,ITB2)
      IF (IC2.NE.0) IC2=IC2+NPREIK
      ID2=IBRID(5,ITB2)
      IF (ID2.GT.0) ID2=ID2+NPREIK
      NBBT=NBBB(II)
      IF (IK.NE.1 .AND. IK.NE.INUMRS) THEN
        NNAT=NATOMS(LISTIK)
      ELSE
        NNAT=NDATOM(LISTIK)
      ENDIF
cd    WRITE (jout,*) 'II=',II,' ITB1=',ITB1,' ITB2=',ITB2
cd    WRITE (jout,*) 'IA1=',IA1,' IB1=',IB1,' IS1=',IS1
cd    WRITE (jout,*) 'IC1=',IC1,' ID1=',ID1
cd    WRITE (jout,*) 'IA2=',IA2,' IB2=',IB2,' IS2=',IS2
cd    WRITE (jout,*) 'IC2=',IC2,' ID2=',ID2
cd    WRITE (jout,*) 'NNAT=',NNAT
C
C STEP ATOM
      DO 140 K=1,NNAT
      NB=5
      IS13=IJ+2
      IF (IJ.NE.1 .AND. IK.NE.INUMRS .AND. J.EQ.6 .AND. K.EQ.1 .AND.
     &           IS13.EQ.K .AND. NIT.EQ.1) THEN
        NB=4
        NIT=0
      ELSE
        IF (ITB1.GT.ITB2) THEN
          NB=NBBRID(II,J,K)
        ELSE
          NB=NBBRID(II,K,J)
        ENDIF
      ENDIF
cd    WRITE (jout,*) 'J=',J,' K=',K,' NB=',NB
      IF(NB.EQ.0) GO TO 140
      KM=K+NPREIK
      KSTRT=KM
      KFIN=KM
cd    write (jout,*) 'JM=',JM,' KSTRT=',kstrt,' KFIN=',kfin
crk      IF (NB.EQ.4) CALL CAL14
crk      IF (NB.EQ.5) CALL CAL15
  140 CONTINUE
      RETURN
      END
      SUBROUTINE GENER
c **************** last modified 5-7-92 ******************** 
c  NOTE: MODIFICATIONS from ECEPP3
c modifications have been made for the particar case of X-Pro
c sequences. The C'N bond length is now 1.340 A and the
c CaCN bond angle is 118.0. Because of the 3 degree increase in
c the bond angle, the rotation matrices for the X-Pro residue must
c use the values cdelp, sdelp, as calculated in subroutine TRANSF,
c instead of sdel, cdel coming from the residue data
c **************************************************************

C  -Altered 11/91  to include residues with N-methyl groups. DR.
C
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE BACKBONE ATOMS OF
C THE POLYPEPTIDE, EXCEPT FOR PROLINE AND HYDROXYPROLINE RESIDUES.  IT
C CALLS GNAMIN AND GNCARB TO GENERATE END GROUP COORDINATES, GNSIDE FOR
C SIDECHAIN COORDINATES, AND GNPRO FOR PROLINE-TYPE RESIDUES.
C
      DOUBLE PRECISION DABS,DCOS,DSIN
      DOUBLE PRECISION A(9),MATC(9)
      DOUBLE PRECISION CSTH1,SNTH1,CSANG,SNANG
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      DOUBLE PRECISION ANG,PROANG(3)
c ********* special angles for X-Pro sequences ***********
      INCLUDE 'COMMON.PROSEQ'
c *********************************************************
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN001'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GEN003'
      INCLUDE 'COMMON.GNROU'
      DOUBLE PRECISION IDENT(9)
      COMMON/GEN005/IDENT
      COMMON/PRINT/IPRNT
      DIMENSION TEMP(3),TEMP2(3)
      LOGICAL LPROLIN
      LOGICAL NMETHYL
      LOGICAL NSWITCH
C     DATA PI/ 3.141593 /
      DATA ERROR / .0001 /
      DATA IONE /1/, ITHREE /3/,ISIX /6/, ISEV /7/
C
C IFEVEN MUST BE RESET EVERY TIME A MOLECULE IS GENERATED.
C
      IFEVEN = 1
      CALL GNAMIN
      LASTFL = INUMRS - 1
      DO 110 I=1,9
      A1(I) = IDENT(I)
  110 CONTINUE
      DO 380 N=2,LASTFL
      IF (N.NE.LASTFL) THEN
         SNTH1 = FLOAT(IFEVEN)*0.857167
         CSTH1 = 0.515038

         LNEXT=LIST(N+1)
         LNEXT=IABS(LNEXT)
         KNEXT=KNDRES(LNEXT)
         KNEXT = IABS(KNEXT)
         NNEXT=N+1
         IF (LPROLIN(NNEXT).AND.(COS(ANGULO(3,N)).GT.0.0) ) THEN
c *********** 5-7-92 *******************************
c   the CNCa angle for cis-Pro is now 127.3, following a revision of
c   X-ray structures *** 5-7-92 *****
c old values for ecepp/2 were:
c                           snth1 = float(ifeven)*0.809017
c                           csth1 = 0.587785
c ***
            SNTH1 = FLOAT(IFEVEN)*0.7954734
            CSTH1 = 0.6059884
c *******************************************************************
            IF (IPRNT.EQ.1) WRITE(JPRINT,400) N
         ENDIF

         IF (NMETHYL(NNEXT) ) THEN 
           IF (COS(ANGULO(3,N)).GT.0.0) THEN
c *********** 8-5-96 *******************************
c   the CNCa angle for cis-N-Me is now 125.85, following a revision of
c   X-ray structures *** 8-5-96 *****
c ***
            SNTH1 = FLOAT(IFEVEN)*0.81055304
            CSTH1 = 0.58566524
           ELSE
c *********** 8-5-96 *******************************
c   the CNCa angle for trans-N-Me is now 118.07, following a revision of
c   X-ray structures *** 8-5-96 *****
c ***
            SNTH1 = FLOAT(IFEVEN)*0.88237337
            CSTH1 = 0.47054994
      ENDIF
         ENDIF
      ENDIF
  120 LISTN = LIST(N)
      NT = IABS(LISTN)
      KINDN = KNDRES(NT)
      KINDN = IABS(KINDN)
      NCHIS=NCHI(NT) 
C
C SIGN INDICATES WHETHER THE D OR L CONFIGURATION IS REQUESTED.
C L IS POSITIVE; D IS NEGATIVE
C
      SIGN = 1.0
      IF (NT .NE. LISTN) SIGN = -1.0
C
C PHI, PSI, AND OMEGA ARE THE FIRST THREE ANGULO IN THE LIST FOR
C EACH RESIDUE.  THE REMAINING 7 ANGULO ARE POSSIBLE CHI'S.
C
      PHI = ANGULO(1,N) - PI
      PSI = ANGULO(2,N) - PI
      OMEGA = ANGULO(3,N) - PI
C
C PROLINE RESIDUES WILL BE HANDLED IN A SPECIAL SUBROUTINE
C
      IF (LPROLIN(N)) THEN
         CALL GNPRO
         IF (KINDN.EQ.22) THEN
C  HYDROXYPROLINE. 
              DO 130 L=1,9
              ROT(L)=A1(L)
  130         CONTINUE
              CALL GNSIDE
         END IF
         GO TO 250
      END IF
C Following code considers exchange of chi's. 
CThis occurs when the torsion convention (IUPAC) does not
C correspond with the organization required in ECEPP for
C side chain generation, as in isoleucine. 
C The treatment here is more general than in original ECEPP program.
C D.R.    AUG/2/95 
C IF RESIDUE IS ISOLEUCINE, CHI2 AND CHI3 MUST BE EXCHANGED
C
      DO KJ=1,NCHIS
        ISKP= ISHFK(KJ,KINDN)
        IF(ISKP.GT.0) THEN
             IAN1=3+KJ
             IAN2=3+KJ+ISKP
            T = ANGULO(IAN1,N)
            ANGULO(IAN1,N) = ANGULO(IAN2,N)
            ANGULO(IAN2,N) = T
        ENDIF  
      ENDDO
      IF (N.EQ.2) THEN
         IF (NSWITCH(N)) THEN
C THIS SECTION LENGTHENS THE N-CA BOND  OF GAL SWITCHES 
C SXY OR SLX.                                         DR 8-93
           NA = NPRE(2)+ 3
           NB = NPRE(2) + 1
           RAN = .022
           CALL MODBOND(NA,NB,RAN)
         END IF
      ELSE
C ATTACH THE H (OR CM OF THE N-METHYL GROUP) AND C-ALPHA TO N.
C  D.R 11/91 ^^^&&&
C
         DO 160 J=2,3
              CALL TRANSF(MATA,J,IONE)
  160    CONTINUE
      END IF
C **********************************************************************
C NEW CODE TO ACCOUNT FOR N-METHYL GROUPS.   D.R. 11/91  ^^^&&&
170   IF (NMETHYL(N)) THEN
         K = LRT1(1,NT)
         DO 165 L=1,9
              B1(L) = A1(L)
              ROT(L) = A1(L)
  165    CONTINUE
C NOW ADD 3 H ATOMS ON METHYL GROUP.
         CALL GNMET
         DO 167 L=1,9
              A1(L) = B1(L)
  167    CONTINUE
      END IF
C **********************************************************************
C
      IF (DABS(PHI) .LE. ERROR) THEN
         DO 180 L=1,9
         B1(L) = A1(L)
  180    CONTINUE
      ELSE
C
C IF PHI DOES NOT EQUAL ZERO, MODIFY THE ROTATION MATRIX.
C
  190    CSANG=DCOS(PHI)
         SNANG = DSIN(PHI)
         DO 200 J=1,3
              MATB(J,1) = MATA(J,1)
              MATB(J,2) = MATA(J,2)*CSANG + MATA(J,3)*SNANG
              MATB(J,3) = - MATA(J,2)*SNANG + MATA(J,3)*CSANG
  200   CONTINUE
      END IF
C ATTACH THE H, C-BETA, AND C' TO C-ALPHA.
C In case of sxy or slx (list=42,43) these atoms are CG1, CG2 and C'.
C                                              DR 8-93.
C
  210 DO 220 J=4,6
      CALL TRANSF(MATB,J,ITHREE)
  220 CONTINUE

      IF (NSWITCH(N)) THEN
C
C In case of sxy or slx (list=42,43) we should add the atoms of the five
C member ring attached to CA.
C
C                           CA(3)
C                         /    \
C              HG1       /      \     HG2
C               (4)CG1  /        \ CG2(5)
C              HG1      |        |    HG2
C                       |        |   HD1
C                (13)ND |________|CD1(12)
C                       /             HD1
C                      /
C                     NE (16)
C
         DO 225 J=8,16
         CALL TRANSF(MATB,J,ITHREE)
  225    CONTINUE
         K=17
      ELSE
C
C FOR STANDARD AMINO ACID RESIDUES.
C THE FOLLOWING SECTION WILL ATTACH THE SIDECHAIN COORDINATES TO C-BETA.
C
         K=8
      END IF
      NX = NCHI(NT)
C ********************************************
C NEW CODE TO ACCOUNT FOR N-METHYL GROUPS.   D.R. 11/91  ^^^&&&
C THE FIRST DIHEDRAL ANGLE REFERS TO THE N-METHYL GROUP. IT IS NOT A CHI.
      IF (NMETHYL(N)) THEN
         NX = NX-1
      END IF
C ********************************************
C
C IF THERE ARE NO SIDECHAIN ROTATIONS (IF THE RESIDUE IS PROLINE OR
C GLYCINE), THE NEXT SECTION IS BYPASSED.
C
      IF (NX.GT.0) THEN
         DO 230 L=1,9
         ROT(L) = B1(L)
  230    CONTINUE
         CALL GNSIDE
      END IF
         IF (NMETHYL(N)) THEN
C IF RESIDUE IS N-METHYL GLY, THEN, SUBINDEX K SHOULD POINT TO THE NEXT
C N ATOM.                                     DR 12/91^^^&&&
              K = K + 3
         END IF
C IF IFEVEN EQUALS 1, THEN THE SIGNS OF SNTH2 AND SDEL (AS STORED FOR
C THE RESIDUE) MUST BE REVERSED.
C
  250 SNT = -FLOAT(IFEVEN)*SNTH2(NT)
      SDELTA = -FLOAT(IFEVEN)*SDEL(NT)
      CST = CSTH2(NT)
      CDELTA = CDEL(NT)
      IF(DABS(PSI).LE.ERROR) THEN
         DO 260 L=1,9
         A1(L) = B1(L)
  260    CONTINUE
      ELSE
C
C IF PSI .NE.0.0, CALCULATE THE ROTATION MATRIX.
         CALL MATRIX(CST,SNT,PSI,MATC)
C
C MULTIPLY THIS BY THE PREVIOUS BACKBONE ROTATIONS.
C
         CALL DMM(MATB,MATC,MATA)
      END IF
C
C IF THIS IS THE LAST RESIDUE, THEN SKIP THE OMEGA ROTATIONS. PUT THE
C CARBOXYL END GROUP ON.
      IF (N.EQ.LASTFL) THEN
C
         DO 290 L=1,9
              B1(L) = A1(L)
  290    CONTINUE
         CSANG = CST
         SNANG = SNT
      ELSE
C ATTACH THE O TO THE C'.
C
         CALL TRANSF(MATA,ISEV,ISIX)
C
C POSITION THE N FOR THE NEXT RESIDUE.
C
c ********* 5-7-92 ***********************
c if the next residue is Pro, the  Nitrogen atom has to be attached
c in the modified geometry and new sdelp, cdelp are calculated
      KNN=KNEXT
      KNITR=K
      CALL TRANSF(MATA,KNITR,ISIX)
      SDELTP=-FLOAT(IFEVEN)*SDELP
      CDELTP=CDELP
c *****************************************************

         IF (LPROLIN(NNEXT).OR.NMETHYL(NNEXT))  THEN

c *******    5-7-92   and 8-6-96  **********
C
C THIS SECTION LENGTHENS THE AMIDE BOND TO 1.34 ANGSTROMS WHEN THE
C NEXT RESIDUE IS A PROLINE- or NMETHYL-TYPE.
C
C following a revision of X-ray structures.
c ******************************************
             NA = NPRE(N+1) + 1
             NB = NPRE(N) + 6
             RAN = .015
             RAB = DST(COORD(1,NA),COORD(1,NB))
             DO 305 I=1,3
             TEMP(I) = COORD(I,NA) + RAN*(COORD(I,NA)-COORD(I,NB))/RAB
  305        CONTINUE
             DO 310 J = 1,3
               COORD(J,NA) = TEMP(J)
  310        CONTINUE
         END IF
         IF(DABS(OMEGA).LE.ERROR) THEN
             DO 330 L=1,9
             B1(L) = A1(L)
  330        CONTINUE
         ELSE
C
C IF OMEGA IS NOT EQUAL TO ZERO, CALCULATE THE ROTATION MATRIX.
c ***********************From changes 5-7-92 ***********************
             IF (LPROLIN(NNEXT))  THEN
                 CALL MATRIX(CDELTP,SDELTP,OMEGA,MATC)
             ELSE
                 CALL MATRIX(CDELTA,SDELTA,OMEGA,MATC)
             ENDIF
c ******************************************************
C
C MULTIPLY BY THE PREVIOUS TRANSFORMATION MATRIX.
             CALL DMM(MATA,MATC,MATB)
         END IF
C
C CSANG IS THE COSINE OF DELTA (DIFFERENCE BETWEEN THETA 2 AND THETA 3)
C PLUS THETA 1.
C
c ***********************  5-7-92 **************
         IF (LPROLIN(NNEXT))  THEN
             CSANG=CDELTP*CSTH1-SDELTP*SNTH1
             SNANG=SDELTP*CSTH1+CDELTP*SNTH1
         ELSE
             CSANG=CDELTA*CSTH1-SDELTA*SNTH1
             SNANG=SDELTA*CSTH1+CDELTA*SNTH1
         ENDIF
c *************************************************

C
C MULTIPLY IFEVEN AND SNTH1 BY -1 SO THAT THE COORDINATES OF THE NEXT
C RESIDUE WILL BE FLIPPED ABOUT THE X-AXIS AND THE EXTENDED
C CONFORMATION WILL RESULT.
C
         IFEVEN = - IFEVEN
         SNTH1 = - SNTH1
      END IF

C ADJUST THE MATRIX TO LINE UP THE COORDINATES OF THE NEXT RESIDUE IN
C THE ORIGINAL COORDINATE SYSTEM.
C
      DO 370 J=1,3
         MATA(J,1) = MATB(J,1)*CSANG + MATB(J,2)*SNANG
         MATA(J,2) = - MATB(J,1)*SNANG + MATB(J,2)*CSANG
         MATA(J,3) = MATB(J,3)
  370 CONTINUE
C
C Code added AUG/2/95  by D.R.; See similar change above.
      DO KJ=1,NCHIS
        ISKP= ISHFK(KJ,KINDN)
        IF(ISKP.GT.0) THEN
             IAN1=3+KJ
             IAN2=3+KJ+ISKP
            T = ANGULO(IAN1,N)
            ANGULO(IAN1,N) = ANGULO(IAN2,N)
            ANGULO(IAN2,N) = T
        ENDIF 
      ENDDO

  380 CONTINUE
C
C ATTACH THE CARBOXYL END GROUP.
C
      CALL GNCARB
C
C GENERATION IS COMPLETE.
C
      RETURN
  400 FORMAT (//,'RESIDUE ',I3,
     1 ' HAS CIS OMEGA AND NEXT RESIDUE IS A PROLINE.',/,
     2 ' PROLINE IS ATTACHED SO C-N-CA=126 DEGREES AND',
     3 ' C-N-CD= 121 DEGREES.')
      END
      SUBROUTINE GNAMIN
c ********** last modified  5-7-92  *********
c modifications have been made for the particular case of Proline
c at the first residue, following a revision of X -ray structures
c ******************************************

C
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE AMINO END GROUP.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      DOUBLE PRECISION ANG,A5(3,9),MATC(9),DABS
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN001'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GNROU'
      COMMON/PRINT/IPRNT
      DIMENSION TEMP(3),TEMP2(3)
C     DATA PI/ 3.141593 /
      DATA ERROR / .0001 /
      LOGICAL NMETHYL,LPROLIN
c********  5-7-92 *******************
c following a proline geometry revision, the C'NCalpha angle is now
c 127.3. The angle of the matrix A5 is no longer 5 but 6.3
c     DATA A5/ .99619D0,-.08716D0,.0D0,.08716D0,.99619D0,.0D0,.0D0,.0D0,
c    1 1.0D0/
C This part of A5 for cis-Pro; angle of rotation is 6.3 deg (127.3-121.0)
      data a5/ .99396D0,-.10973D0,.0D0,.10973D0,.99396D0,.0D0,
     &     .0D0,.0D0,1.0D0,
C This part of A5 for cis-N-Met; angle of rotation is 
     &         .99642D0,-.08455D0,.0D0,.08455D0,.99642D0,.0D0,
     &     .0D0,.0D0,1.0D0,
C This part of A5 for trans-N-Met; angle of rotation is -2.93 deg (118.07-121.00)
     &         .99869D0,.05112D0,.0D0,-.05112D0,.99869D0,.0D0,
     &     .0D0,.0D0,1.0D0/ 
C *****************************************************************

C
      LAMIN = LIST(1)
      KAMIN = KNDEND(LAMIN)
      KAMIN = IABS(KAMIN)
      LNEXT = LIST(2)
      LNEXT = IABS(LNEXT)
      KNEXT = KNDRES(LNEXT)
      KNEXT = IABS(KNEXT)
      NATOM=NDATOM(LAMIN)
      NX = NBOND(LAMIN)
C
C STORE THE COORDINATES FOR THE AMINO END GROUP.
C
      DO 110 M = 1,NATOM
      DO 110 MM = 1,3
      COORD(MM,M)=ENOORD(MM,M,LAMIN)
  110 CONTINUE
C
C THIS SECTION IS FOR A PROLINE- OR N-METHYL TYPE FIRST FULL RESIDUE.  
C FOR ALL END GROUPS EXCEPT THE NULL END GROUP 1) LENGTHEN THE C'-N BOND 
C TO 1.34 ANGSTROMS AND 2) IN THE CASE OF CIS-PROLINE ROTATE THE END GROUP
C BY APPROPRIATE ANGLE IN THE X,Y PLANE (SEE THE COMMENTS AT ARRAY A5).
C
      IF (.NOT. (LPROLIN(2) .OR. NMETHYL(2)) .OR. KAMIN.EQ.10) 
     &   GO TO 140
      NA = NPRE(2)
      NB = NPRE(2) + 1
C Put the coordinates of CN      
      if (nmethyl(2)) then
        do m=1,2
        do mm=1,3
          coord(mm,m+nb)=xoord(mm,m,knext)
        enddo
        enddo
      endif ! nmethyl(2)
C
c the revised bond length is 1.340 **** 5-7-92 ******
C
      RAN = .015
      RAB = DST(COORD(1,NA),COORD(1,NB))
      DO 115 I=1,3
      TEMP(I) = COORD(I,NA) + RAN*(COORD(I,NA)-COORD(I,NB))/RAB
  115 CONTINUE
C
      DO 120 I=1,3
      TEMP2(I)=TEMP(I)-COORD(I,NA)
  120 CONTINUE
      DO 125 I=1,3
      COORD(I,NA) = TEMP(I)
  125 CONTINUE
      NN = NATOM-4
      DO 130 J=1,NN
      DO 130 I=1,3
      COORD(I,J) = TEMP2(I) + COORD(I,J)
  130 CONTINUE
C
c ********      5-7-92   *******************************
c if the amino end group contains a CC' bond, the atoms preceeding
c the carbonyl group are rotated around the z axis by three degrees,
c including the oxygen of the carbonyl.
c
        nc=npre(2)-2
        if(nbtype(nc).eq.6) then
        do 555 i=1,nn
        y=coord(2,i)
        x=coord(1,i)
        z=coord(3,i)
        yt=y-coord(2,na)
        xt=x-coord(1,na)
        zt=z-coord(3,na)
        ango=atan2(yt,xt)
        dn=3.0*0.017453293
        angn=ango+dn
        rr=sqrt(yt*yt+xt*xt)
        coord(1,i)=coord(1,na)+rr*cos(angn)
        coord(2,i)=coord(2,na)+rr*sin(angn)
555     continue
        endif
c *****************************************************

C     IF (COS(ANGULO(NX,1)).LE.0.0) GO TO 140
      CCC=COS(ANGULO(NX,1))
      IF (CCC.LE.0.0 .AND. .NOT. NMETHYL(KNEXT)) GO TO 140
      if (lprolin(knext)) then
C Cis-Pro
        lstart=0
      else if (CCC.GT.0.0) then
C Cis-N-Met
        lstart=3
      else
C Trans-N-Met
        lstart=6
      endif
      N3 = NATOM - 3
      DO 134 M=1,N3
      DO 132 JJ=1,3
      TEMP(JJ)=0.0
      DO 132 L=1,3
      TEMP(JJ)=TEMP(JJ)+A5(JJ,L+LSTART)*COORD(L,M)
  132 CONTINUE
      DO 134 JJ=1,3
      COORD(JJ,M)=TEMP(JJ)
  134 CONTINUE
      IF (IPRNT.EQ.1) WRITE (JPRINT,240)
  140 CONTINUE
C
C IF THERE ARE NO ROTATABLE BONDS IN THE END GROUP, RETURN.
C
      IF (NX.EQ.0) RETURN
C
C THE REMAINDER OF THE SUBROUTINE PERFORMS ANY SPECIFIED ROTATIONS.
C
      ME=0
      DO 210 IBOND=1,NX
      ANG = -ANGULO(IBOND,1) - PI
      IF(DABS(ANG).LE.ERROR) GO TO 210
      ML=1
      MM=NNDPT2(IBOND,LAMIN)
      IF (MM .EQ. ME) ML = MB + 1
      ME = MM
      MB=NNDPT1(IBOND,LAMIN)
C Change 4/9/93 (AL). Rotation about a given angle in the N-terminal group
C                     can affect either the atoms previous or next to the
C                     bond axis, depending on LR(IBOND,LAMIN).
      if (lr(ibond,lamin).lt.mb) ml=lr(ibond,lamin)
C
C THIS SECTION CALCULATES THE DIRECTION COSINES OF THE BOND.
C
      D = 0.0
      DO 150 L = 1,3
      CIS(L) = COORD(L,ME) - COORD(L,MB)
      D = D + CIS(L)*CIS(L)
  150 CONTINUE
      D = 1.0/SQRT(D)
      DO 160 L = 1,3
      CIS(L) = CIS(L)*D
  160 CONTINUE
C
      CALL ROTSET(CIS,ANG,A1)
      MN = MB - 1
      DO 200 J=ML,MN
      DO 170 JJ=1,3
      COORD(JJ,J)=COORD(JJ,J)-COORD(JJ,MB)
  170 CONTINUE
      DO 180 JJ=1,3
      TEMP(JJ)=MATA(JJ,1)*COORD(1,J)+MATA(JJ,2)*COORD(2,J)+
     1 MATA(JJ,3)*COORD(3,J)
  180 CONTINUE
      DO 190 JJ=1,3
      COORD(JJ,J)=TEMP(JJ)+COORD(JJ,MB)
  190 CONTINUE
  200 CONTINUE
  210 CONTINUE
      RETURN
  240 FORMAT (//,' FIRST FULL RESIDUE IS CIS-PROLINE. END GROUP MOVED',
     1' 5 DEGREES SO',/, 
     2 'THAT C-N-CA=126 DEGREES AND C-N-CD=121 DEGREES INSTEAD OF THE',
     3 ' REVERSE.',//)
      END
      SUBROUTINE GNCARB
C
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE CARBOXYL END GROUP.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      DOUBLE PRECISION ANG,DABS,MATC(9)
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN003'
      INCLUDE 'COMMON.GNROU'

      COMMON/GEN007/LBG(3),LEN(3)
      DIMENSION TEMP(3)
      DATA ERROR/ .0001 /
C     DATA PI/ 3.141593 /
      DATA IONE /1/, ITHREE /3/
C
      N=INUMRS
      NT = LIST(N)
      KCARB = KNDEND(NT)
      KCARB = IABS(KCARB)
      SIGN = 1.0
C
C ATTACH THE O AND THE FIRST ATOM OF THE END GROUP TO THE C'.
C
      NL = 3
      IF (KCARB.EQ.20) NL = 2
      DO 110 J=2,NL
      CALL TRANSF(MATA,J,IONE)
  110 CONTINUE
      NL =  NDATOM(NT) + 1
      IF (NL .LT. 4) RETURN
C
C ADD ON THE REMAINING ATOMS WITHOUT ANY BOND ROTATIONS.
C
      DO 120 J=4,NL
      CALL TRANSF(MATA,J,ITHREE)
  120 CONTINUE
      NX=NBOND(NT)
      NATOM=NPRE(INUMRS)
C
C IF THERE ARE NO ROTATABLE BONDS IN THE END GROUP, RETURN.
C
      IF(NX.EQ.0)RETURN
C
C THE REMAINDER OF THE SUBROUTINE PERFORMS ANY SPECIFIED ROTATIONS.
C
      DO 190 IBOND=1,NX
      IF (IBOND.NE.1) GO TO 124
      ANG=ANGULO(3,INUMRS-1) - PI
      IF (KCARB.NE.16) GO TO 125
      ANGL=ANGULO(3,INUMRS-1)
      IF (COS(ANGL).LT.(-0.0001)) GO TO 125
      ANGL=57.29578*ANGL
      WRITE (JPRINT,200) ANGL
      STOP
  124 ANG=ANGULO(IBOND-1,INUMRS)-PI
  125 IF (DABS(ANG).LT.ERROR) GO TO 190
C
C THE FIRST BOND IS DEFINED BY THE 6TH ATOM IN THE LAST FULL RESIDUE
C (C') AND THE FIRST ATOM IN THE END GROUP.  ALL OTHER  BONDS ARE
C DEFINED BY THE STORED NNDPT1 AND NNDPT2.
C
      MB = NNDPT1(IBOND,NT) + NATOM - 1
      IF (IBOND.EQ.1)  MB=NPRE(INUMRS-1)+6
      ME = NNDPT2(IBOND,NT) + NATOM - 1
      IF (IBOND.EQ.1) ME=NATOM+1
C
C THIS SECTION CALCULATES THE DIRECTION COSINES OF THE BOND.
C
      D = 0.0
      DO 130 L = 1,3
      CIS(L) = COORD(L,ME) - COORD(L,MB)
      D = D + CIS(L)*CIS(L)
  130 CONTINUE
      D = 1.0/SQRT(D)
      DO 140 L = 1,3
      CIS(L) = CIS(L)*D
  140 CONTINUE
C
      CALL ROTSET(CIS,ANG,A1)
C
C SPECIAL INDICES LBG AND LEN ARE NEEDED TO DEFINE THE ATOMS AFFECTED BY
C THE BOND ROTATION IN THE CASE OF N,N-DIMETHYLAMIDE.
C
      LL = ME+1
      IF (KCARB.EQ.16) LL = LBG(IBOND)+NATOM-1
      MN = NPRE(INUMRS+1)
      IF (KCARB.EQ.16) MN = NATOM+LEN(IBOND)-1
      DO 180 J = LL,MN
      DO 150 JJ=1,3
      COORD(JJ,J)=COORD(JJ,J)-COORD(JJ,ME)
  150 CONTINUE
      DO 160 JJ=1,3
      TEMP(JJ)=MATA(JJ,1)*COORD(1,J)+MATA(JJ,2)*COORD(2,J)+
     1 MATA(JJ,3)*COORD(3,J)
  160 CONTINUE
      DO 170 JJ=1,3
      COORD(JJ,J)=TEMP(JJ)+COORD(JJ,ME)
  170 CONTINUE
  180 CONTINUE
  190 CONTINUE
      RETURN
  200 FORMAT (/1X,'FOR DIMETHYL AMIDE, THE OMEGA ANGLE MUST BE TRANS',
     1'NOT',F8.3,'DEGREES',/1X,
     2 'BECAUSE THE TWO METHYLS HAVE NON-EQUIVALENT GEOMETRIES.')
      END
      SUBROUTINE GNMET
C  -Written 5/NOV/91  to include residues with N-methyl groups.
C                                                  DR  11/91 ^^^&&&
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE N-METHYL GROUP.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION A(9),MATC(9),DABS
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN003'
      INCLUDE 'COMMON.GNROU'

C     DATA PI/ 3.141593 /
      DATA ERROR / .0001 /
C
      IBOND=1
C MB IS THE BEGINNING OF THE BOND, LE IS THE END, AND MN INDICATES THE
C LAST ATOM TO BE AFFECTED BY THE BOND ROTATION.
C
C     K INDICATES THE FIRST H ATOM OF THE METHYL GROUP
      MB = NDPT1(IBOND,NT)
      LE = NDPT2(IBOND,NT)
      MN = NUM(IBOND,NT) + K - 1
      CHI = ANGULO(IBOND + 3,N) - PI
C
C IF NO CHI ROTATION IS CALLED FOR, ATTACH THE SIDECHAIN ATOMS.
C
      IF (DABS(CHI) .LE. ERROR) THEN
         DO 110 L=K,MN
         CALL TRANSF(ROT,L,LE)
  110    CONTINUE
      ELSE
C STORE THE DIRECTION COSINES FOR THIS BOND IN CIS.
C
      DO 130 I=1,3
      CIS(I)=CHIANG(I,IBOND,NT)
  130 CONTINUE
C
C IF IFEVEN IS -1, THEN THE COORDINATES AS STORED WILL BE FLIPPED 180
C DEGREES ABOUT THE C'-N BOND WHEN THEY ARE ATTACHED.  THEREFORE THE
C DIRECTION COSINES OF THE BOND MUST ALSO BE ADJUSTED.
C
      CIS(2)=FLOAT(IFEVEN)*CIS(2)
      CIS(3)=FLOAT(IFEVEN)*CIS(3)
C
C ADJUST CIS(3) TO ACCOUNT FOR THE DIRECTION COSINE CHANGES IN THE
C SIDECHAIN WHEN GOING FROM L TO D CONFIGURATION.
C ADJUSTMENT DOES NOT APPLY TO THE N-METHYL GROUP   DR  11/91  ^^^&&&
C     CIS(3) = CIS(3)*SIGN
C
C CALCULATE THE MATRIX FOR ROTATING ABOUT THE BOND.
C
      CALL ROTSET(CIS,CHI,A)
C
C UPDATE THE PREVIOUS ROTATION MATRIX TO INCLUDE THE LATEST ROTATION.
C
      CALL DMM(ROT,A,A1)
C
C CONNECT AND ROTATE THE ATOMS ATTACHED TO THIS BOND.
C
      DO 140 L=K,MN
      CALL TRANSF(A1,L,LE)
  140 CONTINUE
C
      END IF
C
C   THE N-METHYL CHAIN GENERATION IS COMPLETE.
C
      RETURN
      END
      SUBROUTINE GNPRO
C
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE PROLINE AND
C HYDROXYPROLINE RESIDUES, EXCEPT FOR THE CARBONYL O, AND THE HD1 OF
C HYDROXYPROLINE.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION A(9),MATC(9)
      DOUBLE PRECISION CSTH1,SNTH1,CSANG,SNANG,IDENT(9)
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      DOUBLE PRECISION ANG,PROANG(3)
      DOUBLE PRECISION DABS,DCOS,DSIN
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN008'
      INCLUDE 'COMMON.GEN003'
      INCLUDE 'COMMON.GNROU'

      COMMON/GEN006/PROANG
      DATA IONE /1/, ITHREE /3/,ISIX /6/
C
      NBT=NGEOM(NT)
      PHI=SIGN * PROANG(NBT)
C      IF (NT.EQ.34) WRITE(*,'(a15,f8.3)') 'PHI OF AZE ', PHI
      ANGULO(1,N)=PHI-PI
C     ALLOW PHI TO VARY FROM -75.
C Take the comment of the following line if you want PHI variable
C D.R.(1990)
C      PHI = ANGULO(1,N) + PI
C
C ATTACH THE C-DELTA AND C-ALPHA TO N.
C
      DO 110 J=2,3
      CALL TRANSF(MATA,J,IONE)
  110 CONTINUE
C
C PHI DOES NOT EQUAL ZERO, SO MODIFY THE ROTATION MATRIX.
C
      CSANG=DCOS(PHI)
      SNANG = DSIN(PHI)
      DO 120 J=1,3
      MATB(J,1) = MATA(J,1)
      MATB(J,2) = MATA(J,2)*CSANG + MATA(J,3)*SNANG
      MATB(J,3) = - MATA(J,2)*SNANG + MATA(J,3)*CSANG
  120 CONTINUE
C
C ATTACH THE C' TO C-ALPHA.
C
      CALL TRANSF(MATB,ISIX,ITHREE)
C
C ATTACH THE REMAINING ATOMS TO THE NITROGEN ATOM, EXCEPT FOR THE
C CARBONYL O, AND THE HD1 OF HYDROXYPROLINE.
C
      DO 130 J=4,14
      IF (J.EQ.6.OR.J.EQ.7) GO TO 130
      CALL TRANSF(MATA,J,IONE)
  130 CONTINUE
      K=15
C     IF ( NCHI(10) .EQ. 0 ) K = 8
      RETURN
      END
      SUBROUTINE GNSIDE
C  -Altered 11/91  to include residues with N-methyl groups.
C                                                     DR ^^^&&&
C THIS SUBROUTINE GENERATES THE COORDINATES OF THE SIDECHAIN ATOMS.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION A(9),MATC(9),DABS
      DOUBLE PRECISION CST,SNT,CDELTA,SDELTA,PHI,PSI,OMEGA,CHI,CIS(3)
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN003'
      INCLUDE 'COMMON.GNROU'

      LOGICAL NMETHYL
C     DATA PI/ 3.141593 /
      DATA ERROR / .0001 /
C
      NX = NCHI(NT)
C ********************************************
C NEW CODE TO ACCOUNT FOR N-METHYL GROUPS.   D.R. 11/91  ^^^&&&
      IF (NMETHYL(N)) THEN
         ISTB = 2
      ELSE
         ISTB = 1
      END IF
C ********************************************
      DO 160 IBOND=ISTB,NX
C
C MB IS THE BEGINNING OF THE BOND, LE IS THE END, AND MN INDICATES THE
C LAST ATOM TO BE AFFECTED BY THE BOND ROTATION.
C
      MB = NDPT1(IBOND,NT)
      LE = NDPT2(IBOND,NT)
      MN = NUM(IBOND,NT) + K - 1
      CHI = ANGULO(IBOND + 3,N) - PI
C
C IF NO CHI ROTATION IS CALLED FOR, ATTACH THE SIDECHAIN ATOMS.
C
      IF (DABS(CHI) .GT. ERROR) GO TO 120
      DO 110 L=K,MN
      CALL TRANSF(ROT,L,LE)
  110 CONTINUE
      GO TO 160
C
C STORE THE DIRECTION COSINES FOR THIS BOND IN CIS.
C
  120 DO 130 I=1,3
      CIS(I)=CHIANG(I,IBOND,NT)
  130 CONTINUE
C
C IF IFEVEN IS -1, THEN THE COORDINATES AS STORED WILL BE FLIPPED 180
C DEGREES ABOUT THE C'-N BOND WHEN THEY ARE ATTACHED.  THEREFORE THE
C DIRECTION COSINES OF THE BOND MUST ALSO BE ADJUSTED.
C
      CIS(2)=FLOAT(IFEVEN)*CIS(2)
      CIS(3)=FLOAT(IFEVEN)*CIS(3)
C
C ADJUST CIS(3) TO ACCOUNT FOR THE DIRECTION COSINE CHANGES IN THE
C SIDECHAIN WHEN GOING FROM L TO D CONFIGURATION.
C
      CIS(3) = CIS(3)*SIGN
C
C CALCULATE THE MATRIX FOR ROTATING ABOUT THE BOND.
C
      CALL ROTSET(CIS,CHI,A)
C
C UPDATE THE PREVIOUS ROTATION MATRIX TO INCLUDE THE LATEST ROTATION.
C
      CALL DMM(ROT,A,A1)
C
C CONNECT AND ROTATE THE ATOMS ATTACHED TO THIS BOND.
C
      DO 140 L=K,MN
      CALL TRANSF(A1,L,LE)
  140 CONTINUE
C
      IF(IBOND.NE.NX) THEN
         MM=NDPT1(IBOND+1,NT)
C MM IS THE BEGINNING OF THE NEXT BOND. IF MM EQUALS MB, THEN A BRANCH
C EXISTS AT THIS POINT IN THE SIDECHAIN. DO NOT UPDATE THE PREVIOUS
C ROTATION MATRIX TO INCLUDE THE LATEST ROTATION.
         IF(MM.NE.MB) THEN
              DO 150 L=1,9
              ROT(L) = A1(L)
  150         CONTINUE
         END IF
      END IF
C
C   UPDATE K TO INDICATE THE NEXT ATOM TO BE ATTACHED.
C
  160 K = MN + 1
C
C   THE SIDECHAIN GENERATION IS COMPLETE.
C
      RETURN
      END
      SUBROUTINE INIT_LRESI
C when using PRO-HIS with changes in ring conformations it is necessary 
C to reset the LIST array.
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.LIST0'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL LPROLIN, LHISTID
      NPH=0
      LPRHI=0
      ISUMPH=0
      LIST0(1)= LIST(1)
      LIST0(INUMRS)= LIST(INUMRS)
      DO 80 J=2,INUMRS-1
         INDX=0
         INDPH(J)=0
         LIST0(J)= LIST(J)
         LIT= IABS(LIST(J))
C NOW LET'S SEE IF THIS IS AN "L" OR "D" RESIDUE
         ISIGNO=ISIGN( 1, LIST(J) )
         IF (LHISTID(J)) THEN
            NPH=NPH+1
C RESIDUE IS HIS, HIE or HIP
C NOTE: FOR HIE, LIST=25 and KNDRES=26
C       FOR HIP, LIST=28 and KNDRES=27
            IF (NV(J).GT.0) THEN
C WITH VARIABLE ANGLES
               INDPH(J)=1
               LIST0(J)= ISIGNO*7
               IF (LIT.EQ.25) INDX=1
            ENDIF
            LPRHI=LPRHI*2+INDX
         ENDIF
         IF (LPROLIN(J).AND.(LIT.NE.34)) THEN
C RESIDUE IS PRO OR H-PRO UP OR DOWN.
C LIST 34  IS AZETIDIN.                         DR 7/95
            NPH=NPH+1
            IF (NV(J).GT.0) THEN
C WITH VARIABLE ANGLES
               IF (LIT.EQ.13 .OR. LIT. EQ. 33) LIST0(J)= ISIGNO*13
               IF (LIT.EQ.22 .OR. LIT. EQ. 35) LIST0(J)= ISIGNO*22
               IF (LIT.EQ.33 .OR. LIT.EQ.35 ) INDX=1
               INDPH(J)=1
            ENDIF
            LPRHI=LPRHI*2+INDX
         ENDIF
         ISUMPH=ISUMPH + INDPH(J)
  80  CONTINUE
      LOGICPH=(ISUMPH.GT.0)
      WRITE(JOUT,1200) NPH, LPRHI, LOGICPH
1200  FORMAT(' No. PRO-HIS res. = ', i4,' Binary Code= ',i6,
     & ' variable HIS or PRO  ? ',l4)
C     WRITE(JOUT,1220)'INDPH ARRAY= ' , (INDPH(I), I=1,INUMRS)
C     WRITE(JOUT,1220)'LIST0 ARRAY= ' , (LIST0(I), I=1,INUMRS)
1220  FORMAT(A15,20I3)
      RETURN
      END

      SUBROUTINE INPUTT

C THIS SUBROUTINE READS THE STANDARD RESIDUE DATA AND STORES THEM IN
C APPROPRIATE ARRAYS.
C
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN000'
      INCLUDE 'COMMON.GEN001'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.GEN008'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.PUT14'
      INCLUDE 'COMMON.PUT15'
      INCLUDE 'COMMON.TORPX'
      INCLUDE 'COMMON.THRLET'
      INCLUDE 'COMMON.EXTPH'
C Change AL 7/29/93 (bridges)
      INCLUDE 'COMMON.BRIDGES'
C Change 8/13/93 (read atom solvation types)
      INCLUDE 'COMMON.SOLVAT2'
      LOGICAL LPRN
      CHARACTER*1 NMETR
C
C The following code has been taken from AL's inputtmod.f
C
C Change 4/21/93. The number of amino-acid residues (nreg) and the number
C of blocking groups (nend) in the database are read in.
C
      READ (JREAD,*) NREG,NEND
C     print *,'inputt: nreg=',nreg,' nend=',nend
C
C THE FOLLOWING SECTION IS FOR FULL AMINO ACID RESIDUES:
C
      LPRN=.FALSE.

      DO 160 I=1,NREG
c        if ((i.eq.1) .or.(i.eq.20))  then
c          lprn=.true.
c        else
c          lprn=.false.
c        endif
C
C Change 1/4/95 - Three and one-letter codes as well as data for
C generation of side chains with branching, IBRNCH are now read 
C from the residue data file.                   AL & DR   JAN/95 
C
C NMETRES (logical) is used to determine if the residue is 
C  nmethylated or not.                                 DR AUG/96
      READ(JREAD,210) (TITL(L,I),L=1,4),ARES(I),ONE_LET(I),NFATO(I),
     &     qqq_read(i),pK0_read(i), nmetr
      nmetres(i)=(nmetr.eq.'T')
C     lprn=.true.
      if (lprn) write (jout,'(i4,2x,4a,2x,a3,2x,a3,2i5,f8.3,2x,l1)' )
     &i,(titl(l,i),l=1,4),ares(i),one_let(i),nfato(i),qqq_read(i),
     &pK0_read(i),  nmetres(i)
C     lprn=.false.
C     if (lprn) write (*,'(i4,2x,4a,2x,a3,2x,a3,2i5,f8.3,2x,l1)' )
C    &i,(titl(l,i),l=1,4),ares(i),one_let(i),nfato(i),qqq_read(i),
C    &pK0_read(i),  nmetres(i)

      READ(JREAD,220) NATOMS(I),NCHI(I),SNTH2(I),CSTH2(I),SDEL(I),
     1  CDEL(I)

      READ(JREAD,280) KNDRES(I),NT,NGEOM(I),NTOR(I)

C     lprn=.true.
      if (lprn) write (jout,'(4a,10x,i4,6x,i4,15x,a3,6x,a3)' ) 
     & (titl(l,i),l=1,4), i, kndres(i), ares(i), one_let(i)
C     lprn=.false.

      KINDI=IABS(KNDRES(I))
C
C --- AL
C ntor(i) is the number of torsional terms that are associated with
C _explicit_ dihedral angles, while nt is the _total_ number of the 
C torsional terms associated with a residue, i.e. including the 
C possible angles of the bridge formed by this residue. 
C The parameters of the _implicit_ torsional angles (i.e. those which 
C will be calculated from the Cartesian coordinates after a bridge 
C is formed) are stored in the arrays after the parameters
C of the explicit angles.
C
      IF(NT.EQ.0)GO TO 120
      IF (NTOR(I).EQ.0) NTOR(I)=NT
      DO 110 J=1,NT
      READ(JREAD,290) AR(J,I),NBB(J,I),NSS(J,I),NANG(J,I)
  110 CONTINUE
  120 NUMCHI=NCHI(I)
      IF (NUMCHI .EQ. 0) GO TO 140
C The program now handles more than one branch on the side-chains. 
C If there is a branch this is defined specifically as data for the 
C bond that branches out. Also, to bring compatibility with the IUPAC 
C conventions (ECEPP reads the torsional angles following this convention),
C a variable ISHFK is defined for each bond to indicate is there
C is a shift of the bond definition given in rsdata.
C In some cases, like ILE,  organization of the rsdata file for ECEPP 
C requires a different rearrangement of the bonds numbers for proper
C generation.       D.R   AUG/2/95
      DO 130 J = 1,NUMCHI
      READ(JREAD,230) (CHIANG(L,J,I),L=1,3),NDPT1(J,I),NDPT2(J,I),
     1  NUM(J,I),LRT1(J,I), IBRNCH(J,KINDI),ISHFK(J,KINDI)
C      write(*,230) (CHIANG(L,J,I),L=1,3),NDPT1(J,I),
C    1 NDPT2(J,I),NUM(J,I),LRT1(J,I),IBRNCH(J,KINDI),ISHFK(J,KINDI)
      if (lprn) write(jout,230) (CHIANG(L,J,I),L=1,3),NDPT1(J,I),
     1 NDPT2(J,I),NUM(J,I),LRT1(J,I),IBRNCH(J,KINDI),ISHFK(J,KINDI)
  130 CONTINUE
  140 NATOM = NATOMS(I)
      READ(JREAD,240) ALPHA(1,I),LTYPE(1,I),NTYPE(1,I),CHG(1,I),
     1 NSN15(1,I),NSN14(1,I),NFN14(1,I)
C     if(ntype(1,i) .ne. 0) read(jread,*) fixvol(1,i), redrad(1,i)
      DO 150 J = 2,NATOM
C
C --- DR & AL
C Change 8/13/93 - the solvation types are also read in 
C WARNING! Done on FRIDAY THE 13TH!!! It's got to be wrong!!!
C
      READ(JREAD,250) (XOORD(L,J-1,I),L=1,3),ALPHA(J,I),LTYPE(J,I),
     1 NTYPE(J,I),CHG(J,I),NSN15(J,I),IJUNK,NSN14(J,I),NFN14(J,I)
C     if(ntype(j,i) .ne. 0) read(jread,*) fixvol(j,i), redrad(j,i)
  150 CONTINUE
      READ(JREAD,250) (XOORD(L,NATOM,I),L=1,3)
c     if (lprn) write(jout,250) (XOORD(L,NATOM,I),L=1,3)
c     do l=1,natoms(i)
c     if (lprn) write(jout,*) i,nsn15(l,i),nsn14(l,i),nfn14(l,i)
c     enddo
  160 CONTINUE
C
C THE FOLLOWING SECTION IS FOR END GROUPS:
C
      DO 180 I=1,NEND
C        if (i.eq.22)  then
C          lprn=.true.
C        else
C          lprn=.false.
C        endif
      IP=I+NREG
      II=I+num_restypes
      READ(JREAD,210) (TITL(L,IP),L=1,4),ARES(II),ONE_LET(II),ijunk,
     & qqq_read(ii),pK0_read(ii)
c     lprn=.true.
      if (lprn) write (jout,'(i4,2x,4a,2x,a3,2x,a3,i5,f10.3)' )
     &   ip,(TITL(L,IP),L=1,4),ares(ii),one_let(ii),qqq_read(ii),
     & pK0_read(ii)
C     write (*,'(i4,2x,4a,2x,a3,2x,a3,i5,f10.3)' )
C    &   ip,(TITL(L,IP),L=1,4),ares(ii),one_let(ii),qqq_read(ii),
C    & pK0_read(ii)
c     lprn=.false.
      READ(JREAD,261) NDATOM(I),NBOND(I),(NNDPT1(L,I),NNDPT2(L,I),L=1,6)
     & ,NTORNI,NTORN(I)
      IF (NTORN(I).EQ.0) NTORN(I)=1
      IF (NTORNI.EQ.0) NTORNI=1
C
C --- AL
C ntorn(i) is the number of torsional terms that are associated with
C _explicit_ dihedral angles, while ntorni is the _total_ number of 
C torsional terms associated with a residue, i.e. including the 
C possible angles of the bridge formed by this residue. 
C The parameters of the _implicit_ torsional angles (i.e. those which 
C will be calculated from the Cartesian coordinates after a bridge 
C is formed) are stored in the arrays after the parameters
C of the explicit angles.
C
      READ(JREAD,270) KNDEND(I),(AAN(L,I),NBBN(L,I),NSSN(L,I),NANGN(L,I)
     & ,L=1,NTORNI)

C     lprn=.true.
      if (lprn) write (jout,'(4a,10x,i4,6x,i4,15x,a3,6x,a3)' ) 
     & (titl(l,ip),l=1,4), i, kndend(i), ares(ii), one_let(ii)
C     lprn=.false.

      if (lprn) write (jout,*) 'ntorn=',ntorn(i),' ntorni=',ntorni
      do ii=1,ntorni
        if (lprn) write (jout,'(f10.5,3i5)') aan(ii,i),nbbn(ii,i),
     & nssn(ii,i),nangn(ii,i)
      enddo
      NB = NBOND(I)
      IF (NB .EQ. 0) NB = 1
      READ(JREAD,260) (LR(L,I),L=1,NB)
      if (lprn) write (jout,'(16i5)') (lr(l,i),l=1,nb)
      ND=NDATOM(I)-3
      IF (ND.LT.7) ND=7
      READ(JREAD,260) (MSX15(L,I),L=1,ND)
      READ(JREAD,260) (MSX14(L,I),L=1,ND)
      READ(JREAD,260) (MFX14(L,I),L=1,ND)
      if (lprn) write (jout,'(16i5)') (msx15(l,i),l=1,nd)
      if (lprn) write (jout,'(16i5)') (msx14(l,i),l=1,nd)
      if (lprn) write (jout,'(16i5)') (mfx14(l,i),l=1,nd)
      NATOM = NDATOM(I)
      DO 170 J = 1,NATOM
      N14(J,I)=1
      N15(J,I)=1
      READ(JREAD,250) (ENOORD(L,J,I),L=1,3),EALPHA(J,I),
     1  NDTYPE(J,I),NETYPE(J,I),ECHG(J,I),MSN15(J,I,1),MFN15(J,I,1),
     2  MSN14(J,I,1),MFN14(J,I,1),ICONT
      IINT=1
cd    if (lprn) write (jout,*) 'icont=',icont
      DO WHILE (ICONT.GT.0)
        IINT=IINT+1
cd    if (lprn) write (jout,*) 'icont=',icont
        READ(JREAD,251) MSN15(J,I,IINT),MFN15(J,I,IINT),MSN14(J,I,IINT),
     &                  MFN14(J,I,IINT),ICONT
      ENDDO
      IINT=1
      DO WHILE (MSN15(J,I,IINT).GT.0)
        IINT=IINT+1
      ENDDO
      N15(J,I)=IINT-1
      IINT=1
      DO WHILE (MSN14(J,I,IINT).GT.0)
        IINT=IINT+1
      ENDDO
      N14(J,I)=IINT-1
cd    if (lprn) write (jout,*) j,(msn14(j,i,iint),
cd   &                mfn14(j,i,iint),iint=1,n14(j,i)),
cd   &               (msn15(j,i,iint),mfn15(j,i,iint),iint=1,n15(j,i))
c     if(netype(j,i) .ne. 0) read(jread,*) dfixvol(j,i), dredrad(j,i)
  170 CONTINUE
  180 CONTINUE
C
C --- AL
C Read bridge data (changes on 4/16/93)
C
      READ (JREAD,*,END=934)
      READ (JREAD,*,END=934)
      READ (JREAD,*,END=934)
      NRB=0
      NBRIDI=1
      lprn = .false.
      DO WHILE (NBRIDI.GT.0)
        READ (JREAD,'(6I5,F10.5)') NBRIDI,IBRID1,IBRID2,IBRID3,IBRID4,
     &                             IBRID5,D0BI
        IF (NBRIDI.GT.0) THEN
          NRB=NRB+1
          NBRID(NRB)=NBRIDI
          IBRID(1,NRB)=IBRID1
          IBRID(2,NRB)=IBRID2
          IBRID(3,NRB)=IBRID3
          IBRID(4,NRB)=IBRID4
          IBRID(5,NRB)=IBRID5
          if (lprn) write (jout,*) nbridi,(ibrid(l,nrb),l=1,5)
          D0B(NRB)=D0BI
          READ (JREAD,*) NKMOV(NRB),(INDKAI(NRB,J),J=1,NKMOV(NRB))
        ENDIF
      ENDDO
      NPBRID=0
      IR1=1
cd    lprn=.true.
      DO WHILE (IR1.GT.0)
c Change 12/29/94 to introduce improper torsions for lactam bridges --- AL
        read (jread,*) ir1,ir2,nbir,arir,im1,im2,aic1,aic2,iio1,iio2
C       write (*,*) ir1,ir2,nbir,arir,im1,im2,aic1,aic2,iio1,iio2
        if (lprn) write (jout,*) 'ir1=',ir1,' ir2=',ir2
        IF (IR1.GT.0) THEN
          II=ICANT(IR1,IR2)
	  IMPROP(1,II)=IM1
	  IMPROP(2,II)=IM2
	  ARIM(1,II)=AIC1
	  ARIM(2,II)=AIC2
          NBBB(II)=NBIR
          ARB(II)=ARIR
	  iiomeg(1,ii)=iio1
	  iiomeg(2,ii)=iio2
          READ (JREAD,'(7F10.5)') (R0B(L,II),L=1,7)
cd        write (jout,*) (r0b(l,ii),l=1,7)
          READ (JREAD,'(7F10.5)') (CONB(L,II),L=1,7)
          if (lprn) write (jout,*) (conb(l,ii),l=1,7)
          IINT=1
          DO JJ=1,MATRES
            DO KK=1,MATRES
              NBBRID(II,JJ,KK)=5
            ENDDO
          ENDDO
          DO WHILE (IINT.GT.0)
            READ (JREAD,'(3I5)') IINT,JINT,NBTI
            IF (IINT.GT.0) THEN
              IF (IR1.GT.IR2) THEN
                NBBRID(II,IINT,JINT)=NBTI
              ELSE
                NBBRID(II,JINT,IINT)=NBTI
              ENDIF
            ENDIF
          ENDDO
          if (lprn) write (jout,*) 'nbbrid array:'
          NBRIDI=NBRID(IR1)
          IF (NBRIDI.GT.NUM_RESTYPES) THEN
            NBRIDI=NBRIDI-NUM_RESTYPES
            NATI=NDATOM(NBRIDI)
          ELSE
            NATI=NATOMS(NBRIDI)
          ENDIF
          NBRIDJ=NBRID(IR2)
          IF (NBRIDJ.GT.NUM_RESTYPES) THEN
            NBRIDJ=NBRIDJ-NUM_RESTYPES
            NATJ=NDATOM(NBRIDJ)
          ELSE
            NATJ=NATOMS(NBRIDJ)
          ENDIF 
          do jj=1,nati
            if (lprn) write (jout,'(40i2)') (nbbrid(ii,jj,kk),kk=1,
     &                    natj)
          enddo
        ENDIF
      ENDDO
      LPRN=.FALSE.
      RETURN
934   WRITE(JOUT,'(A)') ' Bridging info is missing'
      RETURN
  210 FORMAT(4A4,4X,A3,2X,A3,I3,i5,f8.3,4X,A1)
  220 FORMAT(2I5,4F10.7)
  230 FORMAT(5X,3F9.6,5X,3I3,I10,1X,I2,2X,I2)
C 240 FORMAT(37X,A3,I2,F10.6,I5,2X,4I3)
  240 FORMAT(37X,A3,I2,I3,F7.2,I5,2X,4I3)
C 250 FORMAT(3F10.3,7X,A3,I2,F10.6,I5,I2,3I3)
  250 FORMAT(3F10.3,7X,A3,I2,I3,F7.2,I5,I2,3I3)
  251 FORMAT(52x,i5,i2,3i3)
  260 FORMAT(14I5)
  261 FORMAT(16I5)
  270 FORMAT (I4,3(F10.4,3I5)/(4x,3(f10.4,3i5)))
  280 FORMAT(4I4)
  290 FORMAT(F10.4,3I5)
      END
      SUBROUTINE MATRIX(CSANG,SNANG,ROTATE,MATC)
C
C THIS SUBROUTINE IS USED IN THE GENERATION OF COORDINATES WHICH
C DEPEND ON A PSI OR OMEGA DIHEDRAL ANGLE.  IT COMPUTES A ROTATION
C MATRIX MATC FROM 'ROTATE' (THE VALUE OF THE DIHEDRAL ANGLE MINUS PI),
C AND CSANG AND SNANG, THE COSINE AND SINE OF THE ANGLE BETWEEN THE
C ROTATABLE BOND AND THE X-AXIS.
C
      DOUBLE PRECISION CSANG,SNANG,ROTATE,MATC
      DOUBLE PRECISION DCOS,DSIN,CROT,SROT,CS1
      DIMENSION MATC(9)
      CROT=DCOS(ROTATE)
      SROT=DSIN(ROTATE)
      CS1=1.0D0-CROT
      MATC(1)=CROT+CS1*CSANG**2
      MATC(2)=CS1*CSANG*SNANG
      MATC(3)=-SROT*SNANG
      MATC(4)=MATC(2)
      MATC(5)=CROT+CS1*SNANG**2
      MATC(6)=SROT*CSANG
      MATC(7)=-MATC(3)
      MATC(8)=-MATC(6)
      MATC(9)=CROT
      RETURN
      END
      SUBROUTINE MODBOND(NA,NB,RAN)
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.ATOMSS'
      DIMENSION TEMP(3)
         RAB = DST(COORD(1,NA),COORD(1,NB))
         DO 151 I=1,3
           TEMP(I) = COORD(I,NA) + RAN*(COORD(I,NA)-COORD(I,NB))/RAB
  151    CONTINUE
C
         DO 152 I=1,3
           COORD(I,NA) =TEMP(I)
  152    CONTINUE
      RETURN
      END
      LOGICAL FUNCTION NSWITCH(I)
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'

      LISTIJ=LIST(I)
      LISTIJ=IABS(LISTIJ)
      KINDIJ=IABS(KNDRES(LISTIJ))
      NSWITCH= (KINDIJ.EQ.42.OR.KINDIJ.EQ.43)
      RETURN
      END
      SUBROUTINE PARAMD
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.LBONDSX'
      INCLUDE 'COMMON.PRAMX'
      INCLUDE 'COMMON.IOUNIT'
      LOGICAL NMETHYL
C
C AMINO ENDGROUP
C

      write(jout,*) 'crk jestem w proc PARAMD'


      NATM=NPRE(INUMRS+1)
      LAMIN=LIST(1)
      KAMIN=KNDEND(LAMIN)
      KAMIN=IABS(KAMIN)
      NK=NBOND(LAMIN)
      IF (NK.GE.1) THEN
         DO 10 K=1,NK
           IE1(K)=NNDPT1(K,LAMIN)
           IE2(K)=NNDPT2(K,LAMIN)
* Change 4/9/93 AL's modifications to generalize N-terminal end groups.
           LLR=LR(K,LAMIN)
           IF (LLR.LT.IE1(K)) THEN
             LROT2(K)=IE1(K)-1
             LROT1(K)=LLR
           ELSE
             LROT2(K)=NATM
             LROT1(K)=LLR
           ENDIF
   10    CONTINUE
      ENDIF
      KS=maxnum_dihe
      LASTFL=INUMRS-1
C
C RESIDUES
C
      DO 80 I=2,LASTFL
      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=KNDRES(LISTI)
      KINDI=IABS(KINDI)
      NCHS=NCHI(LISTI)
      NPREIJ=NPRE(I)
      NCH=NCHS+3
      NPREIK=NPRE(I+1)
      K1=KS+1
      K2=KS+NCH
      DO 30 K=K1,K2
      LROT2(K)=NATM
   30 CONTINUE
      KS3=KS+3
      IF (NCHS.GT.0) THEN
C CHI'S
C

        DO 60 K=1, NCHS
         KP=KS3+K
         ISKP= 0
C Modified to account for residues with N-methyl groups.D.R.11/91^^^&&&
         KRT1=LRT1(K,LISTI)+NPREIJ
         IF (NMETHYL(I).AND.(K.GT.1) ) THEN
            KRT2=NPREIK - NUM(1,LISTI)
         ELSE
            KRT2=NPREIK
         END IF
C
c      (KINDI.EQ.8).OR.(KIND.EQ.40).OR.(KINDI.EQ.58)
C NDPT2 OF CHI2 AND CHI3 OF ISOLEUCINE  (aILE and N-METHYL ISOLEUCINE) 
C MUST BE CORRECTED BECAUSE THE TWO ANGLES ARE REVERSED FOR GENERATION
C This is accomplished  now via ISHFK(K,KINDI) which allows a
C general treatment for similar cases.    DR 8/95.
C
         ISKP= ISHFK(K,KINDI)


C SPECIAL SECTION FOR BRANCHED SIDECHAINS OF RESIDUES ISOLEUCINE,
C LEUCINE, ARGININE, THREONINE, VALINE, AND ARGININE+
C
         IA = IBRNCH(K,KINDI)
         IF (IA.GT.0) THEN
            KRT2=KRT1+NUM(K,LISTI)-1
         END IF
         IE1(KP+ISKP)=NPREIJ+NDPT1(K,LISTI)
         IE2(KP+ISKP)=NPREIJ+NDPT2(K,LISTI)
         LROT1(KP+ISKP)=KRT1
         LROT2(KP+ISKP)=KRT2
C        write(jout,1000) I, LISTI, K+ISKP, IA,
C    &    IE1(KP+ISKP),IE2(KP+ISKP),LROT1(KP+ISKP),LROT2(KP+ISKP)
1000     format(' RES ', i3,' LISTI ',i3,' CHI=', I2,'IA =',i4,
     &    ' AT1= ', i4, ' AT2= ',i4, ' LROT1 ',i4,' LROT2 ',i4)
   60  CONTINUE

      ENDIF

   70 CONTINUE
C
C PHI
C
      LROT1(KS+1)=4+NPREIJ
      IE1(KS+1)=NPREIJ+1
      IE2(KS+1)=NPREIJ+3
C
C PSI
C
      LROT1(KS+2)=-I-1
      IE1(KS+2)=NPREIJ+3
      IE2(KS+2)=NPREIJ+6
C
C OMEGA
C
      IE1(KS+3)=NPREIJ+6
      IE2(KS+3)=NPREIK+1
      LROT1(KS+3)=NPREIK+2
      KS=KS+maxnum_dihe
   80 CONTINUE
C
C CARBOXYL ENDGROUP
C
      LCARB=LIST(INUMRS)
      KCARB=KNDEND(LCARB)
      KCARB=IABS(KCARB)
      NK=NBOND(LCARB)
      IF (NK.LT.2) RETURN
      NPREIJ=NPRE(INUMRS)
      DO 300 KK=2,NK
      K = KS + KK - 1
      IE1(K)=NNDPT1(KK,LCARB)+NPREIJ-1
      IE2(K)=NNDPT2(KK,LCARB)+NPREIJ-1
      IF (KCARB.NE.16) GO TO 100
      IF (KK.EQ.NK) GO TO 90
      LROT1(K)=LR(NK,LCARB)+NPREIJ
      GO TO 200
   90 LROT1(K)=LR(KK-1,LCARB)+NPREIJ
      LROT2(K) = LROT1(K)+2
      GO TO 300
  100 LROT1(K)=LR(KK,LCARB)+NPREIJ
  200 LROT2(K)=NATM
  300 CONTINUE
      RETURN
      END
      SUBROUTINE ROTSET(CIS,CHI,A)
C
C THIS SUBROUTINE IS USED IN THE GENERATION OF COORDINATES WHICH DEPEND
C ON A DIHEDRAL ANGLE IN A SIDE CHAIN OR END GROUP.  IT COMPUTES A
C ROTATION MATRIX 'A' FROM THE DIRECTION COSINES (CIS) OF THE
C ROTATABLE BOND, AND CHI, THE VALUE OF THE DIHEDRAL ANGLE MINUS PI.
C
      DOUBLE PRECISION CIS,CHI,A
      DOUBLE PRECISION DCOS,DSIN,CS,SN
      DOUBLE PRECISION CS1,A1,A2
      DIMENSION A(3,3),CIS(3)
 12   CS = DCOS(CHI)
      SN = DSIN(CHI)
      CS1 = 1.0 - CS
      A(1,1) = CS + CS1*CIS(1)*CIS(1)
      A(2,2) = CS + CS1*CIS(2)*CIS(2)
      A(3,3) = CS + CS1*CIS(3)*CIS(3)
      A1 = CS1*CIS(1)*CIS(2)
      A2 = SN*CIS(3)
      A(1,2) = A1 - A2
      A(2,1) = A1 + A2
      A1 = CS1*CIS(1)*CIS(3)
      A2 = SN*CIS(2)
      A(1,3) = A1 + A2
      A(3,1) = A1 - A2
      A1 = CS1*CIS(2)*CIS(3)
      A2 = SN*CIS(1)
      A(2,3) = A1 - A2
      A(3,2) = A1 + A2
      RETURN
      END
      SUBROUTINE SETUP_X(IARGUM)

      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.BONDSX'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.TOR2'
      INCLUDE 'COMMON.TORQUEX'
C NEW COMMONS  AUG -93
      INCLUDE 'COMMON.SETUP'
      INCLUDE 'COMMON.KVS'
      INCLUDE 'COMMON.BRIDGES'
      INCLUDE 'COMMON.CNTRL'
      INCLUDE 'COMMON.MINPAR'
      INCLUDE 'COMMON.ACAR'
      INCLUDE 'COMMON.IOUNIT'
      INCLUDE 'COMMON.KASOS'
      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.XBOUNDX'
      INCLUDE 'COMMON.MOVE'
      INCLUDE 'COMMON.TRACK'
      INCLUDE 'COMMON.MYCONF'
      INCLUDE 'COMMON.LIST0'
      INCLUDE 'COMMON.EXTPH'

      LOGICAL LPROLIN
      write(jout,*) 'crk  - jestem w procedurze SETUP_X(IONE)'

C IF THE SOLVATION ENERGY IS REQUESTED, THEN CALCULATE THE
C POSSIBLE IONIZATION STATES AND SET THE RESIDUES TO UNCHARGED STATES.
C     IF (ICOMP(3).EQ.1) THEN
C        CALL DEGIONZ
C     END IF

C VTF
      IF(IRUNTYP.EQ.7) IRANG=INUMRS

*********************************************************** 
      write(jout,*) 'crk CALL PARAM( SUM )'

      CALL PARAM( SUM )

      write(jout,*) 'crk wychodze z CALL PARAM( SUM )'

C  INIT_BRIDGE CHECKS THE SEQUENCE FOR THE PRESENCE OF BRIDGES AND
C PROCESSES THE INFO READ IN READ_BRIDGE.
crk      IF (IARGUM.EQ.1) CALL INIT_BRIDGE

      write(jout,*) 'crk CALL PARAMD w setup_x'
      CALL PARAMD

C     INITIALIZE D ARRAY
      DO 20 I=1,maxnum_var
         D(I) = 1.0E0
20    CONTINUE

C   SUBROUTINE SPEC HAS BEEN CHANGED TO ADAPT IT TO THE NEW CODE. DR AUG2-93.
C   READING OF INPUT INFO IS DONE IN READ_SPEC ROUTINE. 
C   CAREFUL: SPECV IS ALSO CALLED IN GENCMER.
C     WRITE(JOUT,'(A)') 'SPEC NOW'

crk - i tak tylko bede zmieniac lancuchy boczne ...
crk      CALL SPECV(IARGUM)
 
C ZIMMERMAN CODE OF READ CONFORMATION USED AS REFERENCE. DR DEC23 1994 
      IF (REFCOD) THEN 
         CALL PLACE
         DO I=1,INUMRS
      	    IF (I.NE.1.AND.I.NE.INUMRS)  THEN
      	       ZIMMRE(I)=ZIMMK(I)
      	    END IF
         ENDDO
      END IF

      NUMVAR= 0
      NNKAI= 0
      J= 1
      DO 60 K=1,INUMRS
        NUMVAR = NUMVAR + NV(K)

        IF ( NV(K) .NE. 0 ) THEN
           IIB=0
C THE FOLLOWING VARIABLES ARE DEFINED AS SHARED, AND THEY WILL
C BE INITIALIZED ONLY ONCE (i.e. IARGUM=1 or IIB not ZERO)   DR NOV-10-93.
C NKAI1,NKAI2
           IF (IARGUM.EQ.1) THEN
             L=1
             DO WHILE (L.LE.NLOOP)
               IF (NPAIR(1,L).EQ.K) THEN
                 IIB=L
                 INDB=1
                 IITB=ITB(L,1)
                 NKAI1(L)=NKMOV(IITB)
                 NNKAI=NKAI1(L)
               ELSEIF (NPAIR(2,L).EQ.K) THEN
                 IIB=L
                 INDB=2
                 IITB=ITB(L,2)
                 NKAI2(L)=NKMOV(IITB)
                 NNKAI=NKAI2(L)
               ENDIF
               L=L+1
             ENDDO

cd    WRITE (JOUT,*) 'K=',K,' IIB=',IIB,' IITB=',IITB,' NNKAI=',NNKAI
C
             IF (K.GT.1 .AND. K.LT. INUMRS) THEN
cd             WRITE (JOUT,*) 'K=',K,' LPROLIN=',LPROLIN(K)
               IF (.NOT.LPROLIN(K)) THEN
                 IFIND(K)=J
                 IPIND(K)=J+1
               ELSE
                 IFIND(K)=0
                 IPIND(K)=J
               ENDIF
             ENDIF
           ENDIF


C        SET UP INDXV ARRAY.
C
           IIKAI=0
           DO 50 I=1,NV(K)
             IF ( NDXARR(I,K) .LT. 4 ) D(J) = DVALUE
             INDXV(J) = (K - 1) * maxnum_dihe + NDXARR(I,K)
             VAR(J) = ANGLES( INDXV(J) )
C
C THE FOLLOWING VARIABLES ARE DEFINED AS SHARED, AND THEY WILL
C BE INITIALIZED ONLY ONCE (i.e. IARGUM=1 and IIB not ZERO)   DR NOV-10-93.
C ICHIND1, ICHIND2, ICHPOS1, ICHPOS2
C ICHIND1(I,J) and ICHIND2(I,J) are the positions in the variable array of the
C J-th consecutive variable angles of the first and the second residue,
C respectively, forming the Ith bridge. ICHPOS1(I,J) and ICHPOS2(I,J) define
C the LOCAL indices of these angles in the variable-angle sets of the 
C corresponding residues.
             IF (IIB.GT.0) THEN
                 DO L=1,NNKAI
                    IF (INDKAI(IITB,L).EQ.NDXARR(I,K)) THEN
                       IIKAI=IIKAI+1
                       IF (INDB.EQ.1) THEN
                         ICHIND1(IIB,IIKAI)=J
                         ICHPOS1(IIB,IIKAI)=I
                       ELSE
                         ICHIND2(IIB,IIKAI)=J
                         ICHPOS2(IIB,IIKAI)=I
                       ENDIF
                    ENDIF
                 ENDDO
             ENDIF
             J = J + 1
50         CONTINUE
           IF (IIB.GT.0 .AND. NNKAI.NE.IIKAI) THEN
C
C 11/18/93 IVARFLAG<>3 taken into account (i.e. NKAI1 and NKAI2 might be
C          modified if some of the chi's of the bridging residues are not
C          variable).
C
             IF (IVARFLAG.EQ.2 .OR. IVARFLAG.EQ.3 .OR. IVARFLAG.EQ.6)
     &       THEN
                WRITE (JOUT,'(/80(1H*)/10X,A/80(1H*))')
     & 'Error in the specification of movable bridge angles.'
               STOP
             ELSEIF (INDB.EQ.1) THEN
               NKAI1(IIB)=IIKAI
             ELSEIF (INDB.EQ.2) THEN
               NKAI2(IIB)=IIKAI
             ENDIF
           ENDIF
        END IF
60    CONTINUE
cd    WRITE (JOUT,*)
cd    WRITE (JOUT,*) 'NKAI1, ICHIND1, and ICHPOS1 array:'
cd    DO L=1,NLOOP
cd      WRITE (JOUT,'(20I4)') NKAI1(L),(ICHIND1(L,LL),LL=1,NKAI1(L)),
cd   &                                 (ICHPOS1(L,LL),LL=1,NKAI1(L))
cd    ENDDO
cd    WRITE (JOUT,*)
cd    WRITE (JOUT,*) 'NKAI2, ICHIND2, and ICHPOS2 array:'
cd    DO L=1,NLOOP
cd      WRITE (JOUT,'(20I4)') NKAI2(L),(ICHIND2(L,LL),LL=1,NKAI2(L)),
cd   &                                 (ICHPOS2(L,LL),LL=1,NKAI2(L))
cd    ENDDO

      ITOL = 10
cd    WRITE(JOUT,'(A)') 'DISOF '
      IF (IARGUM.EQ.1) THEN
         WRITE(JOUT,'(A,i5)') 'Number of variables= ', NUMVAR
crk         IF (WITHCNST) CALL SET_DISC ( ITOL ) 
crk         CALL BRIDGE_CONSTR
      ENDIF
C Pass constraints info (no. of pairs) from global to local variables.
         NPARES1 = NPAIR1
         NPARES2 = NPAIR2
C
cd    WRITE(JOUT,'(A)') 'INITOR '
crk      CALL INITOR( VAR )

cd    WRITE(JOUT,'(A)') 'GENER '
      CALL GENER
cd    WRITE(JOUT,'(A)') 'DERIV '
crk      CALL DERIV
cd    WRITE(JOUT,'(A)') 'BACK TO MAIN '
C  generate the nblk array
crk      CALL BLOCK
      IF (ICOMP(2).GT.0 .or. icomp(4) .eq. 5) THEN
C SUBROUTINE SETUP_SOLV SETS UP ARRAYS FOR THE CALCULATION OF FEH,
         CALL SETUP_SOLV
      END IF
C Set up the interaction table.
      CALL GENITER
C FILL THE LIST0 ARRAY (PRO-HIS ANG CHARGED RESIDUES).
      IF (IARGUM.EQ.1) CALL INIT_LRESI
      RETURN
      END
      SUBROUTINE TRANSF (T,J,K)
c ********* last modified 5-7-92  ************************
c changes have been made for the case of X-Pro sequences,
c following a revision of X-ray coordinates
c New variables have been introduced in the common statements.
c knn = Proline residue type (13) or Hydroxyproline type (22)
c kthe C'N bond along the x
c axis in the residue data coord.system, to be used for X-Pro sequences.
c cdelp, sdelp substitute sdel and cdel in X-Pro sequences
c ***********************************************************
C
C THIS SUBROUTINE GENERATES THE COORDINATES OF ATOM J WITH RESPECT TO TH
C AXES OF THE POLYPEPTIDE CHAIN.
C
      INCLUDE 'PARAMET.ECEPP'
      DOUBLE PRECISION T(9)
c ********* last modified 5-7-92  ************************
c ********* special angles for X-Pro sequences ***********
      INCLUDE 'COMMON.PROSEQ'
c *********************************************************
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.GEN002X'
      INCLUDE 'COMMON.GEN004'
      INCLUDE 'COMMON.GEN001'
      INCLUDE 'COMMON.GEN003'
C L REFERS TO THE ATOM TO BE ADDED TO THE COORDINATE ARRAY.
C M IS THE ATOM TO WHICH THE NEW ATOM IS BEING ATTACHED.
C SINCE THE COORDINATES FOR N ARE NOT STORED, THE COUNT OF THE STORED
C COORDINATES IS OFF BY ONE.
C
      L = NPRE(N) + J
      M = NPRE(N) + K
      KK = K - 1
C
      IF(N.EQ.INUMRS) GO TO 130
C
C IF KK = 0, THEN THE POINT OF ATTACHMENT IS THE NITROGEN.
C DEFINE IT AS (0,0,0).
C
      IF (KK.GT.0) GO TO 110
      XT = 0.0
      YT = 0.0
      ZT = 0.0
      GO TO 120
C
C ELIMINATE 3 - DIMENSIONAL SUBSCRIPTS:
C
  110 KKNT = (KK - 1)*3 + (NT - 1)*3*matres
      XT = xoord_1d(KKNT + 1)
      YT = xoord_1d(KKNT + 2)
      ZT = xoord_1d(KKNT + 3)
C
C X,Y,Z GIVE THE COORDINATES OF THE ATOM TO BE ADDED IN TERMS OF THE
C POINT OF ATTACHMENT.
C
  120 I = J - 1
      INT = (I - 1)*3 + (NT - 1)*3*matres
      X = xoord_1d(INT + 1) - XT
      Y = xoord_1d(INT + 2) - YT
      Z = xoord_1d(INT + 3) - ZT
c ********* 5-7-92 *******
c knitr is the index for the nitrogen atom
c when k=6, j=knitr, the C'N bond is rotated around the z-axis by 3
c degrees. Only the coordinates of the nitrogen atom are modified
c Following the rotation, the bond angles CaC'N is 118.0 in X-Pro
c sequences, instead of the usual 115.0
      if(knn.ne.13.and.knn.ne.22) go to 160
      if(knitr.eq.0) go to 160
      rr=sqrt(x*x+y*y)
      ango=atan2(y,x)
      dn=3.0*0.017453293
      angn=ango+dn
      x=rr*cos(angn)
      y=rr*sin(angn)
c calculates the projection of the new C'N along x, to be used
c in subroutine GENER
      sdelp=sin(-angn)
      cdelp=cos(-angn)
      knitr=0
      knn=0
c *************************************************************

      GO TO 160
C
C L AND M ARE  OFF BY 2 BECAUSE OF THE WAY THE END GROUP IS STORED.
C IF KK=0, ATTACH THE O AND FIRST ATOM OF END GROUP TO C'.
C
  130 L = L-2
      IF (KK.GT.0) GO TO 140
      XT=0.0
      YT=0.0
      ZT=0.0
      M = NPRE(N - 1) + 6
      GO TO 150
C
  140 XT=ENOORD(1,KK,NT)
      YT=ENOORD(2,KK,NT)
      ZT=ENOORD(3,KK,NT)
      M=M-2
C
  150 I=J-1
      X=ENOORD(1,I,NT)-XT
      Y=ENOORD(2,I,NT)-YT
      Z=ENOORD(3,I,NT)-ZT
      IF(J.NE.2) GO TO 160
C
C POSITION OF O STORED IN END GROUP TO REPLACE O IN LAST RESIDUE.
C
      L = NPRE(N - 1) + 7
C
C IFEVEN INDICATES WHETHER TO INVERT THE STORED COORDINATES ABOUT X.
C SIGN INDICATES D OR L CONFIGURATION.
C
  160 Y = FLOAT(IFEVEN)*Y
      Z = FLOAT(IFEVEN)*SIGN*Z
C
C ATTACH THE L TH COORD TO THE M TH COORD.
      COORD(1,L) = T(1)*X + T(4)*Y + T(7)*Z + COORD(1,M)
      COORD(2,L) = T(2)*X + T(5)*Y + T(8)*Z + COORD(2,M)
      COORD(3,L) = T(3)*X + T(6)*Y + T(9)*Z + COORD(3,M)
      RETURN
      END
      SUBROUTINE UNIMAG( NA1, NA2, IAG )
C THIS SUBROUTINE COMPUTES THE INVERSE OF THE LENGTH
C OF THE BOND AROUND WHICH THE VARIABLE DIHEDRAL
C ANGLE IAG ROTATES. NOTICE THAT THIS VALUE DOES NOT
C CHANGE IN THE COURSE OF THE COMPUTATIONS AND SO
C IT NEED TO BE EVALUATED ONLY ONCE. UNIMAG IS CALLED
C BY DERIV.
      DOUBLE PRECISION SUM,T
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.ATOMSS'
      INCLUDE 'COMMON.GRADT'
      INCLUDE 'COMMON.IOUNIT'
      DATA TOO_SMALL/10E-25/,TOO_LARGE/10E+25/
      SUM=0.0D0
      DO 10 L=1,3
      T=COORD(L,NA2)-COORD(L,NA1)
      SUM=SUM+T*T
 10   CONTINUE
      IF( (SUM.LT.TOO_SMALL).OR.(SUM.GT.TOO_LARGE)) THEN
        WRITE (JOUT,'(3(a,i5))')' ERROR IN UNIMAG: VARIABLE No.',IAG,
     &   'NA2=',NA2,'NA1= ',NA1
        GO TO 20
      ENDIF
      SUM=1.0D0/SUM
      SUM=DSQRT(SUM)
 20   RG(IAG)=SUM
      RETURN
      END
      SUBROUTINE PLACO (EPS)
C Modification of  Max Vasquez  routine PLACO.         APR-7-94. DR
c this is called at the beginning to prepare for sampling from
c `general' low-energy regions
      INCLUDE 'PARAMET.ECEPP'
      DIMENSION P(2,20)

      INCLUDE 'COMMON.VTFEX'
      INCLUDE 'COMMON.COSACO'
C     COMMON/COSACO/ DEL (7,20), EX (10),ISX, IIP
C      REAL ISX, EXX (10)
       REAL EXX (10)

      DATA P /0.010,0.163,0.006,0.304,0.011,0.180,0.018,0.203,
     1 0.002,0.113,0.102,0.000,0.010,0.208,0.001,0.167,
     2 0.012,0.192,0.018,0.268,0.010,0.265,0.008,0.214,
     3 0.100,0.166,0.017,0.260,0.007,0.310,0.015,0.053,
     4 0.003,0.140,0.004,0.281,0.004,0.193,0.001,0.0084/
      DATA EXX /180.0,140.0,90.0,80.0,20.0,200.0,-10.0,170.0,
     1 20.,0.0/

C     IIP = 0
c  check if there are defined sampling regions
crk      IF( REGSAMP) CALL REGION
      DO 10 J=1,10
C        EX(J) = EXX(J)
C Convert to radians here.        DR APR94
        EX(J) = RAD*EXX(J)
10    CONTINUE
      DO 100 I=1,20
C
           II=I
           IF(I.EQ.13.OR.I.EQ.6) GO TO 50
C
C     ALA-TYPE RESIDUE
C
                T=1.0-EPS
                DEL(1,II)=T
                DEL(2,II)=1.0/EPS
                DEL(3,II)=T*(1.0-P(1,II))
                DEL(4,II)=1.0/(T*(P(1,II)))
                S=T*(1.0-P(1,II)-P(2,II))
                DEL(5,II)=S
                DEL(6,II)=1.0/(T*P(2,II))
                DEL(7,II)=1.0/S
           GO TO 100
C
 50   IF(I.EQ.6) GO TO 70
C
C   PROLINE
C
           JJ=0
           DO 60 J=1,2
           JJ=JJ+1
           DEL(JJ,II)=P(J,II)
           JJ=JJ+1
           DEL(JJ,II)=1.0/(1.0-P(J,II))
           JJ=JJ+1
           DEL(JJ,II)=1.0/P(J,II)
 60        CONTINUE
           GO TO 100
C
C    GLYCINE
C
 70        T=1.0-EPS
           DEL(1,II)=T
           DEL(2,II)=1.0/EPS
           S=(1.0-P(1,II))*T
           DEL(3,II)=S
           DEL(4,II)=1.0/(T*P(1,II))
           DEL(5,II)=1.0/S
C
 100  CONTINUE
C
C
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION LPROLIN(I)
C true if residue  at position I is a proline or hydroxiproline.
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'

      LISTIJ=LIST(I)
      LISTIJ=IABS(LISTIJ)
      KINDIJ=IABS(KNDRES(LISTIJ))
      LPROLIN= (KINDIJ.EQ.13.OR.KINDIJ.EQ.22)
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION NMETHYL(I)
C true if residue  at position I is an nmethyl residue.
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'
      INCLUDE 'COMMON.PRAMX'

      LISTIJ=LIST(I)
      LISTIJ=IABS(LISTIJ)
C     KINDIJ=IABS(KNDRES(LISTIJ))
C     NMETHYL= (KINDIJ.GE.50.AND.KINDIJ.LE.80)
      NMETHYL= NMETRES(LISTIJ)
      RETURN
      END
C******************************************************************************
      LOGICAL FUNCTION LHISTID(I)
C true if residue  at position I is a histidine.
      INCLUDE 'PARAMET.ECEPP'
      INCLUDE 'COMMON.GEN100'
      INCLUDE 'COMMON.CHECK'

      LISTI=LIST(I)
      LISTI=IABS(LISTI)
      KINDI=IABS(KNDRES(LISTI))

      LHISTID= (KINDI.EQ.7 .OR. KINDI.EQ.26 .OR. KINDI.EQ.27)
      RETURN
      END
C******************************************************************************
      INTEGER FUNCTION ICANT(I,J)
      IF (I.GE.J) THEN
        ICANT=(I*(I-1))/2+J
      ELSE
        ICANT=(J*(J-1))/2+I
      ENDIF
      RETURN
      END
C******************************************************************************
